Package: pipeComp
Type: Package
Title: pipeComp pipeline benchmarking framework
Version: 1.22.0
Depends: R (>= 4.1)
Authors@R: c(
	person("Pierre-Luc", "Germain", email="pierre-luc.germain@hest.ethz.ch", role=c("cre","aut"), comment = c(ORCID = "0000-0003-3418-4218")), 
	person("Anthony", "Sonrel", email="anthony.sonrel@uzh.ch", role="aut", comment = c(ORCID = "0000-0002-2414-715X")), 
	person("Mark D.", "Robinson", email="mark.robinson@imls.uzh.ch", role=c("aut","fnd"), comment = c(ORCID = "0000-0002-3048-5518")) )
Description: A simple framework to facilitate the comparison of pipelines involving various steps and parameters. 
	The `pipelineDefinition` class represents pipelines as, minimally, a set of functions consecutively executed on 
	the output of the previous one, and optionally accompanied by step-wise evaluation and aggregation functions. 
	Given such an object, a set of alternative parameters/methods, and benchmark datasets, the `runPipeline` function 
	then proceeds through all combinations arguments, avoiding recomputing the same step twice and compiling evaluations 
	on the fly to avoid storing potentially large intermediate data.
Imports: BiocParallel, S4Vectors, ComplexHeatmap, SingleCellExperiment,
        SummarizedExperiment, Seurat, matrixStats, Matrix, cluster,
        aricode, methods, utils, dplyr, grid, scales, scran,
        viridisLite, clue, randomcoloR, ggplot2, cowplot,
        intrinsicDimension, scater, knitr, reshape2, stats, Rtsne,
        uwot, circlize, RColorBrewer
Suggests: BiocStyle, rmarkdown
License: GPL
Encoding: UTF-8
RoxygenNote: 7.1.1
VignetteBuilder: knitr
URL: https://doi.org/10.1186/s13059-020-02136-7
BugReports: https://github.com/plger/pipeComp
biocViews: GeneExpression, Transcriptomics, Clustering,
        DataRepresentation
git_url: https://git.bioconductor.org/packages/pipeComp
git_branch: RELEASE_3_23
git_last_commit: 843ce01
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.23
Date/Publication: 2026-04-28
NeedsCompilation: no
Packaged: 2026-04-28 23:53:52 UTC; biocbuild
Author: Pierre-Luc Germain [cre, aut] (ORCID:
    <https://orcid.org/0000-0003-3418-4218>),
  Anthony Sonrel [aut] (ORCID: <https://orcid.org/0000-0002-2414-715X>),
  Mark D. Robinson [aut, fnd] (ORCID:
    <https://orcid.org/0000-0002-3048-5518>)
Maintainer: Pierre-Luc Germain <pierre-luc.germain@hest.ethz.ch>

<img align="right" style="margin-left: 20px;" src="sticker.png"/>

# pipeComp

`pipeComp` is a simple framework to facilitate the comparison of pipelines involving various steps and parameters. It was initially developed to benchmark single-cell RNA sequencing pipelines:

_pipeComp, a general framework for the evaluation of computational pipelines, reveals performant single-cell RNA-seq preprocessing tools_<br/>
Pierre-Luc Germain, Anthony Sonrel & Mark D Robinson, _Genome Biology_ 2020, doi: [10.1186/s13059-020-02136-7](https://doi.org/10.1186/s13059-020-02136-7)

However the framework can be applied to any other context (see the `pipeComp_dea` vignette for an example). This readme provides an overview of the framework and package. For more detail, please refer to the two vignettes.

* [Introduction](#introduction)
  * [Recent changes](#recent-changes)
  * [Installation](#installation)
* [Using _pipeComp_](#using-pipecomp)
  * [PipelineDefinition](#pipelinedefinition)
  * [Running pipelines](#running-pipelines)
  * [Exploring the metrics](#exploring-the-metrics)
  * [Running a subset of combinations](#running-only-a-subset-of-the-combinations)

<br/><br/>

## Introduction

`pipeComp` is especially suited to the benchmarking of pipelines that include many steps/parameters, enabling the exploration of combinations of parameters and of the robustness of methods to various changes in other parts of a pipeline. It is also particularly suited to benchmarks across multiple datasets. It is entirely based on _R_/Bioconductor, meaning that methods outside of _R_ need to be called via _R_ wrappers. `pipeComp` handles multithreading in a way that minimizes re-computation and duplicated memory usage, and computes evaluation metrics on the fly to avoid saving many potentially large intermediate files, making it well-suited for benchmarks involving large datasets.

This readme gives a very brief overview of the package. For more detailed information on the framework, refer to the [pipeComp vignette](http://bioconductor.org/packages/devel/bioc/vignettes/pipeComp/inst/doc/pipeComp.html). For information specifically about the scRNAseq pipeline and evaluation metrics (as well as more complex examples usages of the plotting functions), see the [pipeComp_scRNA vignette](http://bioconductor.org/packages/devel/bioc/vignettes/pipeComp/inst/doc/pipeComp_scRNA.html). For a completely different example, with walkthrough the creating of a new `PipelineDefinition`, see the [pipeComp_dea vignette](http://bioconductor.org/packages/devel/bioc/vignettes/pipeComp/inst/doc/pipeComp_dea.html).

### Recent changes

* In `pipeComp` 0.99.43, there is now the possibility to continue runs despite errors (see the `skipErrors` argument of `runPipeline`, and the 'Handling errors' section of the [pipeComp vignette](http://bioconductor.org/packages/devel/bioc/vignettes/pipeComp/inst/doc/pipeComp.html).).

* In `pipeComp` 0.99.26 on, the plotting functions for the scRNAseq clustering pipeline (`scrna_evalPlot_DR` and `scrna_evalPlot_clust`) have been replaced by more flexible, pipeline-generic functions (`evalHeatmap`) and a silhouette-specific plotting function (`scrna_evalPlot_silh`). The general heatmap coloring scheme has also been changed to make meaningful changes clearer.

* In `pipeComp` 0.99.24, multithreading capacities have been extended (now virtually no limit).

* `pipeComp` >=0.99.3 made important changes to the format of the output, and greatly simplified the evaluation outputs for the scRNA pipeline.As a result, results produced with older version of the package are not anymore compatible with the current version's aggregation and plotting functions.


## Installation

Install using:

```{r}
BiocManager::install("plger/pipeComp", build_vignettes=TRUE)
```

Due to Bioconductor standards, `pipeComp` requires R>=4, but it is actually compatible with R>=3.6.1 (users who have not yet moved to R4 can use the [R3.6 branch](https://github.com/plger/pipeComp/tree/R3.6)).

Because `pipeComp` was meant as a general pipeline benchmarking framework, we have tried to restrict the package's dependencies to a minimum. To use the scRNA-seq pipeline and wrappers, however, requires further packages to be installed. To check whether these dependencies are met for a given `pipelineDefinition` and set of alternatives, see `?checkPipelinePackages`.

<br/><br/>

## Using _pipeComp_

<img src="inst/docs/pipeComp_scheme.png" width="500" alt="Scheme of the pipeComp framework" style="margin: 15px; float:left;"/>
<div style="text-align: justify;"><b>Scheme of the pipeComp framework. A:</b> The `PipelineDefinition` class represents pipelines as, minimally, a set of functions consecutively executed on the output of the previous one, and optionally accompanied by evaluation and aggregation functions. <b>B:</b> Given a `PipelineDefinition`, a set of alternative parameters and benchmark datasets, the `runPipeline` function proceeds through all combinations arguments, avoiding recomputing the same step twice and compiling evaluations on the fly.</div>


### PipelineDefinition

As represented in the figure above, the `PipelineDefinition` S4 class represents pipelines as, minimally, a set of functions (accepting any number of parameters)  consecutively executed on the output of the previous one, and optionally accompanied by evaluation and aggregation functions. As simple pipeline can be constructed as follows:

```{r}
my_pip <- PipelineDefinition( list( step1=function(x, param1){
                                      # do something with x and param1
                                      x
                                    },
                                    step2=function(x, method1, param2){
                                      get(method1)(x, param2)
                                    },
                                    step3=function(x, param3){
                                      x <- some_fancy_function(x, param3)
                                      # the functions can also output evaluation
                                      # through the `intermediate_return` slot:
                                      e <- my_evaluation_function(x)
                                      list( x=x, intermediate_return=e)
                                    }
                                  ))
```

The PipelineDefinition can also include descriptions of each step or evaluation and aggregation functions. For example:
```{r}
my_pip <- PipelineDefinition( list( step1=function(x, meth1){ get(meth1)(x) },
                                    step2=function(x, meth2){ get(meth2)(x) } ),
                              evaluation=list( step2=function(x){ sum(x) }) )
```


See the `?PipelineDefinition` for more information, or `scrna_pipeline` for a more complex example:

```{r}
pipDef <- scrna_pipeline()
pipDef
```
<pre><code>
A PipelineDefinition object with the following steps:
  - <b>doublet</b>(x, doubletmethod) *
<i>Takes a SCE object with the `phenoid` colData column, passes it through the </i>
<i>function `doubletmethod`, and outputs a filtered SCE.</i>
  - <b>filtering</b>(x, filt) *
<i>Takes a SCE object, passes it through the function `filt`, and outputs a </i>
<i>filtered Seurat object.</i>
  - <b>normalization</b>(x, norm)
<i>Passes the object through function `norm` to return the object with the </i>
<i>normalized and scale data slots filled.</i>
  - <b>selection</b>(x, sel, selnb)
<i>Returns a seurat object with the VariableFeatures filled with `selnb` features </i>
<i>using the function `sel`.</i>
  - <b>dimreduction</b>(x, dr, maxdim) *
<i>Returns a seurat object with the PCA reduction with up to `maxdim` components </i>
<i>using the `dr` function.</i>
  - <b>clustering</b>(x, clustmethod, dims, k, steps, resolution, min.size) *
<i>Uses function `clustmethod` to return a named vector of cell clusters.</i>
</code></pre>

#### Manipulating PipelineDefinition objects

A number of generic methods are implemented on the object, including `show`, `names`, `length`, `[`, `as.list`. This means that, for instance, a step can be removed from a pipeline in the following way:

```{r}
pd2 <- pipDef[-1]
```

Steps can also be added (using the `addPipelineStep` function) and edited - see the `pipeComp` vignette for more detail:

```{r}
vignette("pipeComp", package="pipeComp")
```

<br/><br/>

### Running pipelines

#### Preparing the other arguments

`runPipeline` requires 3 main arguments: i) the pipelineDefinition, ii) the list of alternative parameters values to try, and iii) the list of benchmark datasets.

The scRNAseq datasets used in the papers can be downloaded from [figshare](https://doi.org/10.6084/m9.figshare.11787210.v1) and prepared in the following way:

```{r}
download.file("https://ndownloader.figshare.com/articles/11787210/versions/1", "datasets.zip")
unzip("datasets.zip", exdir="datasets")
datasets <- list.files("datasets", pattern="SCE\\.rds", full.names=TRUE)
names(datasets) <- sapply(strsplit(basename(datasets),"\\."),FUN=function(x) x[1])
```

Next we prepare the alternative methods and parameters. Functions can be passed as arguments through their name (if they are loaded in the environment):

```{r}
# load alternative functions
source(system.file("extdata", "scrna_alternatives.R", package="pipeComp"))
# we build the list of alternatives
alternatives <- list(
  doubletmethod=c("none"),
  filt=c("filt.lenient", "filt.stringent"),
  norm=c("norm.seurat", "norm.sctransform", "norm.scran"),
  sel=c("sel.vst"),
  selnb=2000,
  dr=c("seurat.pca"),
  clustmethod=c("clust.seurat"),
  dims=c(10, 15, 20, 30),
  resolution=c(0.01, 0.1, 0.2, 0.3, 0.5, 0.8, 1, 1.2, 2)
)
```

#### Running the analyses

```{r}
res <- runPipeline( datasets, alternatives, pipDef, nthreads=3,
                    output.prefix="myfolder/" )
```

### Exploring the metrics

Data can be explored manually or plotted using generic or pipeline-specific functions. For example:

```{r}
scrna_evalPlot_silh( res )
```

<img src="inst/docs/silh.png"/>

```{r}
evalHeatmap( res, step="dimreduction", what2="meanAbsCorr.covariate2", 
             what=c("log10_total_features","log10_total_counts") )
```

<img src="inst/docs/dr.png"/>

The functions enable the choice of parameters at whose values to aggregate, 
as well as custom filtering:

```{r}
evalHeatmap(res, step = "clustering", what=c("MI","ARI"), agg.by=c("filt","norm")) +
  evalHeatmap(res, step = "clustering", what="ARI", agg.by=c("filt", "norm"),
              filter=n_clus==true.nbClusts, title="ARI at\ntrue k")
```

<img src="inst/docs/clust.png"/>

See the vignettes and the function's help for more details.

#' evalHeatmap
#' 
#' General heatmap representation of aggregated evaluation results. By default,
#' the actual metric values are printed in the cells, and while the coloring is
#' determined by \code{\link{colCenterScale}} (number of matrix-median absolute
#'  deviations from the column means). Unless the total number of analyses is
#'  small, it is strongly recommended to use the `agg.by` argument to limit the
#'  size and improve the readability of the heatmap.
#'
#' @param res Aggregated pipeline results (i.e. the output of `runPipeline` or
#' `aggregateResults`)
#' @param step Name of the step for which to plot the evaluation results. If 
#' unspecified, will use the latest step that has evaluation results.
#' @param what What metric to plot.
#' @param what2 If the step has more than one benchmark data.frame, which one
#' to use. The function will attempt to guess that automatically based on 
#' `what`, and will notify in case of ambiguity.
#' @param agg.by Aggregate results by these columns (default no aggregation)
#' @param agg.fn Function for aggregation (default mean)
#' @param filterExpr An optional filtering expression based on the columns of 
#' the target dataframe, (e.g. `filterExpr=param1=="value1"`).
#' @param scale Controls the scaling of the columns for the color mapping. Can 
#' either be a logical (TRUE will use NA-safe column z-scores, FALSE will not 
#' scale) or a function performing the scaling. The default uses the
#'  `colCenterScale` function (per-column centering, but per-matrix variance
#'  scaling).
#' @param value_format Format for displaying cells' values (use 
#' `value_format=""` to disable)
#' @param reorder_rows Logical; whether to sort rows (default FALSE). The row 
#' names themselves can also be passed to specify an order, or a 
#' `ComplexHeatmap`.
#' @param row_split Optional column (included in `agg.by`) by which to split
#' the rows. Alternatively, an expression using the columns (retained after
#' aggregation) can be passed.
#' @param show_heatmap_legend Passed to `Heatmap` (default FALSE)
#' @param show_column_names Passed to `Heatmap` (default FALSE)
#' @param col Colors for the heatmap, or a color-mapping function as produced by
#' `colorRamp2`. If passing a vector of colors and the data is scaled, there 
#' should be an odd number of colors. By default, will apply linear mapping (if
#' the data is not scaled) or signed sqrt mapping (if scaled) on the 
#' `viridisLite::inferno` palette.
#' @param font_factor A scaling factor applied to fontsizes (default 1)
#' @param value_cols A vector of length 2 indicating the colors of the values
#' (above and below the mean), if printed
#' @param title Plot title
#' @param shortNames Logical; whether to use short row names (with only
#' the parameter values instead of the parameter name and value pairs), default
#' TRUE.
#' @param name Heatmap name (e.g. used for the legend)
#' @param anno_legend Logical; whether to plot the legend for the datasets
#' @param ... Passed to `Heatmap`
#' 
#' @return A Heatmap
#' @export
#' @importFrom viridisLite inferno
#' @importFrom grid gpar
#' @import ComplexHeatmap
#' @examples
#' data("exampleResults", package="pipeComp")
#' evalHeatmap( exampleResults, step="clustering", what=c("ARI","MI","min_pr"), 
#'              agg.by=c("filt", "norm"), row_split = "norm" ) +
#' evalHeatmap( exampleResults, step="clustering", what="ARI", 
#'              agg.by=c("filt", "norm"), filterExpr=n_clus==true.nbClusts, 
#'              name="ARI at true k", title="ARI at
#' true K" )
evalHeatmap <- function( res, step=NULL, what, what2=NULL, agg.by=NULL, 
                         agg.fn=mean, filterExpr=NULL, scale="colCenterScale", 
                         value_format="%.2f", reorder_rows=FALSE, 
                         show_heatmap_legend=FALSE, show_column_names=FALSE, 
                         col=NULL, font_factor=0.9, 
                         row_split=NULL, shortNames=TRUE,
                         value_cols=c("black","white"), title=NULL, 
                         name=NULL, anno_legend=TRUE, ...){
  pd <- NULL
  if(is(res,"SimpleList")) pd <- metadata(res)$PipelineDefinition
  #if(is.null(pd)) stop("Could not find the PipelineDefinition.")
  if(is.null(step)){
    step <- rev(names(res$evaluation))[1]
    if(length(res$evaluation)>1) message("Using step '",step,"'.")
  }
  step <- match.arg(step, names(res$evaluation))
  if(length(what)>1){
    title <- lapply(seq_along(what), FUN=function(i){
      tryCatch( title[[i]], error=function(e) what[[i]] )
    })
    fcall <- match.call()
    H <- NULL
    for(i in seq_along(what)){
      fcall$what <- what[[i]]
      fcall$title <- title[[i]]
      H <- H + eval(fcall)
    }
    return(H)
  }
  if(is(res,"SimpleList") && "evaluation" %in% names(res)) res <- res$evaluation
  if(is(res,"list") && step %in% names(res)) res <- res[[step]]
  if(is(res,"list")){
    if(is.null(what2)){
      # try to guess the table
      test <- which(vapply( res, FUN=function(x) what %in% colnames(x), 
                            logical(1) ))
      if(length(test)==0) stop("`what2` is undefined and could not be guessed.")
      if(length(test)>1) message("`what2` is undefined, and `what` is present ",
        "in more than one results data.frame (",
        paste(paste0("`",names(res)[test],"`"), collapse=", "), "). ",
        names(res)[test[1]], "' will be used.")
      what2 <- names(res)[test[1]]
    }
    what2 <- match.arg(what2, names(res))
    res <- res[[what2]]
  }
  if(!is.null(pd)){
    what_options <- setdiff( colnames(res), 
                           c("dataset",unlist(arguments(pd))) )
    what <- match.arg(what, choices=what_options)
  }
  res <- .prepRes(res, what=what, agg.by=agg.by, pipDef=pd, 
                  filt=substitute(filterExpr), shortNames=shortNames, 
                  returnParams=TRUE)
  pp <- res$pp
  res <- res$res
  res2 <- .doscale(res, param=scale)
  ro <- .dosort(res2, reorder_rows)
  res2 <- as.matrix(res2)
  cellfn <- .getCellFn(res, res2, value_format, value_cols, font_factor, 
                       scaled=!(is.logical(scale) && !scale) )
  if(is.null(title)) title <- gsub("\\.","\n",what)
  suppressWarnings({
    if(!tryCatch(is.null(row_split), error=function(e) FALSE)){
      if(tryCatch(is.character(row_split), error=function(e) FALSE)){
        if(row_split %in% colnames(pp)){
          row_split <- pp[,row_split]
        }else{
          warning("`row_split` wasn't found and will be ignored.")
          row_split <- NULL
        }
      }else{
        row_split <- eval(substitute(row_split), envir=pp)
      }
    }
  })
  if(is.null(name)) name <- what
  if(is.null(col) || !is.function(col))
    col <- .defaultColorMapping(res2, center=!(is.logical(scale) && !scale),
                                cols=col)
  Heatmap( res2, name=name, cluster_rows=FALSE, cluster_columns=FALSE, 
           show_heatmap_legend=show_heatmap_legend, row_order=ro,
           bottom_annotation=.ds_anno(colnames(res),anno_legend,font_factor), 
           show_column_names=show_column_names, cell_fun=cellfn, col=col,
           column_title=title, row_split=row_split,
           row_title_gp = gpar(fontsize = (14*font_factor)),
           column_title_gp = gpar(fontsize = (14*font_factor)),
           row_names_gp = gpar(fontsize = (12*font_factor)),
           column_names_gp = gpar(fontsize = (12*font_factor)), ... )
}

.doscale <- function(res, param){
  if(is.null(param)) param <- colCenterScale
  if(is.logical(param) && !param) return(res)
  if(is.logical(param) && param) return(.safescale(res))
  if(is.function(param)) return(param(res))
  if(is.character(param) && is.function(get(param))) return(get(param)(res))
  warning("Unknown scaling parameter, will use column z-scores.")
  .safescale(res)
}

#' @import ComplexHeatmap
.dosort <- function(res, reorder_rows){
  if(is(reorder_rows, "Heatmap")){
    ro <- row_order(reorder_rows)
  }else{
    if(length(reorder_rows)>1){
      ro <- reorder_rows
    }else{
      if(reorder_rows){
        ro <- order(rowMeans(res, na.rm=TRUE), decreasing=TRUE)
      }else{
        ro <- seq_len(nrow(res))
      }
    }
  }
  if(!is.numeric(ro))
    ro <- vapply(ro, FUN=function(x) which(row.names(res)==x), integer(1))
  ro
}

# NA-robust scale
.safescale <- function(x){
  if(!is.null(dim(x))){
    y <- apply(x,2,.safescale)
    row.names(y) <- row.names(x)
    return(y)
  }
  if(all(is.na(x))) return(x)
  if(sd(x,na.rm=TRUE)>0) return(base::scale(x))
  if(sum(!is.na(x))==0) return(base::scale(as.numeric(!is.na(x))))
  rep(0,length(x))
}

.defaultColorMapping <- function(x, center=TRUE, cols=NULL){
  if(is.null(cols)) cols <- viridisLite::inferno(101)
  if(!center) return(cols)
  q <- max(abs(range(x, na.rm=TRUE)))
  b <- c( -seq(from=sqrt(q), to=0, length.out=floor(length(cols)/2)+1)^2,
          seq(from=0, to=sqrt(q), length.out=floor(length(cols)/2)+1)[-1]^2 )
  colorRamp2(b, cols)
}

#' colCenterScale
#'
#' Matrix scaling by centering columns separately and then performing variance 
#' scaling on the whole matrix, in a NA-robust fashion. With the default 
#' arguments, the output will be the number of (matrix-)median absolute 
#' deviations from the column-median.
#'
#' @param x A numeric matrix.
#' @param centerFn The function for calculating centers. Should accept the 
#' `na.rm` argument. E.g. `centerFn=mean` or `centerFn=median`.
#' @param scaleFn The function for calculating the (matrix-wise) scaling
#' factor. Should accept the `na.rm` argument. Default `median(abs(x))`.
#'
#' @return A scaled matrix of the same dimensions as `x`.
#' @export
#'
#' @examples
#' # random data with column mean differences
#' d <- cbind(A=rnorm(5, 10, 2), B=rnorm(5, 20, 2), C=rnorm(5,30, 2))
#' colCenterScale(d)
colCenterScale <- function(x, centerFn=median, 
                           scaleFn=function(x,na.rm) median(abs(x),na.rm=na.rm)
                           ){
  if(is.null(dim(x))) stop("`x` should be a numeric matrix or data.frame.")
  centers <- apply(x, MARGIN=2, na.rm=TRUE, FUN=centerFn)
  x2 <- t(t(x)-centers)
  x2 <- x2/scaleFn(x2, na.rm=TRUE)
  if(all(is.na(x2))) x2[is.na(x2)] <- 0
  x2
}

#' @importFrom ComplexHeatmap HeatmapAnnotation
.ds_anno <- function(x, legend=TRUE, font_factor=1){
  y <- vapply( strsplit(gsub("stepElapsed\\.","",x)," "),
               FUN=function(x) x[[1]], FUN.VALUE=character(1))
  cols <- getQualitativePalette(length(unique(y)))
  names(cols) <- sort(unique(y))
  HeatmapAnnotation(dataset=y, col=list(dataset=cols), 
                    annotation_legend_param=list(
                      labels_gp=gpar(fontsize=10*font_factor),
                      title_gp=gpar(fontsize=10*font_factor, fontface = "bold")
                    ),
                    show_annotation_name = FALSE, show_legend=legend)
}

.prepRes <- function(res, what=NULL, agg.by=NULL, agg.fn=mean, pipDef=NULL, 
                     filt=NULL, long=FALSE, shortNames=FALSE, 
                     returnParams=FALSE){
  if(is.null(what) && !long) stop("`what` should be defined.")
  if(!is.null(filt) && filt!=TRUE){
    if(is.null(pipDef)) stop("Filtering requires providing a `pipDef`.")
    res <- res[which(eval(filt, res)),]
  }
  if(!is.null(agg.by)){
    agg.by2 <- c(agg.by, intersect(colnames(res),c("dataset","subpopulation")))
    if(is.null(what)){
      what <- colnames(res)[which(
        vapply(res, function(x) is.integer(x) | is.numeric(x), logical(1))
      )]
      what <- setdiff(what, agg.by)
    }
    res <- aggregate(res[,what,drop=FALSE], by=res[,agg.by2,drop=FALSE], 
                     FUN=agg.fn)
    pp <- res[,agg.by,drop=FALSE]
  }else{
    if(is.null(pipDef)) stop("Either `agg.by` or `pipDef` should be given.")
    pp <- res[,intersect(colnames(res), unlist(arguments(pipDef))),drop=FALSE]
  }
  pp$method <- res$method <- .getReducedNames(pp, short=shortNames)
  if(long) return(res)
  
  if("subpopulation" %in% colnames(res))
    res$dataset <- paste(res$dataset, res$subpopulation)
  r2 <- reshape2::dcast( res, method~dataset, value.var=what,  
                         drop=FALSE, fun.aggregate=agg.fn)
  pp <- pp[!duplicated(pp$method),,drop=FALSE]
  row.names(pp) <- pp$method
  row.names(r2) <- r2[,1]
  res <- as.matrix(r2[,-1,drop=FALSE])
  if(returnParams) return(list(res=res, pp=pp[row.names(res),,drop=FALSE]))
  res
}

.getReducedNames <- function(res, short=FALSE){
  if(is.character(res)) res <- parsePipNames(res)
  pp <- vapply(res, FUN=function(x) length(unique(x))>1, logical(1))
  pp <- res[,pp,drop=FALSE]
  if(!short && ncol(pp)>1){
    y <- apply(pp,1,FUN=function(x){
      x <- paste0(colnames(pp),"=",x)
      paste(x, collapse="; ")
    })
  }else{
    y <- apply(pp,1,collapse=" > ",FUN=paste)
  }
  y
}

#' @importFrom grid grid.text
.getCellFn  <- function( res, res2, value_format, cols=c("black","white"), 
                         font_factor=1, scaled=TRUE ){
  if(scaled){
    resmid <- median(res2, na.rm=TRUE)
  }else{
    resmid <- range(res2, na.rm=TRUE)
    resmid <- resmid[1]+(resmid[2]-resmid[1])/2
  }
  if(is.na(resmid)) resmid <- Inf
  function(j, i, x, y, width, height, fill){
    if(value_format=="" || is.null(value_format) || is.na(value_format))
      return(NULL)
    lab <- sprintf(value_format, res[i,j])
    if(!any(abs(res)>1, na.rm=TRUE)){
      lab <- gsub("^0\\.",".",lab)
      lab <- gsub("^-0\\.","-.",lab)
    } 
    lab <- gsub("^1.00$","1",lab)
    lab <- gsub("^.00$","0",lab)
    cols <- ifelse(res2[i,j]>=resmid,cols[1],cols[2])
    grid.text(lab, x, y, gp = gpar(fontsize = 10*font_factor, col=cols))
  }
}

.scaledLegend <- function(){
  ComplexHeatmap::Legend(
    col_fun=circlize::colorRamp2(seq(1,100), viridisLite::inferno(100)), 
    at=c(1,50,100), title="MADs", labels=c("worst","median","best"), 
    direction="horizontal" )
}

#_______________________________________________________________________________
# DATASET PREPARATION ----------------------------------------------------------


#' add_meta
#'
#' Adds standard metadata.
#'
#' @param ds An object of class `SingleCellExperiment`
#'
#' @return The `SingleCellExperiment` object with updated metadata.
add_meta <- function(ds){
  library(scater)
  library(Matrix)
  data("ctrlgenes", package = "pipeComp")
  ## detect if row.names contain ensembl ids:
  if(any(grepl("^ENSG|^ENSMUSG",head(row.names(ds),n=100)))){
    ## we assume ^ENSEMBL\.whatever rownames
    cg <- lapply(c("Mt", "coding", "ribo"), FUN=function(x){
      union(ctrlgenes[[1]]$ensembl[[x]], ctrlgenes[[2]]$ensembl[[x]])
    })
    g <- sapply(strsplit(row.names(ds),".",fixed=TRUE),FUN=function(x) x[[1]])
  }else{
    # we assume HGNC/MGI symbols
    g <- row.names(ds)
    cg <- lapply(c("Mt", "coding", "ribo"), FUN=function(x){
      union(ctrlgenes[[1]]$symbols[[x]], ctrlgenes[[2]]$symbols[[x]])
    })
  }
  fc <- lapply(cg,g=g, FUN=function(x,g) g %in% x)
  names(fc) <- c("Mt","coding","ribosomal")
  if(exists("addQCPerCell")){
    ds <- addQCPerCell(ds, subsets=fc, percent_top=c(20,50,100,200))
  }else{
    ds <- addPerCellQC(ds, subsets=fc, percent_top=c(20,50,100,200))
  }
  ds$total_features <- ds$detected
  ds$log10_total_features <- log10(ds$detected)
  ds$total_counts <- ds$sum
  ds$log10_total_counts <- log10(ds$sum+1)
  ds$featcount_ratio <- ds$log10_total_counts/ds$log10_total_features
  ds$featcount_dist <- getFeatCountDist(ds)
  ds$pct_counts_top_20_features <- colData(ds)[[intersect(c("percent_top_20","pct_counts_in_top_20_features","percent.top_20"), colnames(colData(ds)))[[1]]]]
  ds$pct_counts_top_50_features <- colData(ds)[[intersect(c("percent_top_50","pct_counts_in_top_50_features","percent.top_50"), colnames(colData(ds)))[[1]]]]
  for(f in names(fc)) 
    ds[[paste0("pct_",f)]] <- ds[[intersect(c(paste0("subsets_",f,"_percent"),paste0("pct_",f)), colnames(colData(ds)))[[1]] ]]
  ds
}

#' getFeatCountDist
#' 
#' Returns the difference to the expected ratio of counts and number of features.
#'
#' @param df a cell metadata data.frame, or an object of class `SingleCellExperiment`
#' @param do.plot Logical; whether to plot the count/feature relationship.
#' @param linear Logical; whether to model the relationship with a linear model (default 
#' TRUE), rather than a loess.
#'
#' @return A vector of differences.
getFeatCountDist <- function(df, do.plot=FALSE, linear=TRUE){
  if(is(df,"SingleCellExperiment")) df <- as.data.frame(colData(df))
  if(linear){
    mod <- lm(df$log10_total_features~df$log10_total_counts)
  }else{
    mod <- loess(df$log10_total_features~df$log10_total_counts)
  }
  pred <- predict(mod, newdata=data.frame(log10_total_counts=df$log10_total_counts))
  df$diff <- df$log10_total_features - pred
  if(do.plot){
    library(ggplot2)
    ggplot(df, aes(x=total_counts, y=total_features, colour=diff)) + 
      geom_point() + geom_smooth(method = "loess", col="black")
  }
  df$diff
}


#' compute_all_gene_info
#' 
#' Populates the rowData of a SCE with various measures of variability, as well as the 
#' proportion of variance explained by clusters.
#'
#' @param sce An object of class `SingleCellExperiment`.
#'
#' @return The updated object.
compute_all_gene_info <- function(sce){
  library(variancePartition)
  library(sctransform)
  library(Seurat)
  cd <- as.data.frame(colData(sce))[,c("phenoid"),drop=FALSE]
  en <- log(t(1000*t(1+counts(sce))/colSums(counts(sce))))
  vp1 <- fitExtractVarPartModel(en, ~phenoid, data=cd)
  vst.out <- vst(counts(sce), colData(sce))
  vste <- vst.out$y+min(vst.out$y)
  vp2 <- fitExtractVarPartModel(vste,~phenoid, data=cd)
  vp <- data.frame(row.names=row.names(vp1), lognorm.varExp=vp1[,1], vst.varExp=vp2[row.names(vp1),1])
  source(system.file("extdata", "willtownes_scrna2019_utils.R", package="pipeComp"))
  gi <- compute_gene_info(counts(sce),gmeta=rowData(sce),mod="poisson")
  vp$deviance <- gi[row.names(vp),"deviance"]
  vp$total_counts <- gi[row.names(vp),"total_counts"]
  se <- .seuratFeatureVariability(sce, vst.out=vst.out)
  colnames(se) <- paste("seurat",colnames(se),sep=".")
  vp <- cbind(vp, se[row.names(vp),])
  RD <- as.data.frame(rowData(sce))
  RD <- RD[,setdiff(colnames(RD), colnames(vp))]
  rowData(sce) <- cbind(RD, vp[row.names(RD),])
  sce
}

.seuratFeatureVariability <- function(sce, vst.out=NULL){
  library(Seurat)
  library(SingleCellExperiment)
  seurat <- CreateSeuratObject( counts(sce), min.cells=0, min.features=0, 
                                project="scRNAseq" )
  seurat <- NormalizeData(seurat, display.progress=FALSE)
  seurat <- ScaleData(seurat, display.progress=FALSE)
  seurat <- FindVariableFeatures(seurat, selection.method="dispersion",
                                 nfeatures=nrow(seurat), display.progress=FALSE)
  seurat <- FindVariableFeatures(seurat, selection.method="vst",
                                 nfeatures=nrow(seurat), display.progress=FALSE)
  mf <- seurat@assays$RNA@meta.features
  if(is.null(vst.out)){
    library(sctransform)
    vst.out <- vst(counts(sce))
  }
  rv <- Seurat:::RowVar(vst.out$y)
  names(rv) <- row.names(vst.out$y)
  mf$res.var <- rv[row.names(mf)]
  mf
}


#' getDevianceExplained
#'
#' @param sce An object of class `SingleCellExperiment`
#' @param form.full The formula for the full model
#' @param form.null The formula for the reduced model (default `~lszie`, i.e. library size)
#' @param tagwise Logical; whether to run tagwise dispersion.
#'
#' @return The proportion of deviance (in the reduced model) explained by the full model.
#' @export
getDevianceExplained <- function(sce, form.full=~lsize+phenoid, form.null=~lsize, tagwise=TRUE){
  library(edgeR)
  sce$lsize <- log(colSums(counts(sce)))
  dds <- DGEList(as.matrix(counts(sce)))
  dds$samples$lib.size <- 1
  CD <- as.data.frame(colData(sce))
  mm <- model.matrix(form.full, data=CD)
  mm0 <- model.matrix(form.null, data=CD)
  dds <- estimateDisp(dds, mm, tagwise=tagwise)
  fit <- glmFit(dds, mm)
  fit0 <- glmFit(dds, mm0)
  de <- (deviance(fit0)-deviance(fit))/deviance(fit0)
  de[which(de<0)] <- 0
  return( de )
}



#_______________________________________________________________________________
# MISC WRAPPER -----------------------------------------------------------------

scrna_seurat_defAlternatives <- function(x=list()){
  def <- list(
    filt="filt.lenient",
    norm=c("norm.seurat","norm.scran.noscale","norm.scran"),
    sel="sel.vst", selnb=2000,
    dr="seurat.pca", maxdim=30, clustmethod="clust.seurat",
    dims = 10, k = 20, steps = 8, 
    resolution = c(0.01, 0.1, 0.5, 0.8, 1), 
    min.size = 50 )
  for(f in names(x)) def[[f]] <- x[[f]]
  def
}

none <- function(x) x


#_______________________________________________________________________________
# FILTERING  -------------------------------------------------------------------

#' filt.mad
#' 
#' Filter cells on the basis of MADs.
#'
#' @param x An object of class `SingleCellExperiment`
#' @param nmads The number of MADs above/below which to filter out (default 3)
#' @param min.cells The minimum number of cells expressing a feature (default 10) to keep
#' the feature.
#' @param min.features The minimum number of features detected in a cell (default 100) to 
#' keep the cell.
#' @param vars A named vector of control variables on which to check for deviations, in 
#' the form `variable=direction`.
#' @param outlier.times The number of times a cell should be an outlier for it to be 
#' excluded.
#'
#' @return A Seurat object.
#' @export
filt.mad <- function(x, nmads=3, min.cells=10, min.features=100,
                     vars=c( "pct_mt"="higher", 
                             "log10_total_features"="both", 
                             "log10_total_counts"="both", 
                             "pct_counts_top_50_features"="higher"
                     ),
                     outlier.times=1
){
  vars <- vars[names(vars) %in% colnames(colData(x))]
  if(length(vars)==0){
    return( x[Matrix::rowSums(counts(x) > 0) >= min.cells,
              Matrix::colSums(counts(x) > 0) >= min.features] )
  } 
  out <- unlist(lapply(names(vars), o=x, v=vars, nm=nmads, FUN=function(x,o,v,nm){
    tryCatch(
      which(isOutlier(o[[x]], 
                      nmads=nm, 
                      log=FALSE, 
                      type=v[[x]]
      )),
      error=function(e){ 
        warning(e)
        return(c())
      }
    )
  }))
  if(length(out)>0){
    out <- table(out)
    out <- as.numeric(names(out)[which(out>=outlier.times)])
    if(length(out)>0) x <- x[,-out]    
  }
  x[Matrix::rowSums(counts(x) > 0) >= min.cells,
    Matrix::colSums(counts(x) > 0) >= min.features]
}

#' applyFilterString
#'
#' @param sce A SingleCellExperiment object.
#' @param filterstring A filtering string.
#'
#' @return A Seurat object.
#' @export
applyFilterString <- function(sce, filterstring){
  x <- strsplit(filterstring,"_",fixed=TRUE)[[1]]
  mads <- as.numeric(x[[2]])
  vars <- .translateFilterVars(strsplit(x,",",fixed=TRUE)[[1]])
  otimes <- ifelse(is.null(x[[3]]),1,as.numeric(x[[3]]))
  filt.mad(sce, nmads=mads, vars=vars, outlier.times=otimes)
}


filt.lenient <- function(x){  
  suppressPackageStartupMessages(library(scater))
  if(!("featcount_dist" %in% colnames(colData(x)))) x <- add_meta(x)
  filters <- c( "log10_total_counts:both:5",
                "log10_total_features:both:5",
                "pct_counts_in_top_20_features:both:5",
                "featcount_dist:both:5")
  out <- lapply(strsplit(filters,":"), FUN=function(f){
    which(isOutlier(x[[f[1]]], log=FALSE,
                    nmads=as.numeric(f[3]), 
                    type=f[2] ))
  })
  mtout <- isOutlier(x$pct_counts_Mt, nmads=3, type="lower" ) | 
    (isOutlier(x$pct_counts_Mt, nmads=3, type="higher" ) & x$pct_counts_Mt > 0.08)
  out <- c(out, list(mt=which(mtout)))
  out <- table(unlist(out))
  out <- as.numeric(names(out)[which(out>=2)])
  if(length(out)>0) x <- x[,-out]
  x[Matrix::rowSums(counts(x) > 0) >= 10, Matrix::colSums(counts(x) > 0) >= 0]
}

filt.default <- function(x, times=2){ 
  suppressPackageStartupMessages(library(scater))
  if(!("featcount_dist" %in% colnames(colData(x)))) x <- add_meta(x)
  filters <- c( "log10_total_counts:higher:2.5",
                "log10_total_counts:lower:5",
                "log10_total_features:higher:2.5",
                "log10_total_features:lower:5",
                "pct_counts_in_top_20_features:both:5",
                "featcount_dist:both:5")
  out <- lapply(strsplit(filters,":"), FUN=function(f){
    which(isOutlier(x[[f[1]]], log=FALSE,
                    nmads=as.numeric(f[3]), 
                    type=f[2] ))
  })
  mtout <- isOutlier(x$pct_counts_Mt, nmads=3, type="lower" ) | 
    (isOutlier(x$pct_counts_Mt, nmads=2.5, type="higher" ) & x$pct_counts_Mt > 0.08)
  out <- c(out, list(mt=which(mtout)))
  out <- table(unlist(out))
  out <- as.numeric(names(out)[which(out>=times)])
  if(length(out)>0) x <- x[,-out]
  x[Matrix::rowSums(counts(x) > 0) >= 10, Matrix::colSums(counts(x) > 0) >= 0]
}

filt.stringent <- function(x){
  filt.default(x,1)
}

.translateFilterVars <- function(x){
  vars=c(  "mt"="pct_counts_Mt", 
           "feat"="total_features",
           "counts"="total_counts",
           "lfeat"="log10_total_features", 
           "lcounts"="log10_total_counts", 
           "top50"="pct_counts_in_top_50_features",
           "ratiodist"="featcount_dist"
  )
  x <- strsplit(x,".",fixed=TRUE)
  y <- sapply(x,FUN=function(x){ if(length(x)==1) return("both"); x[[2]] })
  names(y) <- sapply(x,vars=vars,FUN=function(x, vars) vars[x[[1]]])
  y
}

filt.pca <- function(x, vars=NULL){ 
  suppressPackageStartupMessages(library(scater))
  x <- runPCA(x, use_coldata=TRUE, detect_outliers=TRUE, selected_variables=vars)
  x[Matrix::rowSums(counts(x) > 0) >= 10,!x$outlier]
}

filt.pca2 <- function(x){
  filt.pca(x, vars=c("log10_total_counts", "log10_total_features", "pct_counts_Mt", "pct_counts_in_top_50_features"))
}


#_______________________________________________________________________________
# NORMALIZATION  ---------------------------------------------------------------

norm.seurat <- function(dat, vars=NULL, noscale=FALSE){
  suppressPackageStartupMessages(library(Seurat))
  if (!is(dat, "Seurat")) {
    x <- seWrap(dat)
  } else {
    x <- dat
  }
  x <- NormalizeData(x, verbose=FALSE)
  if(noscale){
    x <- SetAssayData(x, slot="scale.data", as.matrix(GetAssayData(x)))
  }else{
    if(is.null(vars)) vars <- c()
    for(f in vars){
      if(!(sd(x[[]][[f]])>0)) vars <- setdiff(vars,f)
    }
    if(length(vars)==0) vars <- NULL
    x <- ScaleData(x, verbose=FALSE, vars.to.regress=vars)
  }
  if (is(dat, "Seurat")){
    return(x)
  } else {
    dat <- dat[row.names(x),]
    logcounts(dat) <- GetAssayData(x, assay = "RNA", slot = "scale.data")
    return(dat) 
  }
}

norm.scran <- function(x, vars=NULL, noscale=TRUE, min.mean=1){
  suppressPackageStartupMessages({
    library(scran)
    library(Seurat)
    library(SingleCellExperiment)
  })
  if(is(x,"Seurat")){
    a <- GetAssayData(x, assay = "RNA", slot = "counts")
  }else{
    a <- counts(x)
  }
  a <- SingleCellExperiment(assays=list(counts=a))
  clusters <- quickCluster(a, min.mean=min.mean, min.size=50)
  a <- computeSumFactors(a, min.mean=min.mean, clusters=clusters)
  if(is.null(logNormCounts)){
    a <- scater::normalize(a)
  }else{
    a <- logNormCounts(a)
  }
  if(is(x,"Seurat")){ 
    x <- SetAssayData(x, slot="data", new.data=logcounts(a))
    if(noscale){
      x <- SetAssayData(x, slot="scale.data", as.matrix(GetAssayData(x)))
    }else{
      x <- ScaleData(x, verbose=FALSE, vars.to.regress=vars)
    }
  }else{
    if(!noscale) a <- t(scale(t(logcounts(a)))) else a <- logcounts(a)
    logcounts(x) <- a
  }
  x
}
norm.scran.scaled <- function(x, ...){
  norm.scran(x, noscale=FALSE, ...)
}

norm.none <- function(x, vars=NULL, noscale=TRUE){
  if(is(x,"Seurat")){
    a <- GetAssayData(x, slot="counts")
  }else{
    a <- counts(x)
  }
  a <- log1p(a)
  if(is(x,"Seurat")){
    x <- SetAssayData(x, slot="data", a)
    if(noscale){
      x <- SetAssayData(x, slot="scale.data", as.matrix(GetAssayData(x)))
    }else{
      x <- ScaleData(x, verbose=FALSE, vars.to.regress=vars)
    }
  } else {
    if(!noscale) a <- t(scale(t(a)))
    logcounts(x) <- a
  }
  x
}
norm.none.scaled <- function(x){
  norm.none(x, noscale=FALSE)
}

#' norm.seuratvst
#'
#' A wrapper around `sctransform` variance stabilizing transformation. 
#' 
#' @param x A Seurat/ SCE object.
#' @param vars A vector of variables to regress when scaling (default none)
#' @param noscale Ignored.
#' @param variable.features.n Passed to `SCTransform`, default 5000
#'
#' @return A Seurat/ SCE object with updated data slot.
norm.seuratvst <- function(x, vars=NULL, noscale=FALSE, variable.features.n=5000){
  if(!is(x,"Seurat")){
    a <- seWrap(x)
  }else{
    a <- x
  }
  a <- SetAssayData(a, slot="counts", new.data=round(GetAssayData(a,slot="counts")))
  suppressPackageStartupMessages(library(sctransform))
  a <- SCTransform(a, vars.to.regress=vars, verbose=FALSE, 
                   variable.features.n=variable.features.n, 
                   return.only.var.genes=FALSE)
  a@misc$vst.var.feat <- VariableFeatures(a)
  if(is(x,"Seurat")) return(a)
  metadata(x)$vst.var.feat <- metadata(x)$VariableFeats <- VariableFeatures(a)
  logcounts(x) <- GetAssayData(a, "data", "SCT")
  x
}
norm.sctransform <- norm.seuratvst


#' norm.scnorm
#'
#' A wrapper around `SCnorm` normalization.
#' 
#' @param x A SCE or Seurat object.
#' @param vars A vector of variables to regress when scaling (default none). Ignored if `noscale`.
#' @param noscale Logical; whether to disable scaling (default FALSE)
#'
#' @return An object of the same class as `x` with updated slots.
norm.scnorm <- function(x, vars=NULL, noscale=TRUE, nthreads=1){
  suppressPackageStartupMessages(library(SCnorm))
  if(is(x,"Seurat")){
    a <- Seurat::GetAssayData(x, slot="counts")
    a <- SCnorm(a, rep("A",ncol(a)), NCores=nthreads)
    a <- log1p(assays(a)$normcounts)
    x <- SetAssayData(x, slot="data", new.data=a)
    if(noscale){
      x <- SetAssayData(x, slot="scale.data", as.matrix(GetAssayData(x)))
    }else{
      x <- ScaleData(x, verbose=FALSE, vars.to.regress=vars)
    }
    return(x)
  }
  a <- counts(x)
  a <- SCnorm(a, rep("A",ncol(a)), NCores=nthreads)
  a <- log1p(assays(a)$normcounts)
  if(!noscale) a <- t(scale(t(a)))
  logcounts(x) <- a
  x
}

norm.scnorm.scaled <- function(x, ...){
  norm.scnorm(x, noscale=FALSE, ...)
}

#' norm.scVI
#'
#' A function calling a python wrapper (`scVI.py`) around `scVI` normalization, adapted from the the 'Basic usage' Jupyter notebook (https://nbviewer.jupyter.org/github/YosefLab/scVI/blob/master/tests/notebooks/basic_tutorial.ipynb). Note that the function will create a temporary csv file for the intermediate storage of the input count matrix, needed by `scVI`.  
#' 
#' 
#' @param x A SCE or Seurat object.
#' @param py_script Location of the python script
#' @param py_path Optional. If scVI was installed in a specific python bin, pass here the path to it. 
#' @param train_size Size of training set. Default to 0.8 but tutorial however recommends to use 1. 
#' @param n_cores N. cores
#' 
#' @return An object of the same class as `x` with updated slots.

norm.scVI <- function(x, py_script = system.file("extdata", "scVI.py", package="pipeComp"), py_path = NULL, n_cores = 1L, train_size = 1) {
  n_cores <- as.integer(n_cores)
  suppressPackageStartupMessages(library(reticulate))
  if (length(py_path)>0) use_python(py_path ,required=TRUE)
  trysource <- try(source_python(py_script))
  if (class(trysource) == "try-error") stop("Cannot source the python wrapper.") 
  tfile <- tempfile(fileext=".csv", tmpdir = ".")
  if (is(x, "Seurat")) dat <- GetAssayData(x, assay = "RNA", slot = "counts") else dat <- counts(x)
  write.csv(dat, tfile)
  out <- scVI_norm(csv_file = tfile, csv_path = ".", n_cores = n_cores, 
                   train_size = train_size)
  val <- t(out[[1]])
  gnames <- as.character(out[[2]])
  file.remove(tfile)
  dimnames(val) <- list(gnames, colnames(dat))
  x <- x[gnames, ]
  if(is(x,"Seurat")){ 
    x <- SetAssayData(x, slot="data", new.data=as.matrix(val))
    x <- SetAssayData(x, slot="scale.data", as.matrix(val))
  }else{
    logcounts(x) <- as.matrix(val)
  }
  x
}


# ______________________________________________________________________________
# FEATURE SELECTION ------------------------------------------------------------

#' subsetFeatureByType
#'
#' @param g A vector of gene names, either official gene symbols or ensembl stable IDs (or
#'  `ensemblgid.symbol`). Currently only mouse or human supported.
#' @param classes A vector classes to filter.
#'
#' @return A filtered vector of gene names.
#' 
#' @export
subsetFeatureByType <- function(g, classes=c("Mt","conding","ribo")){
  if(length(classes)==0) return(g)
  classes <- match.arg(gsub("ribosomal","ribo",classes), c("Mt","coding","ribo"), several.ok=TRUE)
  data("ctrlgenes", package="pipeComp")
  go <- g
  if(any(grepl("^ENSG|^ENSMUSG",head(g,n=100)))){
    ## we assume ^ENSEMBL\.whatever rownames
    cg <- lapply(classes, FUN=function(x){ union(ctrlgenes[[1]]$ensembl[[x]], ctrlgenes[[2]]$ensembl[[x]]) })
    g <- sapply(strsplit(g,".",fixed=TRUE),FUN=function(x) x[[1]])
  }else{
    # we assume HGNC/MGI symbols
    cg <- lapply(classes, FUN=function(x){ union(ctrlgenes[[1]]$symbols[[x]], ctrlgenes[[2]]$symbols[[x]]) })
  }
  names(cg) <- classes
  if("coding" %in% classes){
    w <- which(g %in% cg$coding)
    go <- go[w]
    g <- g[w]
    cg <- cg[which(names(cg) != "coding")]
  }
  go[which(!(g %in% unlist(cg)))]
}

sel.vst <- function(dat, n=2000, excl=c()){
  if(!is(dat,"Seurat")){
    a <- seWrap(dat)
  } else a <- dat
  if(!is.null(a@misc$vst.var.feat)){
    VariableFeatures(a) <- a@misc$vst.var.feat[1:min(n,length(a@misc$vst.var.feat))]
  }else{
    a <- FindVariableFeatures(a, nfeatures=n)
  }
  VariableFeatures(a) <- subsetFeatureByType(VariableFeatures(a), excl)
  if(is(dat,"Seurat")) return(a)
  metadata(dat)$VariableFeats <- VariableFeatures(a)
  dat
}

#' applySelString
#' 
#' Applies a given selection string.
#'
#' @param se A Seurat or SCE object.
#' @param selstring A rowData variable to use, or a selection string, e.g. 'vst:2000:coding_rmMt_rmribo'.
#' @param n The number of genes to select (ignored if selstring is a full selection string).
#'
#' @return A filtered Seurat or SCE object.
#' @export
applySelString <- function(dat, selstring, n=2000){
  #vst:2000:coding_rmMt_rmribo
  x <- strsplit(selstring,":",fixed=TRUE)[[1]]
  excl <- c()
  if(length(x)>2 && x[3]!="") excl <- gsub("rm","",strsplit(x[3], "_")[[1]])
  fn <- paste0("sel.",x[1])
  if(exists(x[2])) n <- as.numeric(x[2])
  if(exists(fn) && is.function(get(fn))) return(get(fn)(dat, n=n, excl=excl))
  sel.fromField(dat, x[1], n, excl)
}

#' sel.fromField
#' 
#' Selection of features based on a given rowData field (in decreasing order).
#'
#' @param dat A `Seurat` object.
#' @param f The field to use.
#' @param n The number of features to select (default 2000)
#' @param excl Feature types to exclude (default none)
#'
#' @return A `Seurat` object with updated `VariableFeatures`
#' @export
sel.fromField <- function( dat, f, n=2000, excl=c() ){
  if(is(dat, "Seurat")) {
    if(is.null(dat@misc$rowData[[f]])) return(NULL)
    a <- dat
  } else {
    if(is.null(rowData(dat)[[f]])) return(NULL)
    a <- seWrap(dat)
    a@misc$rowData <- as.data.frame(rowData(dat))
  }
  e <- a@misc$rowData
  if(is(e,"list")) e <- as.data.frame(e)
  e <- e[row.names(a),f]
  VariableFeatures(a) <- row.names(a)[order(e, decreasing=TRUE)[1:min(n,length(e))]]
  VariableFeatures(a) <- subsetFeatureByType(VariableFeatures(a), excl)
  if(is(dat, "Seurat")) return(a)
  metadata(dat)$VariableFeats <- VariableFeatures(a)
  dat
}

sel.deviance <- function(x, n=2000, excl=c()){
  sel.fromField(x, "deviance", n=n, excl=excl)
}
sel.expr <- function(x, n=2000, excl=c()){
  sel.fromField(x, "total_counts", n=n, excl=excl)
}


#_______________________________________________________________________________
# DIMENSION REDUCTION ----------------------------------------------------------


seurat.pca <- function(x, dims=50, weight.by.var=TRUE, seed.use=42){
  if(is(x, "Seurat")){
    dat <- x
  } else {
    dat <- seWrap(x)
  }
  dat <- RunPCA(dat, features=VariableFeatures(dat), verbose=FALSE, 
                 weight.by.var=weight.by.var, npcs=dims, seed.use = seed.use)
  if(is(x, "Seurat")){
    dat
  } else {
    reducedDim(x, "PCA") <- Reductions(dat, "pca")@cell.embeddings
    x
  }
}

seurat.pca.noweight <- function(x, dims=50, weight.by.var=FALSE, seed.use=42){
  if(is(x, "Seurat")){
    dat <- x
  } else {
    dat <- seWrap(x)
  }
  dat <- RunPCA(dat, features=VariableFeatures(dat), verbose=FALSE, 
                weight.by.var=weight.by.var, npcs=dims, seed.use = seed.use)
  if(is(x, "Seurat")){
    dat
  } else {
    reducedDim(x, "PCA") <- Reductions(dat, "pca")@cell.embeddings
    x
  }
}

scran.denoisePCA <- function(x, dims=50, pca.method=c("exact","irlba"), ...){
  suppressPackageStartupMessages(library(scran))
  suppressPackageStartupMessages(library(BiocSingular))
  BSPARAM <- switch(match.arg(pca.method),
                    exact=ExactParam(),
                    irlba=IrlbaParam() )
  if(is(x, "Seurat")){
    dat <- sceWrap(x)
  } else {
    dat <- x
  }
  lcmin <- min(logcounts(dat))
  if(lcmin<0) logcounts(dat) <- logcounts(dat) - lcmin
  if(packageVersion("scran") >= "1.13"){
    var.stats <- modelGeneVar(dat)
    dat <- denoisePCA(dat, technical=var.stats, min.rank=2, max.rank=dims, 
                      subset.row=metadata(dat)$VariableFeats, BSPARAM=BSPARAM, 
                      ...)
  }else{
    td <- trendVar(dat, use.spikes=FALSE)
    dat <- denoisePCA(dat, technical=td$trend, min.rank=2, max.rank=dims, 
                      subset.row=metadata(dat)$VariableFeats, BSPARAM=BSPARAM, 
                      ...)
  }
  if(is(x, "Seurat")) return(sceDR2seurat(reducedDim(dat, "PCA"), x, "pca")) else return(dat)
}

GlmPCA <- function(x, weight.by.var=TRUE, dims=20){
  suppressPackageStartupMessages(library(glmpca))
  if(is(x, "Seurat")){
    dat <- x
  } else {
    dat <- seWrap(x)
  }
  dr <- glmpca(as.matrix(GetAssayData(dat, assay = "RNA", slot = "counts")[VariableFeatures(dat),]), dims)
  e <- as.matrix(dr$factors)
  colnames(e) <- gsub("dim","dim_",colnames(e))
  colnames(e) <- gsub("dim_", "PC_", colnames(e))
  if(weight.by.var=="both" && length(dr$dev) %in% dim(e)){
    if(is(x, "Seurat")) {
      x[["glmpca"]] <- CreateDimReducObject(embeddings=e, key="PC_", assay="RNA")
      e <- t(t(e)*dr$d)
      x[["glmpca.wt"]] <- CreateDimReducObject(embeddings=e, key="PC_", assay="RNA")
    } else {
      reducedDim(x, "glmpca") <- e
      e <- t(t(e)*dr$d)
      reducedDim(x, "glmpca.wt") <- e
    }
  }else{
    if(weight.by.var && length(dr$dev) %in% dim(e)) e <- t(t(e)*dr$d)
    if(is(x, "Seurat")){
      x[["pca"]] <- CreateDimReducObject(embeddings=e, key="PC_", assay="RNA")
    } else {
      reducedDim(x, "PCA") <- e
    }
  }
  x
}
GlmPCA.noweight <- function(x, ...){
  GlmPCA(x, weight.by.var=FALSE, ...)
}

scran.runPCA <- function(x, dims=50){
  suppressPackageStartupMessages(library(scran))
  suppressPackageStartupMessages(library(BiocSingular))
  if(is(x, "Seurat")){
    dat <-  sceWrap(x)
  } else {
    dat <- x
  }
  dat <- scater::runPCA(dat, ncomponents = dims, 
                        subset_row=metadata(dat)$VariableFeats)
  if(is(x, "Seurat")) return(sceDR2seurat(reducedDim(dat, "PCA"), x, "pca")) else return(dat)
}

#' scVI.latent
#'
#' A function calling a python wrapper (`scVI.py`) around `scVI` low-dimensional latent space, adapted from the official tutorial (https://scvi.readthedocs.io/en/stable/tutorials/basic_tutorial.html). Note that the function will create a temporary csv file for the intermediate storage of the input count matrix, needed by `scVI`.  
#' 
#' 
#' @param x A SCE or Seurat object.
#' @param py_script Location of the python script
#' @param py_path Optional. If scVI was installed in a specific python bin, pass here the path to it. 
#' @param dims Number of dimensions to return. 
#' @param learning_rate Learning rate of the model. If the model is not training properly due to too high learning rate, it will be reduced consecutively a few times before early stop. 
#' @param n_cores N. cores
#' 
#' @return An object of the same class as `x` with updated slots. Note that scVI-LD initially returns unordered components. For convenience with the package, they are ordered by sdev and renamed 'PC'. 

scVI.latent <- function(x, dims = 50L, learning_rate = 1e-3, py_script = system.file("extdata", "scVI.py", package="pipeComp"), py_path = NULL, n_cores = 1L) {
  dims <- as.integer(dims)
  n_cores <- as.integer(n_cores)
  suppressPackageStartupMessages(library(reticulate))
  if (length(py_path)>0) use_python(py_path ,required=TRUE)
  trysource <- try(source_python(py_script))
  if (class(trysource) == "try-error") stop("Cannot source the python wrapper.") 
  tfile <- tempfile(fileext=".csv", tmpdir = ".")
  if (is(x, "Seurat")) {
    dat <- GetAssayData(x, assay = "RNA", slot = "counts")
    dat <- dat[VariableFeatures(x), ]
  } else {
    
    dat <- counts(x)
    dat <- dat[metadata(x)$VariableFeat, ]
  } 
  write.csv(dat, tfile)
  val <- try(scVI_latent(csv_file = tfile, csv_path = ".", n_cores = n_cores, lr = learning_rate))
  # Error with some dataset; "Loss was NaN 10 consecutive times: the model is not training properly. Consider using a lower learning rate" --> reduce lr
  if (class(val) == "try-error") {
    ntry <- 0
    while(ntry < 6 & class(val) == "try-error") {
      ntry <- ntry + 1
      learning_rate <- learning_rate/10
      message("Downgrading learning rate to ", learning_rate)
      val <- try(scVI_latent(csv_file = tfile, csv_path = ".", n_cores = n_cores, lr = learning_rate))
    }
  }
  file.remove(tfile)
  rownames(val) <- colnames(dat)
  # rename
  colnames(val) <- paste0("PC_", 1:ncol(val))
  if(is(x, "Seurat")){
    x[["pca"]] <- CreateDimReducObject(embeddings=as.matrix(val), 
                                       key="PC_", assay="RNA")
  } else {
    reducedDim(x, "PCA") <- as.matrix(val)
  }
  x
}


#' scVI.LD
#'
#' A function calling a python wrapper (`scVI.py`) around `scVI` linear decoded, adapted from the the 'Basic usage' Jupyter notebook (https://nbviewer.jupyter.org/github/YosefLab/scVI/blob/master/tests/notebooks/linear_decoder.ipynb). Note that the function will create a temporary csv file for the intermediate storage of the input count matrix, needed by `scVI`.  
#' 
#' 
#' @param x A SCE or Seurat object.
#' @param py_script Location of the python script
#' @param py_path Optional. If scVI was installed in a specific python bin, pass here the path to it. 
#' @param dims Number of dimensions to return. 
#' @param learning_rate Learning rate of the model. If the model is not training properly due to too high learning rate, it will be reduced consecutively a few times before early stop. 
#' @param n_cores N. cores
#' 
#' @return An object of the same class as `x` with updated slots. Note that scVI-LD initially returns unordered components. For convenience with the package, they are ordered by sdev and renamed 'PC'. 

scVI.LD <- function(x, dims = 50L, learning_rate = 1e-3, py_script = system.file("extdata", "scVI.py", package="pipeComp"), py_path = NULL, n_cores = 1L) {
  dims <- as.integer(dims)
  n_cores <- as.integer(n_cores)
  suppressPackageStartupMessages(library(reticulate))
  if (length(py_path)>0) use_python(py_path ,required=TRUE)
  trysource <- try(source_python(py_script))
  if (class(trysource) == "try-error") stop("Cannot source the python wrapper.") 
  tfile <- tempfile(fileext=".csv", tmpdir = ".")
  if (is(x, "Seurat")) {
    dat <- GetAssayData(x, assay = "RNA", slot = "counts")
    dat <- dat[VariableFeatures(x), ]
  } else {
    
    dat <- counts(x)
    dat <- dat[metadata(x)$VariableFeat, ]
  } 
  write.csv(dat, tfile)
  val <- try(scVI_ld(csv_file = tfile, ndims = dims, csv_path = ".", n_cores = n_cores, lr = learning_rate))
  # Error with some dataset; "Loss was NaN 10 consecutive times: the model is not training properly. Consider using a lower learning rate" --> reduce lr
  if (class(val) == "try-error") {
    ntry <- 0
    while(ntry < 6 & class(val) == "try-error") {
      ntry <- ntry + 1
      learning_rate <- learning_rate/10
      message("Downgrading learning rate to ", learning_rate)
      val <- try(scVI_ld(csv_file = tfile, ndims = dims, csv_path = ".", n_cores = n_cores, lr = learning_rate))
    }
  }
  file.remove(tfile)
  rownames(val) <- colnames(dat)
  # rename
  colnames(val) <- paste0("PC_", 1:ncol(val))
  if(is(x, "Seurat")){
    x[["pca"]] <- CreateDimReducObject(embeddings=as.matrix(val), 
                                       key="PC_", assay="RNA")
  } else {
    reducedDim(x, "PCA") <- as.matrix(val)
  }
  x
}



sceDR2seurat <- function(embeddings, object, name){
  if (is.null(rownames(embeddings))){
    rownames(embeddings) <- colnames(object)
  }
  key <- gsub(pattern = "[[:digit:]]", replacement = "_", 
              x = colnames(embeddings)[1])
  if (length(x = key) == 0) key <- paste0(name, "_")
  colnames(embeddings) <- paste0(key, 1:ncol(embeddings))
  object[[name]] <- CreateDimReducObject(embeddings = embeddings, key = key, 
                                         assay = DefaultAssay(object))
  object
}


FisherSeparability <- function(PCAdims, py_script = system.file("extdata", "FisherSeparability.py", package="pipeComp")) {
  if(is(PCAdims, "Seurat")){
    PCAdims <- PCAdims[["pca"]]@cell.embeddings
  } else if(is(PCAdims, "SingleCellExperiment")){
    PCAdims <- reducedDim(dat, "PCA")
  }
  # Adapted from https://github.com/auranic/FisherSeparabilityAnalysis
  suppressPackageStartupMessages(library(reticulate))
  suppressPackageStartupMessages(library(Seurat))
  trysource <- try(source_python(py_script))
  if (is(trysource, "try-error")) stop("Cannot source 'FisherSeparability.py'. Make sure:\n1) You are running reticulate and redirecting to a valid Python3 bin/conda (use_python, use_conda)\n2) You have the following modules installed: numpy, math, sklearn.decomposition, seaborn, warnings, scipy.special, matplotlib, scipy.io\n3) You have 'FisherSeparability.py' in your current wd") 
  # Saving to numpy for correct coercion 
  np <- import("numpy")
  tdir <- "tempnpy"
  tfile <- tempfile(fileext=".npy", tmpdir = tdir)
  dir.create(tdir, showWarnings = FALSE)
  np$save(tfile, as.matrix(PCAdims))
  val <- SeparabilityAnalysis(tfile, ProducePlots = TRUE)
  val <- as.numeric(val)
  unlink(tdir, recursive = TRUE)
  return(val)
}


js.wrapper <- function(dat, n.dims=NULL, n.rep=500, doplot=FALSE, ret=c("ndims", "Seurat", "sce","pvalues")){
  ret <- match.arg(ret)
  if (!is(dat, "Seurat")) x <- seWrap(dat) else x <- dat
  if(is.null(n.dims)) n.dims <- ncol(Reductions(x, "pca")@cell.embeddings)-1
  x <- JackStraw(x, dims = n.dims, num.replicate=n.rep, verbose=FALSE)
  x <- ScoreJackStraw(x, dims = 1:n.dims, verbose=FALSE)
  if(ret=="pvalues") return( Reductions(x,"pca")@jackstraw$overall.p.values[,2] )
  if(ret=="Seurat") return(x)
  if(ret=="sce") {
    metadata(dat)$jackstraw <- Reductions(x,"pca")@jackstraw
    return(dat)
  }
  y <- x[["pca"]]@jackstraw$overall.p.values[,2]
  nzeros <- which(y>0)[1]-1
  y <- y[-1*(1:nzeros)]
  farthestPoint(-log10(y))+nzeros
}

scran.ndims.wrapper <- function(dat){
  suppressPackageStartupMessages({
    library(SingleCellExperiment)
    library(scran)
  })
  if(is(dat, "Seurat")) {
    x <- SingleCellExperiment(list(counts=GetAssayData(dat,"counts"), 
                                     logcounts=GetAssayData(dat, "data")))[VariableFeatures(dat),]
  } else {
    x <- dat
  }
  pcs <- getDenoisedPCs(x, technical=modelGeneVar(x))
  ncol(pcs$components)
}


.tmads <- function(x, nbmads=2.5){
  x2 <- nbmads*median(abs(x-median(x)))
  median(x)+c(-x2,x2)
}

.translateFilterVars <- function(x){
  vars=c(  "mt"="pct_counts_Mt", 
           "feat"="total_features",
           "counts"="total_counts",
           "lfeat"="log10_total_features", 
           "lcounts"="log10_total_counts", 
           "top50"="pct_counts_in_top_50_features",
           "ratiodist"="featcount_dist"
  )
  x <- strsplit(x,"%",fixed=TRUE)
  y <- sapply(x,FUN=function(x){ if(length(x)==1) return("both"); x[[2]] })
  names(y) <- sapply(x,vars=vars,FUN=function(x, vars) vars[x[[1]]])
  y
}

#' getFilterStrings
#'
#' Returns a combination of filtering strings.
#' 
#' @param mads A vector of number of MADs.
#' @param times A vector of outlier times.
#' @param dirs A vector of directions (higher/lower/both)
#'
#' @return A vector of filtering strings.
getFilterStrings <- function(mads=c(2,2.5,3,5), times=1:2, dirs=c("higher","both")){
  varCombs <- c("","mt","lcounts","mt,lcounts","lfeat,lcounts","mt,lfeat","mt,lfeat,lcounts",
                "mt,lfeat,lcounts,top50","mt,top50","lcounts,top50")
  v2 <- varCombs[grep("lfeat|lcounts", varCombs)]
  v2 <- gsub("lfeat","feat", v2)
  v2 <- gsub("lcounts","counts", v2)
  varCombs <- c(varCombs,v2)
  mads<- c(2, 2.5, 3, 5)
  varCombs <- unlist(lapply(strsplit(varCombs,",",fixed=TRUE), dir=dirs, mads=mads, FUN=function(x, dir, mads){
    y <- expand.grid(lapply(x, y=dir, sep="%", FUN=paste))
    apply(y,1,collapse=",",FUN=paste)
  }))
  eg <- expand.grid(varCombs, mads, times)
  nbVars <- sapply(strsplit(as.character(eg[,1]),","),FUN=length)
  eg <- eg[which(nbVars>=eg[,3]),]
  as.character(apply(eg, 1, collapse="_", FUN=paste))
}

doublet.scDblFinder <- function(x, trans = "scran"){
  suppressPackageStartupMessages(library(scDblFinder))
  x <- scDblFinder(x, verbose=FALSE)
  x[,which(x$scDblFinder.class!="doublet")]
}

doublet.scds <- function(x){
  suppressPackageStartupMessages(library(scds))
  x <- cxds_bcds_hybrid(x, list(verb=FALSE), list(verb=FALSE))
  dbn <- ceiling((0.01 * ncol(x)/1000)*ncol(x))
  o <- order(x$hybrid_score, decreasing=TRUE)[seq_len(dbn)]
  x[,-o]
}





#_______________________________________________________________________________
# CLUSTERING  ------------------------------------------------------------------

clust.seurat <- function(x, rd=NULL, k=20, steps=8, dims=50, seed.use=1234, min.size=0, resolution=0.8){
  if(is(x, "Seurat")) {
    dat <- x 
  } else {
    dat <- seWrap(x)
  }
  dims <- min(dims,ncol(dat[["pca"]]@cell.embeddings))
  dat <- FindNeighbors(dat, k.param=k, dims=1:dims, verbose=FALSE)
  dat <- FindClusters(dat, resolution=resolution, random.seed=seed.use, verbose=FALSE)
  Idents(dat)
}

#' clust.scran
#' 
#' A wrapper to use scran-based clustering.
#'
#' @param ds An object of class `SingleCellExperiment` or `Seurat`.
#' @param rd The name of the dimensionality reduction to use, or a logical 
#' indicating whether to use a reduced space.
#' @param method The method, either `fast_greedy` or `walktrap`.
#' @param k number of NN to consider, default 20.
#' @param steps number of steps for the random walk (walktrap method), default 8.
#' @param dims The (maximum) number of dimensions to use.
#' @param nthreads The number of threads, default 1.
#' @param seed.use not used.
#' @param min.size Minimum size of a cluster (default 50)
#' @param resolution Ignored; for consistency with `clust.seurat`
#' @param neighbor.method Passed to scran
#' @param graph.type "snn.rank", "snn.number", or "knn".
#'
#' @return A factor vector of cluster IDs, with cell names as names.
#' 
#' @export
clust.scran <- function(ds, rd=TRUE, method="walktrap", 
                        graph.type=c("snn.rank","snn.number","knn"),
                        neighbor.method=c("Kmknn","Vptree","Annoy","Hnsw"), 
                        k=20, steps=8, dims=50, nthreads=1, seed.use=NULL, 
                        min.size=5, resolution=NULL){
  suppressPackageStartupMessages(library(BiocNeighbors))
  graph.type <- match.arg(graph.type)
  neighbor.method <- switch(match.arg(neighbor.method),
                             Kmknn=KmknnParam(),
                             Vptree=VptreeParam(),
                             Annoy=AnnoyParam(),
                             Hnsw=HnswParam())
  if(is(ds,"Seurat")){
    ds <- sceWrap(ds)
  }
  if(is.logical(rd)){
    if(rd){
      if(length(reducedDim(ds))>0){
        rd <- reducedDimNames(ds)[1]
        dims <- min(dims, ncol(reducedDim(ds, rd)))
      }else{
        rd <- NULL
      }
    }else{
      dims <- NA
      rd <- NULL
    }
  }
  BPPARAM <- if(nthreads>1) MulticoreParam(nthreads) else SerialParam()
  if(graph.type=="knn"){
    if(!is.null(rd)) reducedDim(ds, rd) <- reducedDim(ds, rd)[,seq_len(dims)]
    g <- scran::buildKNNGraph(ds, BPPARAM=BPPARAM, BNPARAM=neighbor.method, 
                              use.dimred=rd, k=k)
  }else{
    weighting <- ifelse(graph.type=="snn.rank", "rank", "number")
    if (is.null(rd)) {
      g <- scran::buildSNNGraph(ds, BPPARAM=BPPARAM, BNPARAM=neighbor.method, 
                                type=weighting, use.dimred=rd, k=k, d=dims)   
    } else {
      g <- scran::buildSNNGraph(ds, BPPARAM=BPPARAM, BNPARAM=neighbor.method, 
                                type=weighting, use.dimred=rd, k=k) 
    }
  }
  if(method=="walktrap"){
    cl <- igraph::cluster_walktrap(g, steps=steps)$membership
  }else{
    cl <- igraph::cluster_fast_greedy(g)$membership
  }
  if(min.size>0) cl <- scran:::.merge_closest_graph(g, cl, min.size=min.size)
  names(cl) <- colnames(ds)
  as.factor(cl)
}

clust.scran.fg <- function(ds, ...){
  clust.scran(ds, method="fastq_greedy", ...)
}

.validatePipelineDef <- function(object){
  
  e <- c()
  if( !is.list(object@functions) || 
      !all(vapply(object@functions, is.function, logical(1))) ) 
    e <- c("`functions` should be a (named) list of functions!")
  if(!all(vapply( object@functions, FUN.VALUE=logical(1),
                  FUN=function(x) "x" %in% names(formals(x)))))
    e <- c(e, "Each function should at least take the argument `x`.")
  isf <- function(x) is.null(x) || is.function(x)
  if( !is.list(object@aggregation) || 
      !all(vapply(object@aggregation, isf, logical(1))) ) 
    stop("`aggregation` should be a list of functions and/or NULL slots!")
  if( !is.list(object@evaluation) || 
      !all(vapply(object@evaluation, isf, logical(1))) ) 
    stop("`evaluation` should be a list of functions and/or NULL slots!")
  if(!all(names(object@descriptions)==names(object@functions))) 
    e <- c(e, "descriptions do not match functions.")
  if(!all(names(object@evaluation)==names(object@functions))) 
    e <- c(e, "evaluation do not match functions.")
  if(!all(names(object@aggregation)==names(object@functions))) 
    e <- c(e, "aggregation do not match functions.")
  args <- unlist( lapply( object@functions, 
                          FUN=function(x){ setdiff(names(formals(x)), "x") }) )
  if(any(duplicated(args))) e <- c(e, paste("Some arguments (beside `x`) is",
    "used in more than one step, which is not currently supported."))
  if(length( wa <- setdiff(names(object@defaultArguments),args) )>0)
    e <- c(e, paste("The following default arguments are not in the pipeline's 
           functions:", paste(wa, collapse=", ")))
  if(length(e) == 0) TRUE else e
}

#' @import methods
#' @exportClass PipelineDefinition
setClass( "PipelineDefinition", 
          slots=representation( functions="list", descriptions="list", 
                                evaluation="list", aggregation="list", 
                                initiation="function",
                                defaultArguments="list", misc="list" ),
          prototype=prototype( functions=list(), descriptions=list(), 
                               evaluation=list(), aggregation=list(), 
                               initiation=identity,
                               defaultArguments=list(), misc=list() ),
          validity=.validatePipelineDef )



#' PipelineDefinition
#' 
#' Creates on object of class `PipelineDefinition` containing step functions,
#' as well as optionally step evaluation and aggregation functions.
#'
#' @param functions A list of functions for each step
#' @param descriptions A list of descriptions for each step
#' @param evaluation A list of optional evaluation functions for each step
#' @param aggregation A list of optional aggregation functions for each step
#' @param initiation A function ran when initiating a dataset
#' @param defaultArguments A lsit of optional default arguments
#' @param misc A list of whatever.
#' @param verbose Whether to output additional warnings (default TRUE).
#'
#' @return An object of class `PipelineDefinition`, with the slots functions,
#' descriptions, evaluation, aggregation, defaultArguments, and misc.
#' 
#' @aliases PipelineDefinition-class
#' @seealso \code{\link{PipelineDefinition-methods}}, 
#' \code{\link{addPipelineStep}}. For an example pipeline, see 
#' \code{\link{scrna_pipeline}}.
#' @export
#' @examples
#' PipelineDefinition(
#'   list( step1=function(x, meth1){ get(meth1)(x) },
#'         step2=function(x, meth2){ get(meth2)(x) } )
#' )
PipelineDefinition <- function( functions, descriptions=NULL, evaluation=NULL,
                                aggregation=NULL, initiation=identity, 
                                defaultArguments=list(), 
                                misc=list(), verbose=TRUE ){
  if(!is.list(functions) || !all(vapply(functions, is.function, logical(1)))) 
    stop("`functions` should be a (named) list of functions!")
  n <- names(functions)
  if(is.null(n)) 
    n <- names(functions) <- paste0("step",seq_len(length(functions)))
  descriptions <- .checkInputList(descriptions, functions, FALSE)
  evaluation <- .checkInputList(evaluation, functions)
  aggregation2 <- .checkInputList(aggregation, functions)
  names(aggregation2)<-names(evaluation)<-names(descriptions)<-names(functions)
  for(f in names(aggregation2)){
    if(is.null(aggregation2[[f]]) && !is.null(evaluation[[f]]) &&
       !(f %in% names(aggregation)))
      aggregation2[[f]] <- defaultStepAggregation
  }
  if(is.null(misc)) misc <- list()
  x <- new("PipelineDefinition", functions=functions,descriptions=descriptions,
         evaluation=evaluation, aggregation=aggregation2, 
         initiation=initiation, defaultArguments=defaultArguments, misc=misc)
  
  w <- which( !vapply(x@aggregation, is.null, logical(1)) & 
                vapply(x@evaluation, is.null, logical(1)) )
  if(verbose && length(w)>0){
    warning(paste("An aggregation is defined for some steps that do not have",
                  "a defined evaluation function: ",
                  paste(names(x@functions)[w], collapse=", "),
                  "It is possible that evaluation is performed by the step's",
                  "function itself.") )
  }
  x
}

.checkInputList <- function( x, fns, containsFns=TRUE, 
                             name=deparse(substitute(x)) ){
  name <- paste0("`",name,"`")
  if(!is.null(x)){
    if(length(x)!=length(fns)){
      if(is.null(names(x)))
        stop("If ", name, " does not have the same length as the number of ",
             "steps, its slots should be named.")
      if(length(unknown <- setdiff(names(x),names(fns)))>0)
        stop("Some elements of ",name," (",paste(unknown,collapse=", "),")",
             "are unknown.")
      x <- lapply(names(fns), FUN=function(f){
        if(is.null(x[[f]])) return(NULL)
        x[[f]]
      })
      names(x) <- names(fns)
    } 
    if( !is.null(names(x)) ){
      if(!all(names(x)==names(fns)) )
        stop("The names of ",name," should match those of `functions`")
    }
  }else{
    x <- lapply(fns,FUN=function(x) NULL)
  }
  if(containsFns && 
     !all(vapply(x, FUN=function(x) is.null(x) || is.function(x), logical(1))))
    stop(name," should be a list of functions")
  x
}

#' Methods for \code{\link{PipelineDefinition}} class
#' @name PipelineDefinition-methods
#' @rdname PipelineDefinition-methods
#' @aliases PipelineDefinition-method
#' @seealso \code{\link{PipelineDefinition}}, \code{\link{addPipelineStep}}
#' @param object An object of class \code{\link{PipelineDefinition}}
#' @return Depends on the method.
#' @examples
#' pd <- mockPipeline()
#' length(pd)
#' names(pd)
#' pd$step1
#' pd[2:1]
NULL

#' @rdname PipelineDefinition-methods
#' @importMethodsFrom methods show
#' @importFrom knitr opts_current
setMethod("show", signature("PipelineDefinition"), function(object){
  # colors and bold are going to trigger errors when rendered in a knit, so
  # we disable them when rendering
  isKnit <- tryCatch( isTRUE(getOption('knitr.in.progress')) || 
                        length(knitr::opts_current$get())>0,
                      error=function(e) FALSE)
  fns <- unlist(lapply(names(object@functions), FUN=function(x){ 
    x2 <- x
    if(!isKnit) x2 <- paste0("\033[1m",x,"\033[22m")
    y <- lapply( names(formals(object@functions[[x]])), FUN=function(n){
      if(!is.null(def <- object@defaultArguments[[n]]))
        n <- paste0(n,"=",deparse(def,100,FALSE))
      n
    })
    y <- paste0("  - ", x2, "(", paste(unlist(y), collapse=", "), ")")
    if(!is.null(object@evaluation[[x]]) || !is.null(object@aggregation[[x]])) 
      y <- paste0(y, ifelse(isKnit, " * ", " \033[34m*\033[39m "))
    if(!is.null(object@descriptions[[x]])){
      x2 <- object@descriptions[[x]]
      if(!isKnit) x2 <- paste0("\033[3m",x2,"\033[23m")
      y <- paste(y, x2, sep="\n")
    }
    y
  }))
  cat("A PipelineDefinition object with the following steps:\n")
  cat(paste(fns,collapse="\n"))
  cat("\n")
})

#' get names of PipelineDefinition steps
#' @rdname PipelineDefinition-methods
#' @param x An object of class \code{\link{PipelineDefinition}}
setMethod("names", signature("PipelineDefinition"), function(x){
  names(x@functions)
})

#' set names of PipelineDefinition steps
#' @rdname PipelineDefinition-methods
#' @param value Replacement values
setMethod("names<-", signature("PipelineDefinition"), function(x, value){
  if(any(duplicated(value))) stop("Some step names are duplicated!")
  names(x@functions) <- value
  names(x@evaluation) <- value
  names(x@aggregation) <- value
  names(x@descriptions) <- value
  validObject(x)
  x
})

#' @rdname PipelineDefinition-methods
#' @param name The step name
setMethod("$", signature("PipelineDefinition"), function(x, name){
  x@functions[[name]]
})

#' @rdname PipelineDefinition-methods
setMethod("length", signature("PipelineDefinition"), function(x){
  length(x@functions)
})

#' @rdname PipelineDefinition-methods
#' @param i The index(es) of the steps
setMethod("[",signature("PipelineDefinition"), function(x, i){
  new("PipelineDefinition", functions=x@functions[i], 
       descriptions=x@descriptions[i], evaluation=x@evaluation[i],
       aggregation=x@aggregation[i], misc=x@misc)
})

#' @rdname PipelineDefinition-methods
setMethod("as.list",signature("PipelineDefinition"), function(x){
  x@functions
})

#' @exportMethod arguments
#' @rdname PipelineDefinition-methods
setGeneric("arguments", function(object) args(object))
#' @rdname PipelineDefinition-methods
setMethod("arguments",signature("PipelineDefinition"), function(object){
  lapply(object@functions, FUN=function(x){ setdiff(names(formals(x)), "x") })
})

#' @rdname PipelineDefinition-methods
#' @exportMethod defaultArguments
setGeneric("defaultArguments", function(object) NULL)
#' @exportMethod defaultArguments<-
#' @rdname PipelineDefinition-methods
setGeneric("defaultArguments<-", function(object, value) NULL)
#' @rdname PipelineDefinition-methods
setMethod("defaultArguments",signature("PipelineDefinition"), function(object){
  object@defaultArguments
})
#' @rdname PipelineDefinition-methods
setMethod( "defaultArguments<-",signature("PipelineDefinition"), 
           function(object, value){
  object@defaultArguments <- value
  validObject(object)
  object
})

#' @exportMethod stepFn
#' @rdname PipelineDefinition-methods
setGeneric("stepFn", function(object, step=NULL, type) standardGeneric("stepFn"))
#' @param step The name of the step for which to set or get the function
#' @param type The type of function to set/get, either `functions`, 
#' `evaluation`, `aggregation`, `descriptions`, or `initiation` (will parse 
#' partial matches)
#' @rdname PipelineDefinition-methods
setMethod("stepFn", signature("PipelineDefinition"), 
          function(object, step=NULL, type){
  ft <- c("functions","evaluation","aggregation","descriptions","initiation")
  type <- match.arg( type, ft )
  if(is.null(step)) return(slot(object, type))
  step <- match.arg(step, names(object))
  slot(object, type)[[step]]
})
#' @exportMethod stepFn<-
#' @rdname PipelineDefinition-methods
setGeneric( "stepFn<-", 
            function(object, step, type, value) standardGeneric("stepFn<-") )
#' @rdname PipelineDefinition-methods
setMethod( "stepFn<-", signature("PipelineDefinition"), 
           function(object, step, type, value){
  ft <- c("functions","evaluation","aggregation","descriptions","initiation")
  type <- match.arg(type, ft)
  if(type!="descriptions" && !is.null(value) && !is.function(value))
    stop("Replacement value should be a function.")
  if(type=="initiation"){
    slot(object, type) <- value
  }else{
    step <- match.arg(step, names(object))
    slot(object, type)[[step]] <- value
  }
  if(type=="evaluation" && !is.null(value)){
    # also add the default aggregation:
    if(is.null(slot(object, "aggregation")[[step]]))
      slot(object, "aggregation")[[step]] <- defaultStepAggregation
  }
  object
})


#' addPipelineStep
#' 
#' Add a step to an existing \code{\link{PipelineDefinition}}
#'
#' @param object A \code{\link{PipelineDefinition}}
#' @param name The name of the step to add
#' @param after The name of the step after which to add the new step. If NULL,
#' will add the step at the beginning of the pipeline.
#' @param slots A optional named list with slots to fill for that step (i.e. 
#' `functions`, `evaluation`, `aggregation`, `descriptions` - will be parsed)
#'
#' @return A \code{\link{PipelineDefinition}}
#' @seealso \code{\link{PipelineDefinition}}, 
#' \code{\link{PipelineDefinition-methods}}
#' @importFrom methods is slot
#' @export
#'
#' @examples
#' pd <- mockPipeline()
#' pd
#' pd <- addPipelineStep(pd, name="newstep", after="step1", 
#'                       slots=list(description="Step that does nothing..."))
#' pd
addPipelineStep <- function(object, name, after=NULL, slots=list()){
  if(!is(object, "PipelineDefinition")) 
    stop("object should be a PipelineDefinition")
  if(name %in% names(object)) stop("There is already a step with that name!")
  if(!is.null(after) && !(after %in% names(object))) 
    stop("`after` should either be null or the name of a step.")
  n <- c("functions","evaluation","aggregation","descriptions")
  if(length(slots)>0) 
    names(slots) <- vapply( names(slots), choices=n, FUN=match.arg, 
                            FUN.VALUE=character(1) )
  if(!all(names(slots) %in% n)) 
    stop(paste("fns should be a function or a list", 
    "with one or more of the following names:\n", paste(n,collapse=", ")))
  
  if(is.null(after)){
    i1 <- vector("integer")
    i2 <- seq_along(names(object))
  }else{
    w <- which(names(object)==after)
    i1 <- seq_len(w)
    i2 <- seq.int(from=w+1, to=length(object))
    if(w==length(object)) i2 <- vector("integer")
  }
  ll <- list(NULL)
  names(ll) <- name
  for(f in n) slot(object,f) <- c(slot(object,f)[i1], ll, slot(object,f)[i2])
  for(f in names(slots)) stepFn(object, name, f) <- slots[[f]]
  if(is.null(stepFn(object, name, "functions"))) 
    stepFn(object, name, "functions") <- identity
  validObject(object)
  object
}

#' mockPipeline
#' 
#' A mock `PipelineDefinition` for use in examples.
#'
#' @return a `PipelineDefinition`
#' @export
#'
#' @examples
#' mockPipeline()
mockPipeline <- function(){
  PipelineDefinition(
    list( step1=function(x, meth1){ get(meth1)(x) },
          step2=function(x, meth2){ get(meth2)(x) } ),
    evaluation=list( step2=function(x) c(mean=mean(x), max=max(x)) ),
    descriptions=list( step1="This steps applies meth1 to x.",
                       step2="This steps applies meth2 to x."),
    defaultArguments=list(meth1=c("log","sqrt"), meth2="cumsum")
  )
}

#' plotElapsed
#' 
#' Plot total elapsed time per run, split per step.
#'
#' @param res Aggregated pipeline results
#' @param steps The step(s) to plot (default all)
#' @param agg.by The parameters by which to aggregate (set to FALSE to disable 
#' aggregation)
#' @param agg.fn Aggregation function
#' @param width Width of the bar; default 0.9, use 1 to remove the gaps
#' @param split.datasets Logical; whether to split the datasets into facets
#' @param return.df Logical; whether to return the data.frame instead of plot
#'
#' @return A ggplot, or a data.frame if `return.df=TRUE`
#' 
#' @examples
#' data("exampleResults", package="pipeComp")
#' plotElapsed(exampleResults, agg.by = "norm")
#' 
#' @export
#' @import ggplot2
#' @importFrom reshape2 melt
plotElapsed <- function(res, steps=names(res$elapsed$stepwise), agg.by, 
                        agg.fn=mean, width=0.9, split.datasets=TRUE,
                        return.df=FALSE ){
  allsteps <- names(res$elapsed$stepwise)
  steps <- match.arg(steps, allsteps, several.ok = TRUE)
  args <- unlist(arguments(metadata(res)$PipelineDefinition)[steps])
  if(isFALSE(agg.by)){
    agg.by <- args
  }else{
    agg.by <- match.arg(agg.by, args, several.ok = TRUE)
  }
  for(f in steps){
    colnames(res$elapsed$stepwise[[f]]) <- 
      gsub("^elapsed$",f, colnames(res$elapsed$stepwise[[f]]))
  }
  m <- res$elapsed$stepwise[[1]]
  for(f in names(res$elapsed$stepwise)[-1]){
    fields <- intersect(colnames(m),colnames(res$elapsed$stepwise[[f]]))
    m <- merge(m, res$elapsed$stepwise[[f]], by=fields)
  }
  by2 <- agg.by
  if(split.datasets) by2 <- unique(c("dataset", by2))
  m <- aggregate( m[,steps,drop=FALSE], 
                  by=m[,by2,drop=FALSE], FUN=mean)
  m3 <- reshape2::melt(m, id.vars=by2, variable.name="step")
  m3 <- m3[which(m3$step %in% steps),]
  m3$id <- apply(m3[,agg.by,drop=FALSE], 1, collapse=" ", FUN=paste)
  if(return.df) return(m3)
  p <- ggplot(m3, aes_string('id', 'value', fill='step')) + 
    geom_bar( stat="identity", width=width,
              position=position_stack(reverse=TRUE) ) + 
    coord_flip() + xlab("") + ylab("Time (s)")
  if(split.datasets) p <- p + facet_wrap(~dataset, scales="free_x")
  p
}

## Will Townes' deviance-based feature ranking
## Downloaded from:
## https://github.com/willtownes/scrna2019/blob/master/util/functions.R 
## GNU Lesser General Public License v3.0

##### Deviance functions #####

poisson_deviance<-function(x,mu,sz){
  #assumes log link and size factor sz on the same scale as x (not logged)
  #stopifnot(all(x>=0 & sz>0))
  2*sum(x*log(x/(sz*mu)),na.rm=TRUE)-2*sum(x-sz*mu)
}

multinomial_deviance<-function(x,p){
  -2*sum(x*log(p))
}

binomial_deviance<-function(x,p,n){
  term1<-sum(x*log(x/(n*p)), na.rm=TRUE)
  nx<-n-x
  term2<-sum(nx*log(nx/(n*(1-p))), na.rm=TRUE)
  2*(term1+term2)
}

gof_func<-function(x,sz,mod=c("binomial","multinomial","poisson","geometric")){
  #Let n=colSums(original matrix where x is a row)
  #if binomial, assumes sz=n, required! So sz>0 for whole vector
  #if poisson, assumes sz=n/geometric_mean(n), so again all of sz>0
  #if geometric, assumes sz=log(n/geometric_mean(n)) which helps numerical stability. Here sz can be <>0
  #note sum(x)/sum(sz) is the (scalar) MLE for "mu" in Poisson and "p" in Binomial
  mod<-match.arg(mod)
  fit<-list(deviance=0,df.residual=length(x)-1,converged=TRUE)
  if(mod=="multinomial"){
    fit$deviance<-multinomial_deviance(x,sum(x)/sum(sz))
  } else if(mod=="binomial"){
    fit$deviance<-binomial_deviance(x,sum(x)/sum(sz),sz)
  } else if(mod=="poisson"){
    fit$deviance<-poisson_deviance(x,sum(x)/sum(sz),sz)
  } else if(mod=="geometric"){
    if(any(x>0)) {
      fit<-glm(x~offset(sz),family=MASS::negative.binomial(theta=1))
    }
  } else { stop("invalid model") }
  if(fit$converged){
    dev<-fit$deviance
    df<-fit$df.residual #length(x)-1
    pval<-pchisq(dev,df,lower.tail=FALSE)
    res<-c(dev,pval)
  } else {
    res<-rep(NA,2)
  }
  names(res)<-c("deviance","pval")
  res
}

compute_size_factors<-function(m,mod=c("binomial","multinomial","poisson","geometric")){
  #given matrix m with samples in the columns
  #compute size factors suitable for the discrete model in 'mod'
  mod<-match.arg(mod)
  sz<-Matrix::colSums(m) #base case, multinomial or binomial
  if(mod %in% c("multinomial","binomial")){ return(sz) }
  sz<-log(sz)
  sz<-sz - mean(sz) #make geometric mean of sz be 1 for poisson, geometric
  if(mod=="poisson"){ return(exp(sz)) }
  sz #geometric, use log scale size factors
}

compute_gene_info<-function(m,gmeta=NULL,mod=c("binomial","multinomial","poisson","geometric")){
  #m a data matrix with genes=rows
  #gmeta a pre-existing data frame with gene-level metadata
  mod<-match.arg(mod)
  if(!is.null(gmeta)){ stopifnot(nrow(m)==nrow(gmeta)) }
  gnz<-Matrix::rowSums(m>0)
  sz<-compute_size_factors(m,mod)
  gof<-function(g){ gof_func(m[g,],sz,mod) }
  gof<-as.data.frame(t(vapply(1:nrow(m),gof,FUN.VALUE=rep(0.0,2))))
  #colnames(gof)<-c("deviance","pval")
  gmu<-Matrix::rowMeans(m)
  gvar<-apply(m,1,var)
  gfano<-ifelse(gvar>0 & gmu>0, gvar/gmu, 0)
  res<-cbind(nzsum=gnz,fano=gfano,gof)
  res$pval_fdr<-p.adjust(res$pval,"BH")
  if(is.null(gmeta)){ return(res) } else { return(cbind(gmeta,res)) }
}

#' scrna_pipeline
#' 
#' The `PipelineDefinition` for the default scRNAseq clustering pipeline, with 
#' steps for doublet identification, filtering, normalization, feature 
#' selection, dimensionality reduction, and clustering.
#' Alternative arguments should be character, numeric or logical vectors of
#' length 1 (e.g. the function name for a method, the number of dimensions, 
#' etc). The default pipeline has the following steps and arguments:
#' \itemize{
#' \item doublet: `doubletmethod` (name of the doublet removal function)
#' \item filtering: `filt` (name of the filtering function, or filter string)
#' \item normalization: `norm` (name of the normalization function)
#' \item selection: `sel` (name of the selection function, or variable of 
#' rowData on which to select) and `selnb` (number of features to select)
#' \item dimreduction: `dr` (name of the dimensionality reduction function) and
#'  `maxdim` (maximum number of components to compute)
#' \item clustering: `clustmethod` (name of the clustering function), 
#' `dims` (number of dimensions to use), `k` (number of nearest neighbors to 
#' use, if applicable), `steps` (number of steps in the random walk, if 
#' applicable), `resolution` (resolution, if applicable), `min.size` (minimum 
#' cluster size, if applicable). If using the `scrna_alternatives.R` wrappers, 
#' the dimensionality can be automatically estimated by specifying 
#' `dims = "method_name"`. 
#' }
#' 
#' @param saveDimRed Logical; whether to save the dimensionality reduction for 
#' each analysis (default FALSE)
#' 
#' @param pipeClass `sce` or `seurat`; which object class to use throughout the
#' pipeline. Note that the `alternatives` functions have to be built around the
#' chosen class. Given that, if running the `scrna_alternatives`, the class of 
#' whole pipeline is determined by the output of the filtering, only this step 
#' is affected by this option. 
#' 
#' @return A `PipelineDefinition` object to be used with `runPipeline`.
#' 
#' @export
#' @examples
#' pip <- scrna_pipeline()
#' pip
scrna_pipeline <- function(saveDimRed=FALSE, pipeClass=c("seurat","sce")){
  pipeClass <- match.arg(pipeClass)
  
  # description for each step
  desc <- list( 
    doublet=
"Takes a SCE object with the `phenoid` colData column, passes it through the 
function `doubletmethod`, and outputs a filtered SCE.",
    filtering=
"Takes a SCE object, passes it through the function `filt`, and outputs a 
filtered Seurat object.",
    normalization=
paste("Passes the object through function `norm` and returns it with the",
ifelse(pipeClass=="sce","logcounts assay","normalized and scale data slots"),
"filled."),
    selection=
"Returns a Seurat object with the VariableFeatures filled with `selnb` features
 using the function `sel`.",
    dimreduction=
"Returns a Seurat object with the PCA reduction with up to `maxdim` components
using the `dr` function.",
    clustering=
"Uses function `clustmethod` to return a named vector of cell clusters." )
  
  
  if (pipeClass == "sce") desc <- lapply(desc, function(x){
    x <- gsub("Seurat", "SCE", x)
  })
  
  # we prepare the functions for each step
  # dimred intermediate return
  if(saveDimRed){
    if(pipeClass == "seurat") {
      DRfun <- function(x, dr, maxdim){ 
        x <- get(dr)(x, dims=maxdim)
        list( x=x, 
              intermediate_return=list(
                cell.embeddings=Embeddings(x[["pca"]]),
                evaluation=evaluateDimRed(x)
              )
            )
      }
    } else {
      DRfun <- function(x, dr, maxdim){ 
        x <- get(dr)(x, dims=maxdim)
        list( x=x, 
              intermediate_return=list(cell.embeddings=reducedDim(x, "PCA"),
                                       evaluation=evaluateDimRed(x)) )
      }
    }
    
  }else{
    DRfun <- function(x, dr, maxdim){ 
      get(dr)(x, dims=maxdim)
    }
  }
  # selection intermediate return
  if(pipeClass == "seurat") {
    selfun <- function(x, sel, selnb){                          
      x <- pipeComp:::.runf(sel, x, n=selnb, alt="applySelString")
      list( x=x, intermediate_return=Seurat::VariableFeatures(x) )
    }
    filtfun <- function(x, filt){
      x2 <- pipeComp:::.runf(filt, x, alt="applyFilterString")
      list( x=seWrap(x2), 
            intermediate_return=pipeComp:::.compileExcludedCells(x,x2) )
    }
  }else{
    selfun <- function(x, sel, selnb){                          
      x <- pipeComp:::.runf(sel, x, n=selnb, alt="applySelString")
      list( x=x, intermediate_return=metadata(x)$VariableFeats )
    }
    filtfun <- function(x, filt){
      x2 <- pipeComp:::.runf(filt, x, alt="applyFilterString")
      list(x=x2, intermediate_return=pipeComp:::.compileExcludedCells(x,x2))
    }
  }
  # functions list
  f <- list(
    doublet=function(x, doubletmethod){ 
      x2 <- pipeComp:::.runf(doubletmethod, x)
      list(x=x2, intermediate_return=pipeComp:::.compileExcludedCells(x,x2))
    },
    filtering=filtfun,
    normalization=function(x, norm){ 
      x <- get(norm)(x)
    },
    selection=selfun,
    dimreduction=DRfun,
    # # to try different dimensionality methods without having to recompute the
    # # reduction:
    # dimensionality=function(x, dims){
    #   if(!is.na(suppressWarnings(as.numeric(dims)))){
    #     dims <- as.integer(dims)
    #   }else{
    #     dims <- getDimensionality(x, dims)
    #   }
    #   x[["pca"]]@cell.embeddings<- x[["pca"]]@cell.embeddings[,seq_len(dims)]
    # },
    clustering=function(x, clustmethod, dims, k, steps, resolution, min.size){
      tl <- x$phenoid
      if(!is.na(suppressWarnings(as.numeric(dims)))){
        dims <- as.integer(dims)
      }else{
        dims <- getDimensionality(x, dims)
      }
      dims <- max(dims,2,na.rm=TRUE)
      x <- get(clustmethod)(x, dims=dims, resolution=resolution, k=k, 
                            steps=steps, min.size=min.size)
      attr(x, "true.labels") <- tl
      x
    }
  )
  
  eva <- list( doublet=NULL, filtering=NULL, normalization=evaluateNorm,
               selection=NULL, dimreduction=evaluateDimRed, 
               clustering=evaluateClustering )
  # functions to aggregate the intermediate_return of the different steps
  agg <- list( doublet=.aggregateExcludedCells,
               filtering=.aggregateExcludedCells,
               normalization=NULL,
               selection=NULL,
               dimreduction=.aggregateDR,
               clustering=.aggregateClusterEvaluation )
  # default arguments
  def <- list( selnb=2000, maxdim=50, dims=20, k=20, steps=8, min.size=50,
               resolution=c(0.01, 0.1, 0.5, 0.8, 1) )
  # initiation function
  initf <- function(x){
    if(is.character(x) && length(x)==1) return(readRDS(x))
    x
  }
  PipelineDefinition(functions=f, descriptions=desc, evaluation=eva,
                     aggregation=agg, initiation=initf, 
                     defaultArguments=def, verbose=FALSE)
}

## ----include=FALSE------------------------------------------------------------
library(BiocStyle)

## -----------------------------------------------------------------------------
suppressPackageStartupMessages({
  library(pipeComp)
  library(S4Vectors)
})

evaluateDEA <- function(dea, truth=NULL, th=c(0.01,0.05,0.1)){
  ## we make sure that the column names of `dea` are standard:
  dea <- pipeComp:::.homogenizeDEA(dea)
  ## within Pipecomp, the truth should be passed along with the `dea` object, so
  ## we retrieve it here:
  if(is.null(truth)) truth <- metadata(dea)$truth
  dea <- cbind(dea, truth[row.names(dea),])
  ## we get rid of genes for which the truth is unknown:
  dea <- dea[!is.na(dea$expected.beta),]
  ## comparison of estimated and expected log2 folchanges:
  res <- c(logFC.pearson=cor(dea$logFC, dea$expected.beta, use = "pairwise"),
           logFC.spearman=cor(dea$logFC, dea$expected.beta, 
                              use = "pairwise", method="spearman"),
           logFC.mad=median(abs(dea$logFC-dea$expected.beta),na.rm=TRUE),
           ntested=sum(!is.na(dea$PValue) & !is.na(dea$FDR)))
  ## evaluation of singificance calls
  names(th) <- th
  res2 <- t(vapply( th, FUN.VALUE=vector(mode="numeric", length=6), 
                    FUN=function(x){
    ## for each significance threshold, calculate the various metrics
    called=sum(dea$FDR<x,na.rm=TRUE)
    P <- sum(dea$isDE)
    TP <- sum(dea$FDR<x & dea$isDE, na.rm=TRUE)
    c( TP=TP, FP=called-TP, TPR=TP/P, PPV=TP/called, FDR=1-TP/called, 
       FPR=(P-TP)/sum(!dea$isDE) )
  }))
  res2 <- cbind(threshold=as.numeric(row.names(res2)), as.data.frame(res2))
  row.names(res2) <- NULL
  list(logFC=res, significance=res2)
}

## -----------------------------------------------------------------------------
# we build a random DEA dataframe and truth:
dea <- data.frame( row.names=paste0("gene",1:10), logFC=rnorm(10) )
dea$PValue <- dea$FDR <- c(2:8/100, 0.2, 0.5, 1)
truth <- data.frame( row.names=paste0("gene",1:10), expected.beta=rnorm(10),
                    isDE=rep(c(TRUE,FALSE,TRUE,FALSE), c(3,1,2,4)) )
evaluateDEA(dea, truth)

## -----------------------------------------------------------------------------
step.filtering <- function(x, filt, minCount=10){
  # we apply the function `filt` to `x` with the parameter `minCount`
  get(filt)(x, minCount=minCount)
}

## -----------------------------------------------------------------------------
step.sva <- function(x, sva.method, k=1){
  # we create the model.matrix:
  mm <- stats::model.matrix(~condition, data=as.data.frame(colData(x)))
  # we apply the function `sva.method` to `x` with the parameter `k`
  get(sva.method)(x, k=k, mm=mm)
}

## -----------------------------------------------------------------------------
step.dea <- function(x, dea.method){
  # run the DEA method, and transform the results into a DataFrame:
  x2 <- DataFrame(get(dea.method)(x,mm))
  # attach the truth to the results:
  metadata(x2)$truth <- metadata(x)$truth
  x2
}

## -----------------------------------------------------------------------------
pip <- PipelineDefinition( list( filtering=step.filtering,
                                          sva=step.sva,
                                          dea=step.dea )
                                    )
pip

## -----------------------------------------------------------------------------
stepFn(pip, step="dea", type="evaluation") <- evaluateDEA
pip

## -----------------------------------------------------------------------------
def.filter <- function(x, minCounts=10){
  library(edgeR)
  minCounts <- as.numeric(minCounts)
  x[filterByExpr(assay(x), model.matrix(~x$condition), min.count=minCounts),]
}

sva.svaseq <- function(x, k, mm){
  k <- as.integer(k)
  if(k==0) return(x)
  library(sva)
  # run SVA
  sv <- svaseq(assay(x), mod=mm, n.sv=k)
  if(sv$n.sv==0) return(x)
  # rename the SVs and add them to the colData of `x`:
  colnames(sv$sv) <- paste0("SV", seq_len(ncol(sv$sv)))
  colData(x) <- cbind(colData(x), sv$sv)
  x
}

dea.edgeR <- function(x, mm){
  library(edgeR)
  dds <- calcNormFactors(DGEList(assay(x)))
  dds <- estimateDisp(dds, mm)
  fit <- glmFit(dds, mm)
  as.data.frame(topTags(glmLRT(fit, "condition"), Inf))
}

# we also define a function not doing anything:
none <- function(x, ...) x

## -----------------------------------------------------------------------------
alternatives <- list(
  filt=c("none","def.filter"),
  minCount=10,
  sva.method=c("none","sva.svaseq"),
  k=1:2,
  dea.method="dea.edgeR"
)

## ----eval=FALSE---------------------------------------------------------------
# datasets <- list.files("path/to/datasets", pattern="rds$", full.names=TRUE)
# names(datasets) <- paste0("dataset",1:2)
# datasets <- lapply(datasets, readRDS)

## ----eval=FALSE---------------------------------------------------------------
# # not run
# stepFn(pip, type="initiation") <- function(x){
#   if(is.character(x) && length(x)==1) x <- readRDS(x)
#   x
# }

## ----eval=FALSE---------------------------------------------------------------
# res <- runPipeline( datasets, alternatives, pipelineDef=pip, nthreads=4 )
# 
# lapply(res$evaluation$dea, head)

## -----------------------------------------------------------------------------
data("exampleDEAresults", package = "pipeComp")
res <- exampleDEAresults

## -----------------------------------------------------------------------------
plotElapsed(res, agg.by="sva.method")
evalHeatmap( res, what=c("TPR","FDR","logFC.pearson"), 
             agg.by=c("sva.method", "dea.method"), row_split = "sva.method" )

## -----------------------------------------------------------------------------
evalHeatmap( res, what=c("TPR","FDR"), agg.by=c("sva.method", "dea.method"), 
             row_split="sva.method", filterExpr=threshold==0.05 )

## ----fig.width=9, fig.height=4------------------------------------------------
library(ggplot2)
dea_evalPlot_curve(res, agg.by=c("sva.method","dea.method"), 
                   colourBy="sva.method", shapeBy="dea.method")
dea_evalPlot_curve(res, agg.by=c("sva.method")) + 
  ggtitle("SVA methods, averaging across DEA methods")

## ----fig.height=7, fig.width=5------------------------------------------------
evalHeatmap(res, what=c("TPR","FDR"), agg.by=c("sva.method","k"), 
                 show_column_names=TRUE, anno_legend = FALSE, 
                 row_split="sva.method", filterExpr=threshold==0.05 )

#' checkPipelinePackages
#' 
#' Checks whether the packages required by a pipeline and its alternative 
#' methods are available.
#'
#' @param alternatives A named list of alternative parameter values
#' @param pipDef An object of class `PipelineDefinition`.
#'
#' @return Logical.
#' @export
#' 
#' @importFrom utils installed.packages
#' @examples
#' checkPipelinePackages(list(argument1="mean"), scrna_pipeline())
checkPipelinePackages <- function(alternatives, pipDef=NULL){
  fns <- unlist(alternatives[ vapply( alternatives, FUN=is.character, 
                                      FUN.VALUE=logical(1) ) ])
  fns <- lapply(fns, FUN=function(x){
    if(exists(x) && is.function(get(x))) return(get(x))
    ""
  })
  fns <- paste(unlist(fns),collapse="\n")
  if(!is.null(pipDef)){
    fns <- paste(fns, paste(stepFn(pipDef, type="functions"), collapse="\n"), 
                 paste(stepFn(pipDef, type="evaluation"), collapse="\n"))
  }
  pkg <- gregexpr("library\\(([[:alnum:]])+\\)", fns)
  pkg <- unique(regmatches(fns, pkg)[[1]])
  pkg <- gsub("\\)","",gsub("^library\\(","",pkg))
  pkg <- gsub('"',"",pkg)
  misspkg <- setdiff(pkg, row.names(installed.packages()))
  if(length(misspkg)>0) message("The following packages appear to be missing:",
       paste(misspkg, collapse=", "))
  return(length(misspkg)==0)
}



#' parsePipNames
#' 
#' Parses the names of analyses performed through `runPipeline` to extract a 
#' data.frame of parameter values (with decent classes).
#'
#' @param x The names to parse, or a data.frame with the names to parse as 
#' row.names. All names are expected to contain the same parameters.
#' @param setRowNames Logical; whether to set original names as row.names of
#' the output data.frame (default FALSE)
#' @param addcolumns An optional data.frame of `length(x)` rows to cbind to the
#' output.
#'
#' @return A data.frame
#' 
#' @importFrom utils type.convert
#' @export
#'
#' @examples
#' my_names <- c("param1=A;param2=5","param1=B;param2=0")
#' parsePipNames(my_names)
parsePipNames <- function(x, setRowNames=FALSE, addcolumns=NULL){
  if(is.data.frame(x) || is.matrix(x)){
    if(!is.null(addcolumns)){
      addcolumns <- cbind(x,addcolumns)
    }else{
      addcolumns <- x
    }
    x <- row.names(x)
  }
  x2 <- lapply(strsplit(x,";"),FUN=function(x) x)
  if(length(unique(vapply(x2, length, numeric(1))))>1) 
    stop("The different names do not have the same number of components.")
  n <- vapply(strsplit(x2[[1]],"="),FUN=function(x) x[1], character(1))
  y <- vapply(strsplit(unlist(x2),"="),FUN=function(x) x[2], character(1))
  y <- as.data.frame(matrix(y, ncol=length(n), byrow=TRUE))
  colnames(y) <- n
  for(i in seq_len(ncol(y))) y[[i]] <- type.convert(y[[i]])
  if(setRowNames) row.names(y) <- x
  if(!is.null(addcolumns)){
    row.names(addcolumns) <- NULL
    y <- cbind(y,addcolumns)
  }
  y
}

# run function `x` on object `o`; if there is no function `x`, run `alt` passing
# `x` as second argument
.runf <- function(x, o, alt=NULL, ...){
  if(exists(x) && is.function(get(x))){
    return(get(x)(o, ...))
  }else{
    if(is.null(alt)) stop("Function '",x,"' not found in environment!")
    return(alt(o, x, ...))
  }
}


#' buildCombMatrix
#' 
#' Builds a matrix of parameter combinations from a list of alternative values.
#'
#' @param alt A named list of alternative parameter values
#' @param returnIndexMatrix Logical; whether to return a matrix of indices, 
#' rather than a data.frame of factors.
#'
#' @return a matrix or data.frame
#' @export
#'
#' @examples
#' buildCombMatrix(list(param1=LETTERS[1:3], param2=1:2))
buildCombMatrix <- function(alt, returnIndexMatrix=FALSE){
  eg <- as.matrix(expand.grid(lapply(rev(alt), FUN=seq_along)))
  eg <- eg[,seq(ncol(eg),1)]
  if(returnIndexMatrix) return(eg)
  eg <- as.data.frame(eg)
  for(f in names(alt)){
    eg[,f] <- factor(alt[[f]][eg[,f]], levels=alt[[f]])
  }
  eg
}

.checkCombMatrix <- function(eg, alt){
  if(is.null(dim(eg))) 
    stop("`eg` should be a matrix or data.frame of indices or factors")
  if(!all(names(alt) %in% colnames(eg))) 
    stop("The columns of `eg` do not correspond to the arguments.")
  eg <- eg[,names(alt)]
  if(!is.matrix(eg) || !is.numeric(eg)){
    for(f in colnames(eg)){
      if(is.character(eg[,f])) eg[,f] <- factor(eg[,f])
      if(is.factor(eg[,f])){
        if(!all(levels(eg[,f])==alt[[f]])) 
          stop("If `eg` contains factors, the levels should be identical to 
                 the values of the corresponding element of `alternatives`")
        eg[,f] <- as.numeric(eg[,f])
      }
    }
  }
  if(any(is.na(eg))) stop("Final `eg` contains missing values!")
  .sortcols(eg)
}

.sortcols <- function(x){
  xi <- x[,ncol(x)]
  for(i in seq(ncol(x)-1,1)) xi <- xi+max(xi)*x[,i]
  x[order(xi),]
}

#' getQualitativePalette
#'
#' Returns a qualitative color palette of the given size. If less than 23 colors
#'  are required, the colors are based on Paul Tol's palettes. If more, the 
#'  `randomcoloR` package is used.
#'
#' @param nbcolors A positive integer indicating the number of colors
#'
#' @return A vector of colors
#'
#' @export
#' @importFrom randomcoloR distinctColorPalette
#' @examples
#' getQualitativePalette(5)
getQualitativePalette <- function(nbcolors){
  nbcolors <- round(nbcolors)
  switch(as.character(nbcolors),
         "1"=c("#4477AA"),
         "2"=c("#4477AA", "#CC6677"),
         "3"=c("#4477AA", "#DDCC77", "#CC6677"),
         "4"=c("#4477AA", "#117733", "#DDCC77", "#CC6677"),
         "5"=c("#332288", "#88CCEE", "#117733", "#DDCC77", "#CC6677"),
         "6"=c("#332288", "#88CCEE", "#117733", "#DDCC77", "#CC6677","#AA4499"),
         "7"=c("#332288", "#88CCEE", "#44AA99", "#117733", "#DDCC77", "#CC6677",
               "#AA4499"),
         "8"=c("#332288", "#88CCEE", "#44AA99", "#117733", "#999933", "#DDCC77",
               "#CC6677","#AA4499"),
         "9"=c("#332288", "#88CCEE", "#44AA99", "#117733", "#999933", "#DDCC77",
               "#CC6677", "#882255", "#AA4499"),
         "10"=c("#332288", "#88CCEE", "#44AA99", "#117733", "#999933", 
                "#DDCC77", "#661100", "#CC6677", "#882255", "#AA4499"),
         "11"=c("#332288", "#6699CC", "#88CCEE", "#44AA99", "#117733", 
                "#999933", "#DDCC77", "#661100", "#CC6677", "#882255", 
                "#AA4499"),
         "12"=c("#332288", "#6699CC", "#88CCEE", "#44AA99", "#117733", 
                "#999933", "#DDCC77", "#661100", "#CC6677", "#AA4466", 
                "#882255", "#AA4499"),
         "13"=c("#882E72", "#B178A6", "#1965B0", "#5289C7", "#7BAFDE", 
                "#4EB265", "#90C987", "#CAE0AB", "#F7EE55", "#F6C141", 
                "#F1932D", "#E8601C", "#DC050C"),
         "14"=c("#882E72", "#B178A6", "#D6C1DE", "#1965B0", "#5289C7", 
                "#7BAFDE", "#4EB265", "#90C987", "#CAE0AB", "#F7EE55", 
                "#F6C141", "#F1932D", "#E8601C", "#DC050C"),
         "15"=c("#114477", "#4477AA", "#77AADD", "#117755", "#44AA88", 
                "#99CCBB", "#777711", "#AAAA44", "#DDDD77", "#771111", 
                "#AA4444", "#DD7777", "#771144", "#AA4477", "#DD77AA"),
         "16"=c("#114477", "#4477AA", "#77AADD", "#117755", "#44AA88", 
                "#99CCBB", "#777711", "#AAAA44", "#DDDD77", "#771111", 
                "#AA4444", "#DD7777", "#771144", "#AA4477", "#DD77AA", "black"),
         distinctColorPalette(nbcolors)
  )
}


.getTrueLabelsFromNames <- function(x){
  if(is.null(names(x))) return(NULL)
  tl <- vapply(strsplit(names(x),".",fixed=TRUE), FUN.VALUE=character(1),
               FUN=function(x) x[[1]])
  names(tl) <- names(x)
  tl
}

#' farthestPoint
#'
#' Identifies the point farthest from a line passing through by the first and 
#' last points. Used for automatization of the elbow method.
#'
#' @param y Monotonically inscreasing or decreasing values
#' @param x Optional x coordinates corresponding to `y` (defaults to seq)
#'
#' @return The value of `x` farthest from the diagonal.
#' @export
#'
#' @examples
#' y <- 2^(10:1)
#' plot(y)
#' x <- farthestPoint(y)
#' points(x,y[x],pch=16)
farthestPoint <- function(y, x=NULL){
  if(is.null(x)) x <- seq_len(length(y))
  d <- apply( cbind(x,y), 1, 
              a=c(1,y[1]), b=c(length(y),rev(y)[1]), 
              FUN=function(y, a, b){
                v1 <- a-b
                v2 <- y-a
                abs(det(cbind(v1,v2)))/sqrt(sum(v1*v1))
              })
  order(d,decreasing=TRUE)[1]
}

def.filter <- function(x, minCounts=10){
  minCounts <- as.numeric(minCounts)
  x[filterByExpr(assay(x), model.matrix(~x$condition), min.count=minCounts),]
}

dea.edgeR <- function(x, mm, return.fit=FALSE){
  library(edgeR)
  dds <- calcNormFactors(DGEList(assay(x)))
  dds <- estimateDisp(dds, mm)
  fit <- glmFit(dds, mm)
  if(return.fit) return(fit)
  as.data.frame(topTags(glmLRT(fit, "condition"), Inf))
}

dea.edgeR.QLF <- function(x, mm){
  library(edgeR)
  dds <- calcNormFactors(DGEList(assay(x)))
  dds <- estimateDisp(dds, mm)
  res <- topTags(glmQLFTest(glmQLFit(dds, mm), "condition"), Inf)
  as.data.frame(res)
}

dea.voom <- function(x, mm){
  library(limma)
  library(edgeR)
  dds <- calcNormFactors(DGEList(assay(x)))
  v <- voom(dds, mm)
  fit <- eBayes(lmFit(v, mm), robust=TRUE)
  as.data.frame(topTable(fit, "condition", Inf))
}

dea.DESeq2 <- function(x, mm){
  library(DESeq2)
  dds <- DESeqDataSetFromMatrix(round(assay(x)), colData(x), design=mm)
  dds <- DESeq(dds)
  as.data.frame(results(dds, name = "condition"))
}

none <- function(x, ...)  return(x)

sva.vstsva <- function(x, k=NULL){
  library(sva)
  library(DESeq2)
  dds <- DESeqDataSetFromMatrix( round(assay(x)), as.data.frame(colData(x)), 
                                 design=~condition )
  dds <- estimateSizeFactors(dds)
  en <- as.matrix(assay(vst(dds, blind = FALSE)))
  sv <- .svawrap(en, model.matrix(~x$condition), k, fn=sva::sva)
  if(!is.null(sv)) colData(x) <- cbind(colData(x), sv)
  x
}

sva.svaseq <- function(x, k=NULL){
  library(sva)
  sv <- .svawrap(.normcounts(assay(x)), model.matrix(~x$condition), k=k, 
                 fn=sva::svaseq)
  if(!is.null(sv)) colData(x) <- cbind(colData(x), sv)
  x
}

.svawrap <- function(x, mm, k=NULL, fn=sva::sva){
  if(is.null(k) || is.na(suppressWarnings(as.integer(k)))){
    if(is.null(k)){
      k <- "be"
    }else{
      k <- match.arg(k, c("be","leek"))
    }
    sv <- fn(x, mm, numSVmethod = k)
  }else{
    sv <- fn(x, mm, n.sv = as.integer(k))
  }
  if(sv$n.sv==0) return(NULL)
  colnames(sv$sv) <- paste0("SV", seq_len(ncol(sv$sv)))
  sv$sv
}

sva.RUVr <- function(x, k=NULL){
  library(RUVSeq)
  if(is.null(k) || is.na(suppressWarnings(as.integer(k)))) k <- 1
  mm <- model.matrix(~x$condition)
  resid <- residuals(dea.edgeR(x, mm, return.fit=TRUE), type="deviance")
  ruv <- RUVSeq::RUVr(round(.normcounts(assay(x))), row.names(x), resid, 
              k=as.integer(k))
  ruv <- ruv$W
  colnames(ruv) <- paste0("SV", seq_len(ncol(ruv)))
  colData(x) <- cbind(colData(x), ruv)
  x
}

sva.RUVs <- function(x, k=NULL){
  library(RUVSeq)
  if(is.null(k) || is.na(suppressWarnings(as.integer(k)))) k <- 1
  ri <- split(seq_len(ncol(x)), x$condition)
  ri <- lapply(ri, dr=max(sapply(ri, length)), FUN=function(x, dr){
    c(x,rep(-1,length(x)-dr))
  })
  ri <- do.call(rbind, ri)
  ruv <- RUVs(round(.normcounts(assay(x))), row.names(x), ri, k=as.integer(k))
  ruv <- ruv$W
  colnames(ruv) <- paste0("SV", seq_len(ncol(ruv)))
  colData(x) <- cbind(colData(x), ruv)
  x
}

.normcounts <- function(x){
  library(edgeR)
  if(is(x,"SummarizedExperiment")) x <- assay(x)
  d <- calcNormFactors(DGEList(x))
  return( edgeR::cpm(d, normalized.lib.sizes=TRUE) * 
            mean(d$samples$lib.size)/1000000 )
}

# Most of this code is from the R implementation of molecular cross-validation
# by Matthew Young ( https://github.com/constantAmateur/MCVR/blob/master/code.R 
#, commit c4caf93), with few modifications

library(Matrix)
library(Seurat)

MCVR <- function(se, verbose=FALSE, tFracs=1, nSplits=2, BPPARAM=NULL, ...){
  if(!is(se, "Seurat") || length(VariableFeatures(se))==0)
    stop("`se` should be a Seurat object with computed variable features.")
  se <- SetAssayData(se, slot="counts", new.data=floor(GetAssayData(se, slot="counts")))
  if(is.null(Misc(se, "norm.function"))){
    if(verbose) warning("No normalization function specified, will use standard Seurat normalization")
    nf <- function(x,...){
      ScaleData(NormalizeData(x,verbose=FALSE),verbose=FALSE)
    }
  }else{
    nf <- Misc(se, "norm.function")
  }
  if(verbose){
    if(is.null(Misc(se, "pca.function")))
      warning("No PCA function specified, will use irlba-approximated PCA")
    if(is.null(BPPARAM)) BPPARAM <- SerialParam(progressbar=TRUE)
  }else{
    if(is.null(BPPARAM)) BPPARAM <- SerialParam()
  }
  mcv <- suppressWarnings({
    molecularCrossValidation(se, nf, Misc(se, "pca.function"), tFracs=tFracs, 
                             BPPARAM=BPPARAM, nSplits=nSplits, verbose=verbose)
  })
  if(verbose) plotMCV(mcv)
  k <- max(mcv$minimas, na.rm=TRUE)
  if(is.na(k) || is.infinite(k)) k <- ncol(Embeddings(se))
  if(k<2) k <- 2
  k
}

#' Create test and training data splits.
#'
#' Splits sample of full molecular pool into two samples from larger molecular pool (for test and training), accounting for the overlap between samples (p).
#'
#' @param src The input source matrix.
#' @param alpha Ratio of training to test fraction.
#' @param p Fraction of total molecules sampled.
#' @param tFrac Titration fraction.
#' @return Two sparse matrices, one for the test, one for the training.
partitionData = function(src,alpha,p,tFrac){
  #Do we need to titrate?  If so do that first.
  src = as(src,'dgTMatrix')
  x = src@x
  i = src@i
  j = src@j
  if(tFrac<1)
    x = rbinom(length(x),x,tFrac)
  #Adjust p by titration fraction
  p = p *tFrac
  #Now work out p' and p''
  p1 = (1+alpha-sqrt((1+alpha)**2-4*alpha*p))/(2*alpha)
  p2 = p1*alpha
  #Construct the training sample
  trx = rbinom(length(x),x,p1/p)
  #Construct the test sample, including an overlap adjustment.
  tsx = x-trx + rbinom(length(trx),trx,p2)
  #Reformat the training data into the matrix
  w = which(trx>0)
  train = sparseMatrix(x=trx[w],i=i[w]+1,j=j[w]+1,dims=dim(src),dimnames=dimnames(src))
  #Reformat the test data i nto the matrix
  w = which(tsx>0)
  tst = sparseMatrix(x=tsx[w],i=i[w]+1,j=j[w]+1,dims=dim(src),dimnames=dimnames(src))
  return(list(tst,train))
}


#' Finds the optimal number of PCs to use
#'
#' Uses molecular cross validation method (https://www.biorxiv.org/content/10.1101/786269v1), which must be applied to raw count data, to determine the optimal number of PCs to use for a given data-set.  This is intended to be run as part of a Seurat v2 workflow, but is written so that it can be used in a general context.  If supplying a seurat object, FindVariableGenes must have been run, otherwise a set of genes on which to perform the principal component analysis must be supplied.
#'
#' Arbitrary normalisation requires equal splits of data.  To check that 50/50 split does not unde-estimate the number of PCs, it is useful to perform a series of "titrations" of tha data, to check the number of PCs is not sensative to the sampling depth.  There is no relationship between the optimum number of PCs for un-normalised data and normalised data, so it is best to live with the limitations of normalising data (50/50 split, need to titrate) than to do find the optimum for a type of normalisation you will not use in practice.
#' 
#' This function was taken from the code of Matthew Young ( https://github.com/constantAmateur/MCVR/blob/master/code.R , commit c4caf93), with some modifications to:
#' i) accept a Seurat object as input, ii) multithread, iii) use custom PCA implementations, iv) fix irlba error.
#'
#' @param se A Seurat object
#' @param normalisation Normalization function to use, with a Seurat object as both input and output
#' @param pcamethod PCA function to use, with a Seurat object as both input and output 
#' @param trainFrac Fraction of data to be used for training.
#' @param p Fraction of total molecules sampled in experiment.
#' @param tFracs Titration fractions.  A vector indicating how to sub-sample the data to test if results are sensative to the depth of sampling.  If NULL, just run one version with all the data.
#' @param nSplits The number of random splits of the data to performe.
#' @param maxPCs Check up to this many PCs.
#' @param errorMetric Type of error to calculate.  Options are mse for mean squared erorr, or poisson, which calculates something proportional to the mean poisson log likelihood.
#' @param poissonMin If the PCs predict a number of counts below this value, use this instead to prevent infinite log-likelihood and penalise predicting zeros/negative values. 
#' @param confInt Used in quantifying the sampling error.  The function returns any PC that is within this confidence interval of the  minimum mean error.
#' @param verbose Logical; whether to print info on progress
#' @param BPPARAM Used to multithread; defaults to serial.
#' @param ... Extra parameters passed to PCA function.
#' @return A list.  Contains the average error across all cells for each titration and split of the data and various summaries thereof. 
molecularCrossValidation = function(se, normalisation, pcamethod=NULL, trainFrac=0.5, p=0.01, tFracs=c(1,0.8,0.5), nSplits=5,
                                    maxPCs=NULL,errorMetric=c('mse','poisson'),poissonMin=1e-6,confInt=0.95,verbose=FALSE,
                                    BPPARAM=SerialParam(progressbar=verbose), ...){
  errorMetric = match.arg(errorMetric)
  if(!is(se, "Seurat") || length(VariableFeatures(se))==0)
    stop("`se` should be a Seurat object with computed variable features.")
  if(is.null(maxPCs)) maxPCs <- min(100, ncol(Embeddings(se)))
  if(is.null(tFracs))
    tFracs=1
  titrate = length(tFracs)>1 || tFracs<1
  #Convert to number std. errors
  nSEs = qnorm(confInt/2 +0.5)
  #Convert to sparse Matrix of a useful type
  dat <- GetAssayData(se, slot="counts")
  dat = as(dat,'dgTMatrix')
  #Check that input data are integer counts
  if(any(dat@x%%1!=0))
    stop("Input matrix must contain only integers.")
  #If normalisation is on, have to do equal splits so we don't need to calculate complicated scale factor
  if(!identical(normalisation,identity)){
    #Arbitrary normalisation, have to have 50/50 split.
    if(trainFrac!=0.5){
      warning("Arbitrary normalisation requires equal splits of data. Setting trainFrac=0.5")
      trainFrac=0.5
    }
    if(!titrate){
      warning("When performing arbitrary normalisation it is useful to perform several titrations (by setting tFracs) to ensure results are not sensative to depth.  Consider re-running with tFracs set.")
    }
    if(errorMetric=='poisson')
      warning("Poisson error is not appropriate for non-count data.  Ensure your normalisation produces counts if you wish to proceed with this error profile.")
  }
  #Work out alpha
  alpha = (1-trainFrac)/trainFrac
  titrates = list()
  for(tFrac in tFracs){
    if(verbose && titrate)
      message(sprintf("Running with %d%% of data",tFrac*100))
    #Calculate correction factor alpha
    mse = matrix(NA,nrow=nSplits,ncol=maxPCs-1)
    colnames(mse) = seq(2,maxPCs)
    rownames(mse) = paste0("Split",seq(nSplits))
    for(i in seq(nSplits)){
      if(verbose) message(sprintf("Performing split %d of %d",i,nSplits)) 
      tst <- partitionData(dat,alpha,p,tFrac)
      #Normalise data
      train <- normalisation(CreateSeuratObject(tst[[2]]))
      tst <- GetAssayData(normalisation(CreateSeuratObject(tst[[1]])),slot="scale.data")
      # in case genes get kicked out by the normalization procedure (e.g. sctransform):
      varGenes <- intersect(VariableFeatures(se), row.names(tst))
      varGenes <- intersect(varGenes, row.names(GetAssayData(train, slot="scale.data")))
      VariableFeatures(train) <- varGenes
      tst <- tst[varGenes,]
      #Run PCA on training data.
      if(verbose) message("Running PCA and cross-validating")
      if(is.null(pcamethod)){
        pca = irlba::prcomp_irlba(GetAssayData(train, slot="scale.data")[varGenes,],center=FALSE,n=maxPCs)
        rot = t(pca$rotation)
        embed = pca$x
      }else{
        pca <- pcamethod(train, dims=maxPCs, weight.by.var=TRUE, ...)
        rot <- t(Loadings(pca))
        embed <- Embeddings(pca)
      }
      mse[i,] <- unlist(bplapply(seq(maxPCs,2),BPPARAM=BPPARAM,FUN=function(k){
        tmp = embed[,seq(k)] %*% rot[seq(k),]
        if(!all(dim(tmp)==dim(tst))) tmp <- t(tmp)
        #Mean squared error
        if(errorMetric=='mse'){
          return(mean((tmp*alpha-tst)**2))
        }else if(errorMetric=='poisson'){
          a = as.vector(tmp*alpha)
          b = as.vector(tst)
          #Fix those that are below minimum
          a[a<poissonMin]=poissonMin
          #Calculate poisson negative log likelihood
          return(-1*mean(dpois(b,a,log=TRUE)))
        }
      }))
    }
    titrates[[length(titrates)+1]] = mse
  }
  #Now work out which PC did the best
  #Work out mean and limits
  lower = do.call(cbind,lapply(titrates,apply,2,min))
  means = do.call(cbind,lapply(titrates,apply,2,mean))
  upper = do.call(cbind,lapply(titrates,apply,2,max))
  #Get the minima for each
  mins = seq(2,maxPCs)[apply(means,2,which.min)]
  #Get the standard error of each estimate
  ses = lapply(titrates,function(e) apply(e,2,sd)/sqrt(nSplits))
  ses = do.call(cbind,ses)
  #Find out the PCs that are within x standard errors of the minimum mean error
  seMins = t(t(means-nSEs*ses) <= apply(means,2,min))
  seMins = apply(seMins,2,which)
  #Ensure formating the same
  if(length(titrates)==1){
    seMins = list(as.numeric(rownames(seMins)))
  }else{
    seMins = lapply(seMins,function(e) as.numeric(names(e)))
  }
  if(length(titrates)==1)
    titrates=titrates[[1]]
  out = list(errors = titrates,
             means = means,
             lower = lower,
             upper = upper,
             minimas = mins,
             mins1sd = seMins,
             titrations = tFracs
             )
  return(out)
}

#' Plots summary of MCV run
#' 
#' Plots normalised loss curves for each titration of data as returned by molecularCrossValidation.
#' 
#' @param mcv Output of molecularCrossValidation.
#' @param cols Colours to apply to each titration line.
#' @return Nothing.  Produces a plot.
plotMCV = function(mcv,cols=seq(ncol(mcv$lower))){
  pcs = as.numeric(rownames(mcv$means))
  titrates = mcv$errors
  if(!is.list(titrates))
    titrates = list(titrates)
  #Work out normalisation factors
  normFacs = apply(mcv$lower,2,min)
  #Define plot area
  yRange = c(1,max(t(mcv$upper)/normFacs))
  layout(matrix(c(1,1,2),nrow=3))
  plot(0,0,type='n',xlab='Number of PCs',ylab='avg error / min avg error',ylim=yRange,xlim=range(pcs),frame.plot=FALSE,main='Error profiles')
  #Make lower,middle and upper plots
  for(i in seq_along(titrates)){
    lines(pcs,mcv$lower[,i]/normFacs[i],col=cols[i],lty=2)
    lines(pcs,mcv$means[,i]/normFacs[i],col=cols[i])
    lines(pcs,mcv$upper[,i]/normFacs[i],col=cols[i],lty=2)
  }
  #abline(v=mcv$minimas,col=seq(ncol(x)))
  legend(mean(mcv$minimas),yRange[2],legend=paste0(round(mcv$titrations*100),'% Data (Min = ',mcv$minimas,')'),col=cols,lty=1)
  tryCatch({
    plot(mcv$titrations*100,mcv$minimas,pch=19,xlab='Data percentage',ylab='Optimal #PCs',main='Convergance',ylim=range(pcs[unlist(mcv$mins1sd)]))
    lines(mcv$titrations*100,mcv$minimas)
    #Add error bars
    arrows(mcv$titrations*100, pcs[sapply(mcv$mins1sd,min)], mcv$titrations*100,pcs[sapply(mcv$mins1sd,max)], length=0.05, angle=90, code=3)
  }, error=function(e) NULL)
}

#' pipeComp - a framework for pipeline benchmarking
#'
#' \pkg{pipeComp} is a simple framework to facilitate the comparison of 
#' pipelines involving various steps and parameters. It was initially developed 
#' to benchmark single-cell RNA sequencing pipelines, and contains pre-defined
#' \code{\link{PipelineDefinition}}s and functions to that effect, but could be
#' applied to any context. See `vignette("pipeComp")` for an introduction.
#'
#' @author Pierre-Luc Germain \email{pierre-luc.germain@hest.ethz.ch}
#' @author Anthony Sonrel \email{anthony.sonrel@uzh.ch}
#' @author Mark D. Robinson \email{mark.robinson@@imls.uzh.ch}
#' @name pipeComp-package
#' @aliases pipeComp
#' @docType package
NULL


#' runPipeline
#' 
#' This function runs a pipeline with combinations of parameter variations on 
#' nested steps. The pipeline has to be defined as a list of functions applied 
#' consecutively on their respective outputs. See 'examples' for more details. 
#'
#' @param datasets A named vector of initial objects or paths to rds files.
#' @param alternatives The (named) list of alternative values for each 
#' parameter.
#' @param pipelineDef An object of class \code{\link{PipelineDefinition}}.
#' @param comb An optional matrix of indexes indicating the combination to run. 
#' Each column should correspond to an element of `alternatives`, and contain 
#' indexes relative to this element. If omitted, all combinations will be 
#' performed.
#' @param output.prefix An optional prefix for the output files.
#' @param nthreads Number of threads, default 1. If the memory requirements are
#' very high or the first steps very long to compute, consider setting this as
#' the number of datasets or below.
#' @param saveEndResults Logical; whether to save the output of the last step.
#' @param debug Logical (default FALSE). When enabled, disables multithreading 
#' and prints extra information.
#' @param skipErrors Logical. When enabled, `runPipeline` will
#' continue even when an error has been encountered, and report the list of 
#' steps/datasets in which errors were encountered.
#' @param ... passed to MulticoreParam. Can for instance be used to set 
#' `makeCluster` arguments, or set `threshold="TRACE"` when debugging in a 
#' multithreaded context.
#'
#' @examples 
#' pip <- mockPipeline()
#' datasets <- list( ds1=1:3, ds2=c(5,10,15) )
#' tmpdir1 <- paste0(tempdir(),"/")
#' res <- runPipeline(datasets, pipelineDef=pip, output.prefix=tmpdir1,
#'                    alternatives=list() )
#' # See the `pipeComp_scRNA` vignette for a more complex example
#' 
#' @return A SimpleList with elapsed time and the results of the evaluation 
#' functions defined by the given `pipelineDef`.
#' 
#' The results are also stored in the output folder with: 
#' \itemize{
#' \item The clustering results for each dataset (`endOutputs.rds` files),
#' \item A SimpletList of elapsed time and evaluations for each dataset 
#'  (`evaluation.rds` files),
#' \item A list of the `pipelineDef`, `alternatives`, `sessionInfo()` and
#'  function call used to produce the results (`runPipelineInfo.rds` file),
#' \item A copy of the SimpleList returned by the function 
#'  (`aggregated.rds`file). 
#' }
#' 
#' @importFrom utils sessionInfo
#' @import methods BiocParallel S4Vectors
#' @export
runPipeline <- function( datasets, alternatives, pipelineDef, comb=NULL, 
                         output.prefix="", nthreads=1, saveEndResults=TRUE, 
                         debug=FALSE, skipErrors=TRUE, ...){
  mcall <- match.call()
  if(!is(pipelineDef,"PipelineDefinition")) 
    pipelineDef <- PipelineDefinition(pipelineDef)
  alternatives <- .checkPipArgs(alternatives, pipelineDef)
  pipDef <- stepFn(pipelineDef, type="functions")
  
  if(is.null(names(datasets)))
    names(datasets) <- paste0("dataset",seq_along(datasets))
  if(any(grepl(" ",names(datasets)))) 
    stop("Dataset names should not have spaces.")
  if(any(grepl("\\.",names(datasets)))) 
    warning("It is recommended not to use dots ('.') in dataset names to 
            facilitate browsing aggregated results.")
  
  # check that output folder exists, otherwise create it
  if(output.prefix!=""){
    x <- gsub("[^/]+$","",output.prefix)
    if(x!="" && !dir.exists(x)) dir.create(x, recursive=TRUE)
  }
  
  # prepare the combinations of parameters to use
  alt <- alternatives[unlist(arguments(pipelineDef))]
  if(is.null(comb)){
    eg <- buildCombMatrix(alt, TRUE)
  }else{
    eg <- .checkCombMatrix(comb, alt)
  }
  names(dsnames) <- dsnames <- names(datasets)
  
  if(!debug){
    if(any( class(nthreads) %in% 
            c("SnowParam","MulticoreParam","SerialParam") )){
      bpp <- nthreads
      nthreads <- bpnworkers(bpp)
    }else{
      bpp <- MulticoreParam(nthreads, ...)
    }
    message(paste("Running", nrow(eg), "pipeline settings on", length(datasets),
                  "datasets using", nthreads,"threads"))
  }else{
    nthreads <- 1
    bpp <- SerialParam()
  }
    
  if(!debug && nthreads>length(datasets)){
    # splitting downstream of datasets
    egs <- .splitEG(names(datasets), eg, nthreads)
    dsnames <- rep(names(datasets),each=length(egs))
    resfiles <- bpmapply( dsi=dsnames, eg=egs, BPPARAM=bpp,
                          FUN=function(dsi, eg) tryCatch(
                            .runPipelineF( dsi, datasets[[dsi]], pipelineDef, 
                                           alt, eg, output.prefix, noWrite=TRUE,
                                           saveEndResults=saveEndResults,
                                           skipErrors=skipErrors ),
                              error=function(e){
                                if(!skipErrors) stop(e)
                                cat(e)
                                NULL
                              })
                          )
    resfiles <- split(resfiles, dsnames)
    # reassembling and saving the results per dataset
    resfiles <- lapply(names(datasets), FUN=function(dsi){
      if(saveEndResults){
        res <- do.call(c, lapply(resfiles[[dsi]], FUN=function(x) x$res))
        saveRDS(res, file=paste0(output.prefix,"res.",dsi,".endOutputs.rds"))
      }
      if(length(resfiles[[dsi]])==1){
        res <- resfiles[[dsi]][[1]][c("evaluation", "elapsed")]
      }else{
        res <- resfiles[[dsi]][[1]]
        for(i in seq.int(from=2, to=length(resfiles[[dsi]]))){
          res <- .dsMergeResults(res, resfiles[[dsi]][[i]])
        }
      }
      metadata(res)$PipelineDefinition <- pipelineDef
      ifile <- paste0(output.prefix,"res.",dsi,".evaluation.rds")
      saveRDS(res, file=ifile)
      return(ifile)
    })
  }else if(!debug && nthreads>1 && length(datasets)>1){
    resfiles <- bptry(bplapply( dsnames, BPPARAM=bpp,
                          FUN=function(dsi){
                            tryCatch(
                    .runPipelineF(dsi, datasets[[dsi]], pipelineDef, alt, eg,
                                  output.prefix, saveEndResults=saveEndResults,
                                  skipErrors=skipErrors),
                                     error=function(e){
                                       print(e)
                                       if(debug) print(traceback())
                                       if(!skipErrors) stop(e)
                                       NULL
                                     })
                          }))
  }else{
    nthreads <- 1
    if(debug) message("Running in debug mode (single thread)")
    resfiles <- lapply( dsnames, FUN=function(dsi){
      .runPipelineF(dsi, datasets[[dsi]], pipelineDef, alt, eg, output.prefix, 
                    debug, saveEndResults=saveEndResults, skipErrors=skipErrors)
    })
  }

  message("
                Finished running on all datasets")
  
  # save pipeline and resolved functions
  pipinfo <- list( pipDef=pipelineDef,
                   alts=lapply(alt, FUN=function(x){ 
                     if(is.numeric(x)) return(x)
                     lapply(x,FUN=function(x){
                       tryCatch({
                           if(is.function(x)) return(x)
                           if(exists(x) && is.function(get(x))){
                             return(get(x))
                           }else{
                             return(x)
                           }
                         },
                         error=function(e) return(x)
                       )
                     })
                   }),
                   sessionInfo=sessionInfo(),
                   call=mcall
  )
  saveRDS(pipinfo, file=paste0(output.prefix,"runPipelineInfo.rds"))

  names(resfiles) <- names(datasets)
  res <- lapply(resfiles, readRDS)
  errs <- lapply(res, FUN=function(x) x$errors)
  if(length(unlist(errs))>0){
    errs <- errs[!vapply(errs, FUN.VALUE=logical(1L), FUN=is.null)]
    errs <- lapply(errs, .removeRedundantErrors)
    errs <- data.frame(dataset=rep(names(errs), lengths(errs)),
                       step=unlist(errs))
    row.names(errs) <- NULL
    message("
Some errors were encountered during the run:")
    print(errs)
    patt <- paste(paste0("^",gsub("([.()\\^{}+$*?]|\\[|\\])", "\\\\\\1", 
                                  unique(errs$step))), collapse="|")
    message("All results were saved, but only those of analyses successful ",
            "across all datasets will be retained for aggregation.")
    removeErrorSteps <- function(x){
      w <- grep(patt,names(x),invert=TRUE)
      if(is.data.frame(x)) return(x[w,,drop=FALSE])
      x[w]
    }
    res <- lapply(res, FUN=function(x){
      x$elapsed$stepwise <- lapply(x$elapsed$stepwise, removeErrorSteps)
      x$elapsed$total <- removeErrorSteps(x$elapsed$total)
      x$evaluation <- lapply(x$evaluation, removeErrorSteps)
      x
    })
  }
  message("
                Aggregating results...")
  res <- aggregatePipelineResults(res, pipelineDef)
  saveRDS(res, file=paste0(output.prefix,"aggregated.rds"))
  res
}


.runPipelineF <- function( dsi, ds, pipelineDef, alt, eg, output.prefix,
                           debug=FALSE, saveEndResults=FALSE, noWrite=FALSE,
                           skipErrors=FALSE ){
  
  if(debug) message(dsi)
  
  pipDef <- stepFn(pipelineDef, type="functions")
  args <- arguments(pipelineDef)
  
  ds <- tryCatch( stepFn(pipelineDef, type="initiation")(ds),
                  error=function(e){
                    stop("Error trying to initiate dataset ", dsi,"
",e)
                  })
  
  elapsed <- lapply(pipDef, FUN=function(x) list())
  elapsed.total <- list()
  
  objects <- c(list(BASE=ds),lapply(args[-length(args)],FUN=function(x)NULL))
  intermediate_return_objects <- lapply(args, FUN=function(x) list() )
  run.errors <- c()
  rm(ds)
  
  res <- vector(mode="list", length=nrow(eg))
  for(n in seq_len(nrow(eg))){
    newPar <- as.numeric(eg[n,])
    aa <- paste( mapply(an=names(alt), a=alt, i=newPar, 
                        FUN=function(an,a,i) paste0(an,"=",a[i]) )
                 ,collapse=", ")
    if(debug){
      message("
                ####################
                # Iteration ",n,"
                # ", aa)
    }
    if(n==1){
      oldPar <- rep(0,ncol(eg))
    }else{
      oldPar <- as.numeric(eg[n-1,])
    }
    # identify the first parameters that changes and the corresponding step
    chParam <- names(alt)[which(newPar!=oldPar)[1]]
    wStep <- which(vapply(args,FUN=function(x){ chParam %in% x },logical(1)))
    # fetch the object from the previous step)
    while( (w <- which(names(objects)==names(args)[wStep])) && 
           (all(is.na(objects[[w-1]])) || is.null(objects[[w-1]])) && wStep > 2)
      wStep <- wStep-1 # to handle steps without parameter
    x <- objects[[w-1]]
    if(is.null(x)){
      # going back to original dataset
      x <- objects[[1]]
      wStep <- 1
    }
    # proceed with the remaining steps of the pipeline
    for(step in names(args)[seq.int(from=wStep, to=length(args))]){
      if(debug) message(step)
      # prepare the arguments
      a <- lapply(args[[step]], FUN=function(a){
        alt[[a]][newPar[which(colnames(eg)==a)]]
      })
      names(a) <- args[[step]]
      #a$x <- x
      #x <- do.call(pipDef[[step]], a)   ## unknown issue with do.call...
      fcall <- .mycall(pipDef[[step]], a)
      if(debug) message(fcall)
      st <- Sys.time()
      if(length(x)>1 || !is.na(x))
        x <- tryCatch( eval(fcall),
                       error=function(e){
                         .pipError(x, e, step, pipDef, fcall, newPar, 
                                   output.prefix, dsi, aa, debug,
                                   continue=skipErrors)
                       })
        
      # name the current results on the basis of the previous steps:
      ws <- seq_len(sum( vapply(args[seq_len(which(names(args)==step))], 
                                length, integer(1)) ))
      ename <- .args2name(newPar[ws], alt[ws])
      # save elapsed time for this step
      elapsed[[step]][[ename]] <- as.numeric(Sys.time()-st)
      if(is.null(x) || (length(x)==1 && is.na(x))){
        run.errors <- c(run.errors, ename)
        x <- NA
      }else{
        # save eventual intermediate objects (e.g. step evaluation)
        if(is.list(x) && all(c("x","intermediate_return") %in% names(x))){
          intermediate_return_objects[[step]][[ename]] <- x$intermediate_return
          x <- x$x
        }else{
          if(!is.null(stepFn(pipelineDef, step, "evaluation"))){
            intermediate_return_objects[[step]][[ename]] <- tryCatch(
              stepFn(pipelineDef, step, "evaluation")(x),
              error=function(e){
                fcall <- 'stepFn(pipelineDef, step, "evaluation")(x)'
                .pipError(x, e, step, pipDef, fcall, newPar, output.prefix, dsi,
                          aa, debug, continue=skipErrors)
              })
          }
        }
      }
      objects[[step]] <- x
    }
    
    # compute total time for this iteration
    elapsed.total[[n]] <- sum(vapply(names(args),FUN=function(step){
      ws <- seq_len(sum( vapply(args[seq_len(which(names(args)==step))], 
                                length, integer(1)) ))
      ename <- .args2name(newPar[ws], alt[ws])
      elapsed[[step]][[ename]]
    }, numeric(1) ))
    
    # return final results
    res[[n]] <- x
  }
  
  if(debug) message("
                      Completed running all variations.")
  
  # set names as the combination of arguments
  names(res) <- apply(eg,1,alt=alt,FUN=.args2name)
  names(elapsed.total) <- names(res)
  
  if(noWrite){
    out <- SimpleList( evaluation=intermediate_return_objects,
                       elapsed=list( stepwise=elapsed, total=elapsed.total ) )
    if(saveEndResults) out$res <- res
    return(out)
  }
  if(saveEndResults)
    saveRDS(res, file=paste0(output.prefix,"res.",dsi,".endOutputs.rds"))
  
  res <- SimpleList( evaluation=intermediate_return_objects,
                     elapsed=list( stepwise=elapsed, total=elapsed.total ) )
  if(length(run.errors)>0) res$errors <- run.errors
  metadata(res)$PipelineDefinition <- pipelineDef
  
  ifile <- paste0(output.prefix,"res.",dsi,".evaluation.rds")
  saveRDS(res, file=ifile)
  return(ifile)
}



# build function call (for a step of runPipeline) from list of arguments
.mycall <- function(fn, args){
  if(is.function(fn)) fn <- deparse(match.call()$fn)
  args <- paste(paste(names(args), vapply(args, FUN=function(x){
    if(is.numeric(x)) return(as.character(x))
    paste0("\"",x,"\"")
  }, character(1)), sep="="), collapse=", ")
  if(args!="") args <- paste(",",args)
  parse(text=paste0(fn, "(x=x", args, ")"))
}

.checkPipArgs <- function(alternatives, pipDef=NULL){
  if(any(grepl(";|=",names(alternatives)))) 
    stop("Some of the pipeline arguments contain unaccepted characters ",
      "(e.g. ';' or '=').")
  if(any(vapply(alternatives, function(x) any(grepl(";|=",x)), logical(1))))
    stop("Some of the alternative argument values contain unaccepted ",
      "characters (e.g. ';' or '=').")
  if(!is.null(pipDef)){
    def <- defaultArguments(pipDef)
    for(f in names(alternatives)) def[[f]] <- alternatives[[f]]
    args <- arguments(pipDef)
    if(!all(unlist(args) %in% names(def))){
      missingParams <- setdiff(as.character(unlist(args)), names(def))
      stop("`alternatives` should have entries for the following slots defined",
        " in the pipeline: ", paste(missingParams ,collapse=", "))
    }
    if(!all( vapply(def, length, integer(1))>0)){
      stop("All steps of `alternatives` should contain at least one option.")
    }
    alternatives <- def
  }
  alternatives
}


.args2name <- function(x, alt){
  x2 <- mapply(a=alt,i=as.numeric(x),FUN=function(a,i) a[i])
  paste( paste0( names(alt), "=", x2), collapse=";" )
}

.pipError <- function(x, e, step, pipDef, fcall, newPar, output.prefix, dsi, aa, 
                      debug=TRUE, continue=FALSE){
  if(debug) save(x, step, pipDef, fcall, newPar, 
                 file=paste0(output.prefix,"runPipeline_error_TMPdump.RData"))
  msg <- paste0("Error in dataset `", dsi, "` with parameters:\n", aa, 
                "\nin step `", step, "`, evaluating command:\n`", 
                gsub("[[step]]",paste0('[["',step,'"]]'), fcall, fixed=TRUE), "`
                Error:\n", e, "\n", 
                ifelse(debug, paste0("Current variables dumped in ", 
                                     output.prefix,
                                     "runPipeline_error_TMPdump.RData"), ""))
  if(continue){
    cat( msg )
  }else{
    stop( msg )
  }
  NULL
}

.splitEG <- function(datasets, eg, nthreads, tol=1){
  # we find at which step to split to maximize cluster use
  eg <- as.data.frame(eg)
  for(i in seq_len(ncol(eg))){
    if(length(unique(eg[,i]))*length(datasets) >= (nthreads-tol)){
      return(split(eg, eg[,seq_len(i)]))
    }
  }
  split(eg, seq_len(nrow(eg)))
}

.removeRedundantErrors <- function(e){
  i <- 1
  while(i < length(e)){
    w <- i+grep(paste0("^",e[i]), e[-seq_len(i)])
    if(length(w)>0) e <- e[-w]
    i <- i + 1
  }
  e
}

#' scrna_evalPlot_silh
#' 
#' Plot a min/max/mean/median silhouette width heatmap from aggregated 
#' evaluation results of the `scrna_pipeline`.
#'
#' @param res Aggregated pipeline results (i.e. the output of `runPipeline` or
#' `aggregateResults`)
#' @param what What metric to plot, possible values are “minSilWidth”, 
#' “meanSilWidth” (default), “medianSilWidth”, or “maxSilWidth”.
#' @param step Name of the step for which to plot the evaluation results. 
#' Defaults to "dimreduction".
#' @param dims If multiple sets of dimensions are available, which one to use
#' (defaults to the first).
#' @param agg.by Aggregate results by these columns (default no aggregation)
#' @param agg.fn Function for aggregation (default mean)
#' @param filterExpr An optional filtering expression based on the columns of 
#' the target dataframe, (e.g. `filterExpr=param1=="value1"`).
#' @param value_format Format for displaying cells' values (no label by default)
#' @param reorder_rows Whether to sort rows (default FALSE). The row 
#' names themselves can also be passed to specify an order, or a 
#' `ComplexHeatmap`.
#' @param reorder_columns Whether to sort columns (default TRUE).
#' @param row_split Optional column (included in `agg.by`) by which to split
#' the rows. Alternatively, an expression using the columns (retained after
#' aggregation) can be passed.
#' @param show_heatmap_legend Passed to `Heatmap` (default FALSE)
#' @param show_column_names Passed to `Heatmap` (default FALSE)
#' @param col Colors for the heatmap
#' @param font_factor A scaling factor applied to fontsizes (default 1)
#' @param value_cols A vector of length 2 indicating the colors of the values
#' (above and below the mean), if printed
#' @param title Plot title
#' @param shortNames Logical; whether to use short row names (with only
#' the parameter values instead of the parameter name and value pairs), default
#' TRUE.
#' @param anno_legend Logical; whether to plot the legend for the datasets
#' @param ... Passed to `Heatmap`
#' 
#' @return A Heatmap
#' @export
#' @import ComplexHeatmap
#' @examples
#' data("exampleResults", package="pipeComp")
#' scrna_evalPlot_silh( exampleResults, agg.by=c("filt","norm"), 
#'                      row_split="norm" )
scrna_evalPlot_silh <- function( res, what=c("minSilWidth","meanSilWidth"), 
                                 step="dimreduction", dims=1, agg.by=NULL, 
                                 agg.fn=mean, filterExpr=NULL, value_format="", 
                                 reorder_rows=FALSE, reorder_columns=TRUE,
                                 show_heatmap_legend=TRUE, 
                                 show_column_names=FALSE, 
                                 col=rev(RColorBrewer::brewer.pal(n=11,"RdBu")),
                                 font_factor=0.9, row_split=NULL, 
                                 shortNames=TRUE, value_cols=c("white","black"),
                                 title=NULL, anno_legend=TRUE, ...){
  pd <- NULL
  if(is(res,"SimpleList")) pd <- metadata(res)$PipelineDefinition
  if(is.null(pd)) stop("Could not find the PipelineDefinition.")
  if(length(what)>1){
    fcall <- match.call()
    H <- NULL
    for(i in what){
      fcall$what <- i
      H <- H + eval(fcall)
    }
    return(H)
  }
  if(is(res,"SimpleList") && "evaluation" %in% names(res)) 
    res <- res$evaluation
  if(is(res,"list") && step %in% names(res))
    res <- res[[step]]
  if(is(res,"list") && "silhouette" %in% names(res))
    res <- res[["silhouette"]]
  res <- res[[dims]]
  what_options <- setdiff( colnames(res), 
                           c("dataset","subpopulation",unlist(arguments(pd))) )
  what <- match.arg(what, choices=what_options)
  res <- .prepRes(res, what=what, agg.by=agg.by, pipDef=pd, returnParams=TRUE,
                  filt=substitute(filterExpr), shortNames=shortNames)
  pp <- res$pp
  res <- as.matrix(res$res)
  ro <- .dosort(res, reorder_rows)
  if(reorder_columns)
    res <- res[,order(colMeans(res), decreasing=TRUE),drop=FALSE]
  
  cellfn <- .getCellFn(res, res, value_format, value_cols, font_factor)
  if(is.null(title)) title <- gsub("\\.","\n",what)
  suppressWarnings({
    if(!tryCatch(is.null(row_split), error=function(e) FALSE)){
      if(tryCatch(is.character(row_split), error=function(e) FALSE)){
        if(row_split %in% colnames(pp)){
          row_split <- pp[,row_split]
        }else{
          warning("`row_split` wasn't found and will be ignored.")
          row_split <- NULL
        }
      }else{
        row_split <- eval(substitute(row_split), envir=pp)
      }
    }
  })
  col <- .silScale(res, col)
  Heatmap( res, name=what, cluster_rows=FALSE, cluster_columns=FALSE, 
           show_heatmap_legend=show_heatmap_legend, row_order=ro,
           bottom_annotation=.ds_anno(colnames(res),anno_legend,font_factor), 
           show_column_names=show_column_names, cell_fun=cellfn, col=col,
           column_title=title, row_split=row_split,
           row_title_gp = gpar(fontsize = (14*font_factor)),
           column_title_gp = gpar(fontsize = (14*font_factor)),
           row_names_gp = gpar(fontsize = (12*font_factor)),
           column_names_gp = gpar(fontsize = (12*font_factor)), ...)
}

.getClustAggFields <- function(res, pipDef=NULL){
  if(is.null(pipDef)) pipDef <- metadata(res)$PipelineDefinition
  if("evaluation" %in% names(res)) res <- res$evaluation
  if("clustering" %in% names(res)) res <- res$clustering
  fields <- unlist(arguments(pipDef))
  fields <- setdiff(fields, c("k", "dims", "steps","resolution","min.size"))
  fields <- intersect(colnames(res), fields)
  fields[vapply( res[,fields,drop=FALSE], FUN=function(x) length(unique(x))>1,
                 logical(1) )]
}

.mergeFilterOut <- function(ll){
  ll <- lapply(ll, FUN=function(x){
    if(any(is.na(x$N.lost))){
      w <- which(is.na(x$N.lost))
      x$N.lost[w] <- x$N.before[w]
      x$pc.lost[w] <- 100
    }
    x
  })
  if(length(ll)==1){
    ll[[1]]$N <- ll[[1]]$N.before
    return(ll[[1]])
  }
  # get back the initial number of cells
  mm <- ll[[1]]
  for(i in seq_len(length(ll)-1)){
    f <- setdiff(colnames(ll[[i]]), c("N.before","N.lost","pc.lost"))
    suf <- paste0(".",names(ll)[i+0:1])
    if(i>1) suf[1] <- ""
    mm <- merge(mm, ll[[i+1]], by=f, suffixes=suf)
  }
  mm$N <- mm[,grep("N\\.before",colnames(mm))[1]]
  mm$N.lost <- rowSums(mm[,grep("N\\.lost",colnames(mm))])
  mm$pc.lost <- 100*mm$N.lost/mm$N
  mm
}

#' scrna_evalPlot_filtering
#'
#' @param res Aggregated pipeline results (i.e. the output of `runPipeline` or
#' `aggregateResults`)
#' @param steps Steps to include (default 'doublet' and 'filtering'); other 
#' steps will be averaged.
#' @param clustMetric Clustering accuracy metric to use (default `mean_F1``)
#' @param filterExpr An optional filtering expression based on the columns of 
#' the clustering evaluation (e.g. `filterExpr=param1=="value1"` or 
#' `filterExpr=n_clus==true.nbClusts`).
#' @param atNearestK Logical; whether to restrict analyses to those giving the 
#' smallest deviation from the real number of clusters (default FALSE).
#' @param returnTable Logical; whether to return the data rather than plot.
#' @param point.size Size of the points
#' @param ... passed to `geom_point`
#'
#' @return A ggplot, or a data.frame if `returnTable=TRUE`
#' @importFrom stats median
#' @import ggplot2
#' @export
#' @examples
#' data("exampleResults", package="pipeComp")
#' scrna_evalPlot_filtering(exampleResults)
scrna_evalPlot_filtering <- function(res, steps=c("doublet","filtering"), 
                                     clustMetric="mean_F1", filterExpr=TRUE,
                                     atNearestK=FALSE, returnTable=FALSE,
                                     point.size=2.2, ...){
  param_fields <- tryCatch(
    unlist(arguments(metadata(res)$PipelineDefinition)[steps]),
    error=function(e) unlist(arguments(scrna_pipeline())[steps]) )
  res <- res$evaluation
  co <- .mergeFilterOut(res[steps])
  coI <- co[,c("dataset",param_fields)]
  ci <- split(seq_len(nrow(co)), coI, drop=TRUE)
  agfns <- list(min.lost=min, mean.lost=mean, median.lost=median, max.lost=max)
  x <- as.data.frame(do.call(cbind, lapply( agfns, FUN=function(agf){
    vapply( ci, function(x) agf(co[x,"pc.lost"]), numeric(1) )
  })))
  x$total.lost <- vapply(ci, FUN=function(x) sum(co[x,"N.lost"]), numeric(1))
  x$pc.lost <- vapply( ci, FUN.VALUE=numeric(1), 
                       FUN=function(x) 100*sum(co[x,"N.lost"])/sum(co[x,"N"]) )
  x <- cbind(coI[vapply(ci, FUN=function(x) x[1], integer(1)),], x)
  # get clustering data
  cl <- res$clustering[eval(substitute(filterExpr), res$clustering),]
  
  if(atNearestK){
    cl$absdiff <- abs(cl$n_clus-cl$true.nbClusts)
    cl <- do.call(rbind, lapply(split(cl, cl$dataset), FUN=function(x){
      cl[cl$absdiff==min(cl$absdiff),]
    }))
  }
  
  cl <- aggregate( cl[,clustMetric,drop=FALSE], 
                   by=cl[,c("dataset",param_fields)], FUN=mean )
  m <- merge(cl, x, by=c("dataset",param_fields))
  m$method <- apply( m[,param_fields,drop=FALSE], 1, collapse="+", FUN=paste )
    
  if(returnTable) return(m)
  if( length(param_fields)==2 && 
      all(sort(param_fields)==c("doubletmethod","filt")) ){
    return(ggplot(m, aes(max.lost, mean_F1, colour=filt, shape=doubletmethod))+ 
      geom_point(size=point.size, ...) + facet_wrap(~dataset, scales="free") + 
      xlab("Max proportion of subpopulation excluded") +
      labs(colour="filter set", shape="doublet removal"))
  }
  ggplot(m, aes(max.lost, mean_F1, colour=method, shape=method)) + 
    geom_point(size=point.size, ...) + facet_wrap(~dataset, scales="free") + 
    xlab("Max proportion of subpopulation excluded")
}

#' scrna_describeDatasets
#' 
#' Plots descriptive information about the datasets
#'
#' @param sces A character vector of paths to SCE rds files, or a list of SCEs
#' @param pt.size Point size (for reduced dims)
#' @param ... Passed to geom_point()
#'
#' @return A plot_grid output
#'
#' @export
#' @import SingleCellExperiment scran scater ggplot2 scales
#' @importFrom SummarizedExperiment colData colData<-
#' @importFrom cowplot plot_grid
#' @importFrom RColorBrewer brewer.pal
#' @importFrom Rtsne Rtsne
#' @importFrom uwot umap
scrna_describeDatasets <- function(sces, pt.size=0.3, ...){
  if(is.null(names(sces))) names(sces) <- paste0("dataset",seq_along(sces))
  if(is.character(sces)){
    sces <- lapply(sces, FUN=function(x){
      sce <- readRDS(x)
      sce <- logNormCounts(sce)
      var.stats <- modelGeneVar(sce)
      sce <- denoisePCA(sce, technical=var.stats)
      reducedDim(sce, "tSNE") <- Rtsne(reducedDim(sce))$Y
      reducedDim(sce, "umap") <- umap(reducedDim(sce))
      sce
    })
  }
  tt <- lapply(sces, FUN=function(x) table(x$phenoid))
  cols <- lapply(tt, FUN=function(x){
    y <- getQualitativePalette(length(x))
    names(y) <- names(x)
    y
  })
  for(i in seq_along(sces)) 
    sces[[i]]$cluster <- cols[[i]][as.character(colData(sces[[i]])$phenoid)]
  cd <- lapply(sces, FUN=function(x) as.data.frame(colData(x)))
  names(cols2) <- cols2 <- unique(unlist(cols))
  noy <- theme( axis.line=element_blank(),axis.text.y=element_blank(),
                  axis.ticks.y=element_blank(), axis.title.y=element_blank(),
                  strip.background = element_blank(), legend.position = "none",
                  aspect.ratio = 1, axis.text=element_text(size=10),
                  plot.margin=margin(l=0,r=0))
  cs <- scale_fill_manual(values=cols2)
  d <- data.frame( dataset=rep(names(sces), vapply(tt, length, integer(1))), 
                   cluster=unlist(cols), nb=unlist(tt) )
  p1 <- ggplot(d, aes(x=cluster, y=nb, fill=cluster)) +
    geom_bar(stat = "identity") + scale_y_log10() + 
    facet_wrap(~dataset, scales="free_y", ncol=1, strip.position = "left") + 
    coord_flip() + ylab("Number of cells") + xlab("") +  noy + cs
  for(x in names(sces))
    colData(sces[[x]])$cluster <- 
      unlist(cols)[paste(x, colData(sces[[x]])$phenoid,sep=".")]
  d <- suppressWarnings(dplyr::bind_rows(lapply(cd, FUN=function(x) 
    x[,c("total_counts","total_features","cluster")]))
  )
  d$dataset <- rep(names(cd), vapply(cd, nrow, integer(1)))
  pf <- function(d, x) ggplot(d, aes_string(x="cluster", y=x, fill="cluster"))+ 
    geom_violin() + xlab("") + coord_flip() + noy + cs +
    facet_wrap(~dataset, scales="free_y", ncol=1) + 
    theme( strip.text.x = element_blank(), 
           panel.grid.major.x=element_line(color="grey", linetype="dashed")) + 
    scale_y_continuous( trans = 'log10', breaks=10^pretty(log10(d[[x]]),n=3), 
                        labels=trans_format('log10', math_format(10^.x)) )
  rd <- function(dimred,...){
    d2 <- cbind(d, do.call(rbind, lapply(sces, FUN=function(x){
      reducedDim(x,dimred)
    })))
    colnames(d2)[5:6] <- c("x","y")
    ggplot(d2, aes(x,y,col=cluster)) + geom_point(...) + 
      facet_wrap(~dataset, scales="free", ncol=1) + 
      scale_color_manual(values=cols2) + xlab(paste0("\n",dimred)) +
      theme(axis.line=element_blank(), axis.text=element_blank(),
            axis.ticks=element_blank(), axis.title.y=element_blank(),
            strip.background = element_blank(), strip.text.x=element_blank(),
            legend.position = "none", aspect.ratio = 1 )
  }
  p5 <- rd("umap", size=pt.size, ...)
  plot_grid( p1, pf(d,"total_counts"), pf(d,"total_features"), 
             rd("tSNE", size=pt.size, ...), rd("umap", size=pt.size, ...),
             nrow=1 )
}

#' @importFrom circlize colorRamp2
.silScale <- function(x, cols=NULL){
  if(is.null(cols)) cols <- rev(brewer.pal(n=11,"RdBu"))
  if(is.function(cols)) cols <- cols(11)
  if(length(cols)!=11) stop("`cols` should contain 11 colors.")
  bb <- c( -seq(from=sqrt(abs(min(x, na.rm=TRUE))), to=0, length.out=6)^2, 
           seq(from=0, to=sqrt(max(x, na.rm=TRUE)), length.out=6)[-1]^2 )
  colorRamp2(bb, cols)
}


#' scrna_evalPlot_overall
#' 
#' Plots a multi-level summary heatmap of many analyses of the `scrna_pipeline`.
#'
#' @param res Aggregated pipeline results (i.e. the output of `runPipeline` or
#' `aggregateResults`)
#' @param agg.by The paramters by which to aggregate.
#' @param width The width of individual heatmap bodies.
#' @param datasets_as_columnNames Logical; whether dataset names should be 
#' printed below the columns (except for silhouette) rather than using a
#' legend.
#' @param rowAnnoColors Optional list of colors for the row annotation variables
#' (passed to `HeatmapAnnotation(col=...)`)
#' @param column_names_gp Passed to each calls to `Heatmap`
#' @param column_title_gp Passed to each calls to `Heatmap`
#' @param heatmap_legend_param Passed to each calls to `Heatmap`
#' @param ... Passed to each calls to `Heatmap`
#'
#' @return A HeatmapList
#' @importFrom stats hclust
#' @export
#'
#' @examples
#' library(ComplexHeatmap)
#' data("exampleResults")
#' h <- scrna_evalPlot_overall(exampleResults)
#' draw(h, heatmap_legend_side="bottom")
scrna_evalPlot_overall <- function(res, agg.by=NULL, width=NULL, 
                              datasets_as_columnNames=TRUE, 
                              rowAnnoColors=NULL,
                              column_names_gp=gpar(fontsize=10),
                              column_title_gp=gpar(fontsize=12),
                              heatmap_legend_param=list( by_row=TRUE,
                                                direction="horizontal", nrow=1), 
                              ... ){
  a <- arguments(metadata(res)$PipelineDefinition)
  if(is.null(agg.by)){
    agg.by <- c(unlist(a[-length(a)]),c("clustmethod", "dims"))
    agg.by <- agg.by[sapply(agg.by, FUN=function(x) 
                              length(unique(res$evaluation$clustering[[x]]))>1)]
  }
  agg.by <- as.character(agg.by)
  if(!all(agg.by %in% unlist(a)))
    stop("`agg.by` should be a vector of pipeline parameters.")
  
  # dimred
  sil <- res$evaluation$dimreduction$silhouette
  if(is(sil,"list")) sil <- sil[[1]]
  ll <- lapply(c("minSilWidth", "meanSilWidth"), FUN=function(x){
    .prepRes( sil, what=x, agg.by=intersect(agg.by, colnames(sil)), 
              returnParams=TRUE, shortNames=TRUE, 
              pipDef=metadata(res)$PipelineDefinition )
  })
  pp1 <- ll[[1]]$pp
  pp1$method <- NULL
  ll1 <- lapply(ll, FUN=function(x) x$res)

  # clustering
  ll <- lapply(c("ARI", "MI"), FUN=function(x){
    .prepRes( res$evaluation$clustering, what=x, returnParams=TRUE, 
              agg.by=agg.by, shortNames=TRUE, 
              pipDef=metadata(res)$PipelineDefinition )
  })
  ll[[3]] <- .prepRes(res$evaluation$clustering, what="ARI", returnParams=TRUE,
                      agg.by=agg.by, filt=expr(true.nbClusts==n_clus), 
                      shortNames=TRUE, pipDef=metadata(res)$PipelineDefinition)
  pp <- ll[[1]]$pp
  pp$method <- NULL
  ll2 <- lapply(ll, FUN=function(x){
    x <- as.data.frame(x$res)
    x <- as.matrix(colCenterScale(x[row.names(pp),]))
    row.names(x) <- row.names(pp)
    x
  })
  
  # merge dimred and clust results
  tmp <- as.character(apply( pp[,colnames(pp1),drop=FALSE], 1, 
                             collapse=" > ",FUN=paste ))
  ll1 <- lapply(ll1, FUN=function(x){
    x <- x[tmp,]
    row.names(x) <- row.names(ll2[[1]])
    x
  })
  ll <- c(ll1,ll2)

  # get max % lost
  pclost <- scrna_evalPlot_filtering(res, returnTable=TRUE)
  filt.agg.by <- intersect(agg.by,unlist(a[1:2]))
  pclost <- aggregate( pclost[,"max.lost",drop=FALSE], 
                        pclost[,c(filt.agg.by,"dataset"),drop=FALSE], FUN=mean)
  if(length(filt.agg.by)>0){
    f <- as.formula(paste(paste(filt.agg.by,collapse="+"),"~dataset"))
    pclost <- reshape2::dcast(pclost, f, value.var="max.lost")
    row.names(pclost) <- apply( pclost[,seq_along(filt.agg.by),drop=FALSE], 1, 
                                collapse=" > ",FUN=paste )
    tmp <- as.character(apply( pp[,filt.agg.by,drop=FALSE], 1, collapse=" > ",
                               FUN=paste ))
    pclost <- pclost[tmp,setdiff(colnames(pclost), filt.agg.by),]
    row.names(pclost) <- row.names(ll2[[1]])
  }else{
    pclost <- matrix(pclost$max.lost, nrow=nrow(ll2[[1]]), ncol=nrow(pclost), 
                     byrow=TRUE, 
                     dimnames=list(row.names(ll2[[1]]), pclost$dataset))
  }
  pclost <- apply(pclost,1,FUN=max)
  
  ll2 <- list( list(mat=ll[[1]], title="min silh.\nwidth", 
                    cluster_columns=TRUE, name="silhouette width"),
               list(mat=ll[[2]], title="mean silh.\nwidth", 
                    cluster_columns=TRUE, show_heatmap_legend=FALSE),
               list(mat=ll[[3]], title="mean ARI", name="ARI (MADs)", 
                    cluster_columns=FALSE),
               list(mat=ll[[4]], title="mean MI", name="MI (MADs)", 
                    cluster_columns=FALSE),
               list(mat=ll[[5]], title="mean ARI\nat true k", 
                    name="ARI at true k (MADs)", cluster_columns=FALSE)
               )

  if("doubletmethod" %in% colnames(pp))
    pp$doubletmethod <- gsub("^doublet\\.","",pp$doubletmethod)
  if("clustmethod" %in% colnames(pp))
    pp$clustmethod <- gsub("^clust\\.","",pp$doubletmethod)
  for(f in c("filt","sel","norm")){
    if(f %in% colnames(pp)) pp[[f]] <- gsub(paste0("^",f,"\\."),"",pp[[f]])
  }
  if(is.null(rowAnnoColors)){
    ha <- HeatmapAnnotation( which="row",
                             "max\n% lost"=anno_barplot( pclost, bar_width=0.85, 
                                                         border=FALSE,
                                                         width=unit(1.5,"cm"),
                                                         gp=gpar(fill="#282828",
                                                                 col="#282828") ),
                             df=pp, annotation_legend_param=list("side"="right") )
  } else {
    ha <- HeatmapAnnotation( which="row", col=rowAnnoColors,
                             "max\n% lost"=anno_barplot( pclost, bar_width=0.85, 
                                                         border=FALSE,
                                                         width=unit(1.5,"cm"),
                                                         gp=gpar(fill="#282828",
                                                                 col="#282828") ),
                             df=pp, annotation_legend_param=list("side"="right") )
  }
  
  h <- hclust(dist(do.call(cbind, ll)))
  silhscale <- .silScale(cbind(ll2[[1]]$mat, ll2[[2]]$mat))
  H <- NULL
  for(i in seq_along(ll2)){
    if(i==1){
      hi <- h
    }else{
      hi <- FALSE
    }
    if(grepl("silh", ll2[[i]]$title)){
      col <- silhscale
      scn <- FALSE
    }else{
      col <- .defaultColorMapping(ll2[[i]]$mat, center=TRUE)
      scn <- datasets_as_columnNames
    }
    la <- ra <- NULL
    if(i==length(ll2)) ra <- ha
    ba <- .ds_anno(colnames(ll2[[i]]$mat), 
                   legend=(!datasets_as_columnNames && i==1))
    name <- ifelse(is.null(ll2[[i]]$name),ll2[[i]]$title,ll2[[i]]$name)
    wi <- ifelse(is.null(width), unit(ifelse(i<=2,3.2,2.5), "cm"), width)
    H <- H + Heatmap( ll2[[i]]$mat, name=name, cluster_rows=hi, 
                      show_row_names=FALSE, show_column_names=scn, 
                      heatmap_legend_param=heatmap_legend_param, 
                      column_title=ll2[[i]]$title, col=col, width=wi, 
                      cluster_columns=ll2[[i]]$cluster_columns, 
                      show_column_dend=FALSE, bottom_annotation=ba, 
                      left_annotation=la, right_annotation=ra, 
                      column_names_gp=column_names_gp,
                      column_title_gp=column_title_gp,
                      show_heatmap_legend=ifelse(
                        is.null(ll2[[i]]$show_heatmap_legend),TRUE,
                        ll2[[i]]$show_heatmap_legend), ... )
  }
  H
}

#' evaluateClustering
#'
#' Evaluates a clustering using 'true' labels. Entries with missing true labels
#' (i.e. NA) are excluded from calculations. If using `evaluteClustering` in a
#' custom pipeline, you might want to use the corresponding 
#' `pipeComp:::.aggregateClusterEvaluation` aggregation function.
#'
#' @param x The clustering labels
#' @param tl The true labels
#'
#' @return A numeric vector of metrics (see the `pipeComp_scRNA` vignette for 
#' details)
#' @importFrom aricode clustComp
#' @export
#' 
#' @examples
#' # random data
#' dat <- data.frame( 
#'  cluster=rep(LETTERS[1:3], each=10),
#'  x=c(rnorm(20, 0), rnorm(10, 1)),
#'  y=c(rnorm(10, 1), rnorm(20, 0))
#' )
#' # clustering
#' dat$predicted <- kmeans(dist(dat[,-1]),3)$cluster
#' # evaluation
#' evaluateClustering(dat$predicted, dat$cluster)
evaluateClustering <- function(x, tl=NULL){
  if(is.null(tl)) tl <- attr(x,"true.labels")
  if(is.null(tl)) stop("True labels not found!")
  if(!is.null(names(tl)) && !is.null(names(x))){
    if(all(names(x) %in% names(tl))){
      tl <- tl[names(x)]
    }else{
      warning("The names of the clustering vector does not match the names of",
              " the true labels.")
    }
  }
  if(any(is.na(tl))){
    w <- which(!is.na(tl))
    if(length(w)==0) stop("No non-NA true label!")
    tl <- tl[w]
    x <- x[w]
  }
  e <- match_evaluate_multiple(x, tl)
  x <- as.character(x)
  unmatched <- length(x)-sum(e$n_cells_matched)
  c( unlist(e), unmatched.cells=unmatched, 
     unlist(aricode::clustComp(x,tl)) )
}

.compileExcludedCells <- function(before, after){
  tt <- table(before$phenoid)
  tt <- rbind( tt, table(after$phenoid)[names(tt)])
  row.names(tt) <- c("before","after")
  list( table=tt, excluded=setdiff(colnames(before), colnames(after)) )
}

#' @importFrom dplyr bind_rows
.aggregateExcludedCells <- function(res){
  pi <- parsePipNames(names(res[[1]]))
  res <- lapply(res, FUN=function(x){
    y <- pi[rep(seq_len(nrow(pi)), each=ncol(x[[1]]$table)),,drop=FALSE]
    row.names(y) <- NULL
    y$subpopulation <- rep(colnames(x[[1]]$table), length(x))
    y$N.before <- unlist(lapply(x, FUN=function(x) as.numeric(x$table[1,])))
    y$N.lost <- unlist(lapply(x, FUN=function(x){
      nl <- as.numeric(x$table[1,]-x$table[2,])
      if(any(is.na(nl))){
        w <- which(is.na(nl))
        nl[w] <- as.numeric(x$table[1,w])
      }
      nl
    }))
    
    if(length(w <- which(is.na(y$N.lost)))>0) y$N.lost[w] <- y$N.before[w]
    y$pc.lost <- round(100*y$N.lost/y$N.before,3)
    y
  })
  res <- dplyr::bind_rows(res, .id="dataset")
  res$dataset <- factor(res$dataset)
  res
}


#' @importFrom matrixStats rowMins
#' @importFrom dplyr bind_cols bind_rows
.aggregateClusterEvaluation <- function(res){
  pi <- row.names(res[[1]])
  if(is.null(pi)) pi <- names(res[[1]])
  pi <- parsePipNames(pi)
  res <- lapply(res, FUN=function(a){
    a <- lapply(a, cn=unique(unlist(lapply(a, names))), FUN=function(x,cn){
      for(f in setdiff(cn,names(x))) x[[f]] <- NA_real_
      x[cn]
    })
    ## accomodate old and new dplyr behaviors:
    x <- dplyr::bind_rows(a)
    if(ncol(x)!=length(a[[1]])) x <- t(x)
    ##
    x <- as.data.frame(x)
    colnames(x) <- names(a[[1]])
    for(f in c("pr","re","F1")){
      w <- grep(paste0("^",f,"\\."),colnames(x))
      x[[paste0("min_",f)]]<- matrixStats::rowMins(as.matrix(x[,w,drop=FALSE]))
    }
    y <- as.data.frame(x[,grep("pr\\.|re\\.|F1\\.",colnames(x),invert=TRUE)])
    y$true.nbClusts <- length(grep("^pr\\.", colnames(x)))
    y
  })
  pi <- pi[rep(seq_len(nrow(pi)), length(res)),,drop=FALSE]
  res <- cbind(pi, dplyr::bind_rows(res, .id="dataset"))
  res$dataset <- factor(res$dataset)
  row.names(res) <- NULL
  res
}

.getVE <- function(x, cl){
  tryCatch({
    summary(lm(x~cl))$r.squared
  }, error=function(e){ print(e); return(NA) })
}



#' evaluateDimRed
#'
#' Gathers evaluation statistics on a reduced space using known cell labels.
#' If using `evaluteDimRed` in a custom pipeline, you will probably want to use
#' `pipeComp:::.aggregateDR` as the corresponding aggregation function.
#'
#' @param x The matrix of the reduced space, with cells as rows and components 
#' as columns
#' @param clusters The vector indicating each cell's cluster.
#' @param n A numeric vector indiciating the number of top dimensions at which 
#' to gather statistics (default `c(10,20,50)`). Will use all available 
#' dimensions if a higher number is given.
#' @param covars A character vectors containing any additional covariates 
#' (column names of `colData`) to track during evalutation. If missing, will
#' attempt to use default covariates. To disable, set `covars=c()`.
#'
#' @return A list with the following components:
#' * silhouettes: a matrix of the silhouette for each cell-cluster pair at each 
#' value of `n`
#' * clust.avg.silwidth: a matrix of the cluster average width at each value of 
#' `n`
#' * R2: the proportion of variance in each component (up to `max(n)`) that is 
#' explained by the clusters (i.e. R-squared of a linear model).
#' 
#' @importFrom stats dist lm
#' @importFrom cluster silhouette
#' @export
#' @examples
#' # random data
#' library(scater)
#' sce <- runPCA(logNormCounts(mockSCE(ngenes = 500)))
#' sce <- addPerCellQC(sce)
#' # random population labels
#' sce$cluster <- sample(LETTERS[1:3], ncol(sce), replace=TRUE)
#' res <- evaluateDimRed(sce, sce$cluster, covars=c("sum","detected"))
#' # average silhouette widths:
#' res$clust.avg.silwidth
#' # adjusted R2 of covariates:
#' res$covar.adjR2
evaluateDimRed <- function(x, clusters=NULL, n=c(10,20,50), covars){
  if(missing(covars)) covars <- c("log10_total_features", "log10_total_counts", 
                                  "total_features")
  if(is(x,"Seurat")){
    if(is.character(covars)) covars <- x[[]][,covars]
    if(is.null(clusters)) clusters <- x$phenoid
    x <- Embeddings(x[["pca"]])
  }else if(is(x, "SingleCellExperiment")){
    if(is.character(covars))
      covars <- as.data.frame(colData(x)[,
                                    intersect(covars,colnames(colData(x)))])
    if(is.null(clusters)) clusters <- x$phenoid
    x <- reducedDim(x, "PCA")
  }else{
    if(is.null(clusters)) stop("`clusters` must be given!")
    if(is.character(covars)) covars <- list()
  }
  if(is.data.frame(covars) && ncol(covars)==0) covars <- list()
  clusters <- as.factor(clusters)
  n <- unique(vapply(n, y=ncol(x), FUN=function(x,y) min(x,y), numeric(1)))
  si <- lapply(n, FUN=function(dims){
    cluster::silhouette(as.integer(clusters), dist(x[,seq_len(dims)]))
  })
  names(si) <- vapply(n, FUN=function(i){
    if(i==ncol(x)) return(paste0("all_", i,"_dims"))
    return(paste0("top_", i,"_dims"))
  }, FUN.VALUE=character(1))
  # summarize silhouette information
  if(length(n)==1){
    silhouettes <- si[[1]][,seq(1,3)]
  }else{
    silhouettes <- lapply(si,FUN=function(x) as.numeric(x[,3]))
    silhouettes <- cbind(si[[1]][,seq(1,2)], do.call(cbind, silhouettes))
  }
  # cluster average silhouette width
  csw <- do.call(rbind, lapply(si, FUN=function(x) summary(x)$clus.avg.widths))
  colnames(csw) <- levels(clusters)
  # variance in each component explained by clusters
  R2 <- apply(x[,seq_len(max(n)),drop=FALSE], 2, cl=clusters, FUN=.getVE)
  # correlation of each component with covariates
  covar.cor <- vapply( covars, FUN=function(y) cor(x,y), numeric(ncol(x)) )
  covar.adjR2 <- vapply(covars, FUN=function(co){
    apply(x[,seq_len(min(5,ncol(x)))], 2, FUN=function(x){ 
      tryCatch({
        summary(lm(x~co+factor(clusters)))$adj.r.squared -
          summary(lm(x~factor(clusters)))$adj.r.squared
      }, error=function(e) NA)
    })
  }, numeric(min(5,ncol(x))))
  # per-subpopuluation correlation of each component with covariates
  ii <- split(seq_len(nrow(x)), clusters)
  covar.cor2 <- lapply( covars, FUN=function(y){
    z <- vapply(ii, FUN=function(i){
      t(cor(x[i,],y[i]))
    }, numeric(ncol(x)))
    row.names(z) <- colnames(x)
    z
  })
  # each cell's distance to the cluster median
  cs <- split(row.names(x),clusters)
  dists <- lapply(n, FUN=function(i){
    x2 <- lapply(cs, FUN=function(y) x[y,seq_len(i),drop=FALSE])
    lapply(x2, FUN=function(y){
      sqrt(colSums((t(y)-matrixStats::colMedians(y))^2))
    })
  })
  names(dists) <- paste0(n,"dims")
  list( silhouettes=silhouettes,
        clust.avg.silwidth=csw,
        cellDistsToMedian=dists,
        covar.cor=covar.cor,
        covar.cor2=covar.cor2,
        covar.adjR2=covar.adjR2,
        R2=R2 )
}

#' @importFrom stats as.formula median
.aggregateDR <- function(res){
  res <- lapply(res, FUN=function(x){
    if("evaluation" %in% names(x)) x <- x$evaluation
    if("dimreduction" %in% names(x)) x <- x$dimreduction
    if("evaluation" %in% names(x)) x <- x$evaluation
    x
  })
  
  pi <- parsePipNames(names(res[[1]]))
  
  agfns <- list(minSilWidth=min, meanSilWidth=mean, medianSilWidth=median, 
                maxSilWidth=max)
  
  allsi <- lapply(res, FUN=function(x){
    subpops <- colnames(x[[1]]$clust.avg.silwidth)
    x <- lapply(x,FUN=function(y) y$silhouettes)
    dims <- table(unlist(lapply(x, FUN=function(x) colnames(x)[c(-1,-2)])))
    if(!any(dims==length(x))){
      warning("Silhouettes computed over incompatible dimensionalities.",
              "Will use the first available one.")
      dims <- c(1,1)
    }
    if(length(unique(dims))==1){
      # single dimensionality
      if(length(dims)>1){
        x <- lapply(x, FUN=function(x){ colnames(x)[3] <- "selected"; x })
        dims <- table(unlist(lapply(x, FUN=function(x) colnames(x)[c(-1,-2)])))
      }
    }
    names(dims) <- dims <- intersect( unique(unlist(lapply(x, FUN=colnames))),
                                      names(dims)[dims==length(x)] )
    lapply(dims, FUN=function(dim){
      sils <- dplyr::bind_rows(lapply(x, FUN=function(sil){ 
        data.frame( subpopulation=subpops,
                    vapply(agfns, FUN.VALUE=numeric(length(unique(sil[,1]))),
                           FUN=function(agf) aggregate(sil[,dim], 
                                                       by=list(cluster=sil[,1]),
                                                       FUN=agf)[,2] ),
                    stringsAsFactors=FALSE )
      }))
      sils<- cbind(pi[rep(seq_len(nrow(pi)),each=length(subpops)),,drop=FALSE],
                    sils)
      row.names(sils) <- NULL
      sils
    })
  })
  
  dims <- unlist(lapply(allsi, names))
  dims <- table(dims)[unique(dims)]
  names(dims) <- dims <- names(dims)[dims==length(allsi)]
  allsi <- lapply(dims, FUN=function(x){
    x <- dplyr::bind_rows(lapply(allsi, FUN=function(y) 
                                              y[[x]]), .id = "dataset")
    x$dataset <- factor(x$dataset)
    x
  })

  R2 <- dplyr::bind_rows(lapply(res, FUN=function(x){
    # find common PCs
    x <- lapply(x, FUN=function(x) x$R2)
    nn <- table(unlist(lapply(x, names)))
    nn <- names(nn)[nn==length(x)]
    x <- do.call(rbind, lapply(x, FUN=function(x) x[nn]))
    cbind(pi, x)
  }), .id="dataset")
  
  if(is.null(tmp <- dim(res[[1]][[1]]$covar.cor)) || any(tmp==0)){
    top5 <- covar.adjR2 <- covar <- NULL
  }else{
    covar <- dplyr::bind_rows(lapply(res, FUN=function(x){
      a <- pi[rep(seq_len(nrow(pi)),each=ncol(x[[1]]$covar.cor)),,drop=FALSE]
      a <- cbind(a, dplyr::bind_rows(lapply(x, FUN=function(x){
        y <- t(x$covar.cor)
        colnames(y) <- paste0("PC",seq_len(ncol(y)))
        data.frame(covariate=colnames(x$covar.cor), y, stringsAsFactors=FALSE)
     })))
      row.names(a) <- NULL
      a
    }), .id="dataset")
    
    top5 <- covar.cor2 <- covar.adjR2 <- NULL
    if(!is.null(res[[1]][[1]]$covar.cor2)){
      covar.cor2 <- dplyr::bind_rows(lapply(res, FUN=function(x){
        x <- lapply(x, FUN=function(x){
          i <- seq_len(min(nrow(x),5))
          reshape2::melt(vapply(x$covar.cor2, FUN.VALUE=numeric(length(i)), 
                                FUN=function(x) rowMeans(x[i,,drop=FALSE])),
                         value.name = "meanCor")
        })
        cbind( pi[rep(seq_len(nrow(pi)),vapply(x,nrow,integer(1))),,drop=FALSE], 
               dplyr::bind_rows(x) )
      }), .id="dataset")
      colnames(covar.cor2)[ncol(pi)+2:3] <- c("component","covariate")
      w <- which( covar.cor2$component %in% 
                    paste0(c("PC","PC_"), rep(seq(1,5),each=2)) )
      top5 <- aggregate( covar.cor2$meanCor[w],
                         by=covar.cor2[,c("dataset","covariate", colnames(pi))],
                         FUN=function(x) mean(abs(x)) )
      ff <- paste( paste( setdiff(colnames(top5), c("x","covariate")),
                          collapse="+"),
                   "~covariate" )
      top5 <- reshape2::dcast( top5, as.formula(ff), value.var="x", 
                               fun.aggregate=mean)
    }
    if(!is.null(res[[1]][[1]]$covar.adjR2)){
      covar.adjR2 <- dplyr::bind_rows(lapply(res, FUN=function(x){
        pi <- parsePipNames(names(x))
        x <- do.call(rbind, 
                     lapply(x, FUN=function(x) x$covar.adjR2[1,,drop=FALSE]))
        row.names(x) <- NULL
        cbind(pi, x)
      }), .id="dataset")
    }
  }
  list( silhouette=allsi, varExpl.subpops=R2, corr.covariate=covar,
        meanAbsCorr.covariate2=top5, PC1.covar.adjR2=covar.adjR2 )
}


#' match_evaluate_multiple
#' 
#' Function to match cluster labels with 'true' clusters using the Hungarian 
#' algorithm, and return precision, recall, and F1 score. Written by Lukas 
#' Weber in August 2016 as part of his 
#' \href{https://github.com/lmweber/cytometry-clustering-comparison}{cytometry
#' clustering comparison}, with just slight modifications on initial handling 
#' of input arguments.
#'
#' @param clus_algorithm cluster labels from algorithm
#' @param clus_truth true cluster labels. If NULL, will attempt to read them 
#' from the names of `clus_algorithm` (expecting the format 
#' `clusterName.cellName`)
#'
#' @return A list.
#' 
#' @importFrom clue solve_LSAP
#' @export
#' 
#' @examples
#' # random data
#' dat <- data.frame( 
#'  cluster=rep(LETTERS[1:3], each=10),
#'  x=c(rnorm(20, 0), rnorm(10, 1)),
#'  y=c(rnorm(10, 1), rnorm(20, 0))
#' )
#' # clustering
#' dat$predicted <- kmeans(dist(dat[,-1]),3)$cluster
#' # evaluation
#' match_evaluate_multiple(dat$predicted, dat$cluster)
match_evaluate_multiple <- function(clus_algorithm, clus_truth=NULL){
  if(is.null(clus_truth)){
    warning("Truth not given, trying to guess it from the names...")
    clus_truth <- .getTrueLabelsFromNames(clus_algorithm)
  }
  if(length(clus_truth)>length(clus_algorithm)){
    if(!is.null(names(clus_truth)) && !is.null(names(clus_algorithm))){
      clus_truth <- clus_truth[names(clus_algorithm)]
    }else{
      stop("Could not match items from the two input vectors!")
    }
  }
  if(!is.numeric(clus_truth)) clus_truth <- as.integer(as.factor(clus_truth))
  if(!is.numeric(clus_algorithm)) 
    clus_algorithm <- as.integer(as.factor(clus_algorithm))
  
  # number of detected clusters
  n_clus <- length(table(clus_algorithm))
  
  # remove unassigned cells (NA's in clus_truth)
  unassigned <- is.na(clus_truth)
  clus_algorithm <- clus_algorithm[!unassigned]
  clus_truth <- clus_truth[!unassigned]
  if (length(clus_algorithm) != length(clus_truth)) 
    warning("vector lengths are not equal")
  
  tbl_algorithm <- table(clus_algorithm)
  tbl_truth <- table(clus_truth)
  
  # detected clusters in rows, true populations in columns
  pr_mat <- re_mat <- F1_mat <- 
    matrix(NA, nrow = length(tbl_algorithm), ncol = length(tbl_truth))
  
  for (i in seq_len(length(tbl_algorithm))) {
    for (j in seq_len(length(tbl_truth))) {
      i_int <- as.integer(names(tbl_algorithm))[i]  # cluster from algorithm
      j_int <- as.integer(names(tbl_truth))[j]  # cluster from true labels
      
      true_positives <- sum(clus_algorithm == i_int & 
                              clus_truth == j_int, na.rm = TRUE)
      detected <- sum(clus_algorithm == i_int, na.rm = TRUE)
      truth <- sum(clus_truth == j_int, na.rm = TRUE)
      
      # calculate precision, recall, and F1 score
      precision_ij <- true_positives / detected
      recall_ij <- true_positives / truth
      F1_ij <- 2 * (precision_ij * recall_ij) / (precision_ij + recall_ij)
      
      if (F1_ij == "NaN") F1_ij <- 0
      
      pr_mat[i, j] <- precision_ij
      re_mat[i, j] <- recall_ij
      F1_mat[i, j] <- F1_ij
    }
  }
  
  # put back cluster labels (note some row names may be missing due to removal 
  # of unassigned cells)
  rownames(pr_mat) <- rownames(re_mat) <- rownames(F1_mat) <- 
    names(tbl_algorithm)
  colnames(pr_mat) <- colnames(re_mat) <- colnames(F1_mat) <- 
    names(tbl_truth)
  
  # match labels using Hungarian algorithm applied to matrix of F1 scores 
  # (Hungarian algorithm calculates an optimal one-to-one assignment)
  
  # use transpose matrix (Hungarian algorithm assumes n_rows <= n_cols)
  F1_mat_trans <- t(F1_mat)
  
  if (nrow(F1_mat_trans) <= ncol(F1_mat_trans)) {
    # if fewer (or equal no.) true populations than detected clusters, can 
    # match all true populations
    labels_matched <- solve_LSAP(F1_mat_trans, maximum = TRUE)
    # use row and column names since some labels may have been removed due to 
    # unassigned cells
    labels_matched <- 
      as.numeric(colnames(F1_mat_trans)[as.numeric(labels_matched)])
    names(labels_matched) <- rownames(F1_mat_trans)
    
  } else {
    # if fewer detected clusters than true populations, use transpose matrix
    # and assign NAs for true populations without any matching clusters
    labels_matched_flipped <- solve_LSAP(F1_mat, maximum = TRUE)
    # use row and column names since some labels may have been removed due to 
    # unassigned cells
    labels_matched_flipped <- 
      as.numeric(rownames(F1_mat_trans)[as.numeric(labels_matched_flipped)])
    names(labels_matched_flipped) <- rownames(F1_mat)
    
    labels_matched <- rep(NA, ncol(F1_mat))
    names(labels_matched) <- rownames(F1_mat_trans)
    labels_matched[as.character(labels_matched_flipped)] <- 
      as.numeric(names(labels_matched_flipped))
  }
  
  # precision, recall, F1 score, and number of cells for each matched cluster
  pr <- re <- F1 <- n_cells_matched <- rep(NA, ncol(F1_mat))
  names(pr) <- names(re) <- names(F1) <- names(n_cells_matched) <- 
    names(labels_matched)
  
  for (i in seq_len(ncol(F1_mat))) {
    # set to 0 if no matching cluster (too few detected clusters); use 
    # character names for row and column indices in case subsampling completely 
    #  removes some clusters
    im <- labels_matched[i]
    pr[i] <- ifelse(is.na(im), 0, pr_mat[as.character(im), names(im)])
    re[i] <- ifelse(is.na(im), 0, re_mat[as.character(im), names(im)])
    F1[i] <- ifelse(is.na(im), 0, F1_mat[as.character(im), names(im)])
    
    n_cells_matched[i] <- sum(clus_algorithm == labels_matched[i], na.rm=TRUE)
  }
  
  # means across populations
  mean_pr <- mean(pr)
  mean_re <- mean(re)
  mean_F1 <- mean(F1)
  
  return(list(n_clus = n_clus, 
              pr = pr, 
              re = re, 
              F1 = F1, 
              labels_matched = labels_matched, 
              n_cells_matched = n_cells_matched, 
              mean_pr = mean_pr, 
              mean_re = mean_re, 
              mean_F1 = mean_F1))
}

#' evaluateNorm
#' 
#' @param x An object of class 'Seurat' or 'SingleCellExperiment' with 
#' normalized data
#' @param clusters A vector of true cluster identities. If missing, will 
#' attempt to fetch it from the `phenoid` colData.
#' @param covars Covariates to include, either as data.frame or as colData
#' columns of `x`
#'
#' @return a data.frame.
#' @export
#' @importFrom SummarizedExperiment colData
#' @importFrom matrixStats rowMedians
#' @importFrom Matrix rowMeans
#' @importFrom Seurat GetAssayData
#' @examples
#' # random data
#' library(scater)
#' sce <- logNormCounts(mockSCE(ngenes = 500))
#' sce <- addPerCellQC(sce)
#' # random population labels
#' sce$cluster <- sample(LETTERS[1:3], ncol(sce), replace=TRUE)
#' evaluateNorm(sce, sce$cluster, covars="detected")
evaluateNorm <- function(x, clusters=NULL, covars){
  if(missing(covars)) covars <- c("log10_total_counts", "total_features")
  if(is(x,"Seurat")){
    if(is.character(covars) && length(covars)>0) 
      covars <- x[[]][,covars,drop=FALSE]
    if(is.null(clusters)) clusters <- x$phenoid
    meanCount <- Matrix::rowMeans(GetAssayData(x, assay="RNA", slot="counts"))
    x <- GetAssayData(x, assay="RNA", slot="data")
  }else if(is(x, "SingleCellExperiment")){
    if(is.character(covars) && length(covars)>0) 
      covars <- as.data.frame(colData(x)[,covars,drop=FALSE])
    if(is.null(clusters)) clusters <- x$phenoid
    meanCount <- Matrix::rowMeans(counts(x))
    x <- logcounts(x)
  }
  x <- as.matrix(x)
  ve <- round(as.numeric(apply(x, 1, cl=clusters, FUN=.getVE)),2)
  res <- data.frame( row.names=row.names(x), meanCount=meanCount,
                     varExpByCluster=ve )
  if(!is.null(covars) && length(covars)>0){
    ii <- split(seq_len(ncol(x)), clusters)
    for( f in names(covars) ){
      tmp <- vapply(ii, FUN.VALUE=numeric(nrow(x)), FUN=function(i){
        cor(t(x[,i]), as.numeric(covars[[f]][i]))
      })
      res[[paste0(f,".medianCorr")]] <- round(matrixStats::rowMedians(tmp),2)
      res[[paste0(f,".meanCorr")]] <- round(Matrix::rowMeans(tmp),2)
      res[[paste0(f,".meanAbsCorr")]] <- round(Matrix::rowMeans(abs(tmp)),2)
    } 
  }
  return(res)
}


.aggregateNorm <- function(res){
  res <- lapply(res, FUN=function(x){
    if("evaluation" %in% names(x)) x <- x$evaluation
    if("normalization" %in% names(x)) x <- x$normalization
    x
  })
  res2 <- dplyr::bind_rows(lapply(res, FUN=function(x){
    x <- t(vapply(x, FUN.VALUE=numeric(ncol(x[[1]])), FUN=function(x){
      vapply(x, FUN=function(x) mean(abs(x), na.rm=TRUE), numeric(1))
    }))
    parsePipNames(as.data.frame(x))
  }), .id="dataset")
  cor2 <- dplyr::bind_rows(lapply(res, FUN=function(x){
    parsePipNames(as.data.frame(t(vapply(x, FUN=function(x){
      vapply( x[,-1], y=x[,1], method="spearman", use="pairwise",
              FUN=cor, FUN.VALUE=numeric(1) )
    }, FUN.VALUE=numeric(ncol(x[[1]])-1)))))
  }), .id="dataset")
  list( meanAbsCorr=res2, spearman.with.meanCount=cor2 )
}

#' getDimensionality
#' 
#' Returns the estimated intrinsic dimensionality of a dataset.
#'
#' @param dat A Seurat or SCE object with a pca embedding.
#' @param method The dimensionality method to use.
#' @param maxDims Deprecated and ignored.
#'
#' @return An integer.
#'
#' @importFrom Seurat Stdev
#' @importFrom SingleCellExperiment reducedDim
#' @import intrinsicDimension
getDimensionality <- function(dat, method, maxDims=NULL){
  if(is.numeric(method) || grepl("^[0-9]+$", method))
    return(as.integer(round(as.numeric(method))))
  if(is(dat, "Seurat")){
    x <- Embeddings(dat[["pca"]])
    sdv <- Stdev(dat, "pca")
  } else {
    if(method=="jackstraw.elbow")
      stop("the jackstraw.elbow method is only available for Seurat objects.")
    x <- reducedDim(dat, "PCA")
    sdv <- attr(reducedDim(dat, "PCA"), "percentVar")
  }
  # conversion for backward compatibility:
  conv <- c( "fisherSeparability"="FisherSeparability",
             "scran.denoisePCA"="scran.ndims.wrapper", 
             "jackstraw.elbow"="js.wrapper"
  )
  if(method %in% names(conv)) method <- as.character(conv[method])
  
  x <- switch(method,
              essLocal.a=essLocalDimEst(x),
              essLocal.b=essLocalDimEst(x, ver="b"),
              pcaLocal.FO=pcaLocalDimEst(x,ver="FO"),
              pcaLocal.fan=pcaLocalDimEst(x, ver="fan"),
              pcaLocal.maxgap=pcaLocalDimEst(x, ver="maxgap"),
              maxLikGlobal=maxLikGlobalDimEst(x, k=20, unbiased=TRUE),
              maxLikGlobal10=maxLikGlobalDimEst(x, k=10, unbiased=TRUE),
              pcaOtpmPointwise.max=pcaOtpmPointwiseDimEst(x,N=10),
              elbow=farthestPoint(sdv)-1,
              ifelse( !is.function(method) && 
                        !( is.character(method) && 
                             is.function(method <- get(method)) ),
                      stop("Unknown dimensionality method!"),
                      method(dat) )
  )
  if(is.list(x) && "dim.est" %in% names(x)) x <- max(x$dim.est)
  as.integer(round(x))
}


# sce2se conversion
# not exported
#' @import SingleCellExperiment Seurat
#' @importFrom SummarizedExperiment assayNames
seWrap <- function(sce, min.cells=10, min.features=0){
  if(is(sce,"Seurat")) return(sce)
  if(!is(sce,"SingleCellExperiment")) stop("not a SingleCellExperiment!")
  se <- CreateSeuratObject( counts=counts(sce), 
                            min.cells=min.cells, 
                            min.features=min.features, 
                            meta.data=as.data.frame(colData(sce)), 
                            project = "scRNAseq" )
  Misc(se, "rowData") <- as.data.frame(rowData(sce))
  if("logcounts" %in%  assayNames(sce)){
    se <- ScaleData(se, verbose = FALSE)
    sce <- sce[row.names(se),]
    se <- SetAssayData(se, slot="data", new.data=logcounts(sce))
    se <- SetAssayData(se, slot="scale.data", new.data=logcounts(sce))
  } 
  if(!is.null(metadata(sce)$VariableFeats)) 
    VariableFeatures(se) <- metadata(sce)$VariableFeats
  if(length(reducedDimNames(sce)) != 0) 
    se[["pca"]] <- CreateDimReducObject(embeddings=reducedDim(sce), key="PC_", 
                                        assay="RNA")
  se
}

# se2sce conversion
# not exported
#' @import SingleCellExperiment Seurat
#' @importFrom SummarizedExperiment rowData<-
sceWrap <- function(seu) {
  if(is(seu,"SingleCellExperiment")) return(seu)
  if(!is(seu,"Seurat")) stop("not a Seurat object!")
  sce <- SingleCellExperiment(
    list(counts=GetAssayData(seu, assay="RNA", slot="counts")), 
    colData = seu[[]] )
  if(nrow(norm <- GetAssayData(seu, slot="scale.data"))>0){
    sce <- sce[row.names(norm),]
    logcounts(sce) <- norm
  }
  rowData(sce) <- Misc(seu, "rowData")[row.names(sce),]
  if(length(VariableFeatures(seu)))
    metadata(sce)$VariableFeats <- VariableFeatures(seu)
  if(length(Reductions(seu))>0){
    reducedDims(sce) <- lapply( Reductions(seu), FUN=Embeddings )
  }
  sce
}

#' evaluateDEA
#' 
#' Evaluates a differential expression analysis (DEA).
#'
#' @param dea Expects a data.frame with logFC and FDR, as produced by 
#' `edgeR::topTags`, `limma::topTable` or `DESeq2::results`.
#' @param truth A data.frame containing the columns `expected.beta` (real logFC)
#' and `isDE` (logical indicating whether there is a difference or not; accepts
#' NA values)
#' @param th The significance thresholds for which to compute the metrics.
#'
#' @return A list with two slots: `logFC` (vector of metrics on logFC) and 
#' `significance` table of significance-related statistics.
#' 
#' @export
#' @examples
#' # fake DEA results
#' dea <- data.frame( row.names=paste0("gene",1:10), logFC=rnorm(10) )
#' dea$PValue <- dea$FDR <- c(2:8/100, 0.2, 0.5, 1)
#' truth <- data.frame( row.names=paste0("gene",1:10), expected.beta=rnorm(10),
#'                      isDE=rep(c(TRUE,FALSE,TRUE,FALSE), c(3,1,2,4)) )
#' evaluateDEA(dea, truth)
evaluateDEA <- function(dea, truth=NULL, th=c(0.01,0.05,0.1)){
  ## we make sure that the column names of `dea` are standard:
  dea <- pipeComp:::.homogenizeDEA(dea)
  ## within Pipecomp, the truth should be passed along with the `dea` object, 
  ## so we retrieve it here:
  if(is.null(truth)) truth <- metadata(dea)$truth
  dea <- cbind(dea, truth[row.names(dea),])
  ## we get rid of genes for which the truth is unknown:
  dea <- dea[!is.na(dea$expected.beta),]
  ## comparison of estimated and expected log2 folchanges:
  res <- c(logFC.pearson=cor(dea$logFC, dea$expected.beta, use = "pairwise"),
           logFC.spearman=cor(dea$logFC, dea$expected.beta, 
                              use = "pairwise", method="spearman"),
           logFC.mad=median(abs(dea$logFC-dea$expected.beta),na.rm=TRUE),
           ntested=sum(!is.na(dea$PValue) & !is.na(dea$FDR)))
  ## evaluation of singificance calls
  names(th) <- th
  res2 <- t(vapply( th, FUN.VALUE=vector(mode="numeric", length=6), 
                    FUN=function(x){
            ## for each significance threshold, calculate the various metrics
            called=sum(dea$FDR<x,na.rm=TRUE)
            P <- sum(dea$isDE)
            TP <- sum(dea$FDR<x & dea$isDE, na.rm=TRUE)
            c( TP=TP, FP=called-TP, TPR=TP/P, PPV=TP/called, FDR=1-TP/called, 
               FPR=(P-TP)/sum(!dea$isDE) )
                    }))
  res2 <- cbind(threshold=as.numeric(row.names(res2)), as.data.frame(res2))
  row.names(res2) <- NULL
  list(logFC=res, significance=res2)
}

#' dea_evalPlot_curve
#'
#' @param res Aggregated results of the DEA pipeline
#' @param scales Passed to `facet_grid`
#' @param agg.by Aggregate results by these columns (default no aggregation)
#' @param agg.fn Function for aggregation (default mean)
#' @param xlim Optional vector of x limits
#' @param colourBy Name of column by which to colour
#' @param shapeBy Name of column determining the shape of the points. If 
#' omitted, the shape will indicate whether the nominal FDR is below or equal 
#' the real FDR.
#' @param pointsize Size of the points
#'
#' @return A ggplot.
#' @export
#' @examples
#' data("exampleDEAresults", package="pipeComp")
#' dea_evalPlot_curve(exampleDEAresults, agg.by=c("sva.method"))
dea_evalPlot_curve <- function(res, scales="free", agg.by=NULL, agg.fn=mean, 
                               xlim=c(NA,NA), colourBy="method", shapeBy=NULL,
                               pointsize=4){
  pd <- NULL
  if(is(res,"SimpleList")) pd <- metadata(res)$PipelineDefinition
  if(is(res,"SimpleList") && "evaluation" %in% names(res)) res <- res$evaluation
  if(is(res,"list") && "dea" %in% names(res)) res <- res$dea
  if(is(res,"list") && "significance" %in% names(res)) res <- res$significance
  if(is.null(agg.by)) agg.by <- intersect(colnames(res), unlist(arguments(pd)))
  d <- aggregate(res[,c("FDR","TPR")], by=res[,c("dataset","threshold",agg.by)], na.rm=TRUE, FUN=agg.fn)
  pp <- d[,agg.by,drop=FALSE]
  d$method <- apply(pp, 1, collapse=" > ", FUN=paste)
  if(all(c("filt","minCount") %in% colnames(d))){
    d$filter <- paste(d$filt, "(",d$minCount,")")
    d$filter[which(d$filt=="none")] <- "none"
  } 
  p <- ggplot(d, aes_string("FDR", "TPR", group="method", colour=colourBy, 
                            shape=shapeBy)) + 
    geom_vline(xintercept=unique(d$threshold), linetype="dashed", 
               colour="darkgrey") + 
    geom_line(size=1) + geom_point(size=pointsize)
  if(is.null(shapeBy)) p <- p + 
    geom_point(data=d[d$FDR>d$threshold,], size=3, colour="white")
  p + facet_wrap(~dataset, scales=scales) + 
    scale_x_sqrt( breaks=c(0.001,0.01,0.05,0.1,0.2,0.4), 
                  limits=xlim ) + 
    theme(axis.text.x=element_text(angle = 90, hjust = 1))
}

# ==============================================================================
# Author: Anthony Sonrel 
# Email:  anthony.sonrel@uzh.ch
# Created date: Wed Nov 13 2019
# ------------------------------------------------------------------------------
# Project: pipeComp
#
# Description: individual wrappers of each imputation function used in the 
#   pipeComp project. For all of these function, both the input and the output
#   is an SCE object. 
#
# ------------------------------------------------------------------------------
# TODO: 
# ==============================================================================


#' wrapp.saverx
#' 
#' Wrapper for SAVERX imputation. 
#' 
#' @param sce An SCE object to perform the imputation on. 
#' @param organism "Mouse" or "Human". Origin of the dataset.
#' @param python_path Path to the python binary that has an installtion of SAVERX. 
#' @param n_cores Number of cores to use. 
#' 
#' @return An SCE object with the imputed data in the 'counts' assay. 
#' @export

wrapp.saverx <- function(sce, 
                         organism,
                         python_path = '/usr/bin/python3', 
                         n_cores = 1L
                         ){
  
  
  suppressPackageStartupMessages({
    library(data.table)
    library(SingleCellExperiment)
    library(purrr)
    library(SAVERX)
    library(reticulate)
    reticulate::use_python(python = python_path, required = TRUE)
    library(tensorflow)
    library(keras)
    config <- tf$ConfigProto(intra_op_parallelism_threads = n_cores,
                             inter_op_parallelism_threads = n_cores)
    session = tf$Session(config = config)
    k_set_session(session)
  })
  
  saveRDS(counts(sce), file = "temp.rds")
  
  res <- saverx(input.file.name = "temp.rds", data.species = organism,
                clearup.python.session = TRUE, ncores = n_cores)
  file.remove("temp.rds")

  denois <- readRDS(res) %>% .$estimate
  file.remove(res)
  
  .out_check(sce, denois)
  denois <- .prep(sce, denois, out = "output")
  counts(sce) <- denois
  # unlink(gsub("\\/.*", "", res), recursive = TRUE)
  cat("If you want to run SAVERX a second time, please restart the R session (open issue of the package).\n")
  
  return(sce)

}


#' wrapp.scimpute
#' 
#' Wrapper for scImpute imputation. 
#' 
#' @param sce An SCE object to perform the imputation on. 
#' @param n_cores Number of cores to use. 
#' @param scImpute_kcluster: integer, k clusters expected in the data. Can be set.By default, this number is automatically detected if a `sce` if given with a 'phenoid' column in the colData. 
#' @param kcluster_modif Integer, number of clusters to add or substract to the estimated number of clusters.

#' 
#' @return An SCE object with the imputed data in the 'counts' assay.
#' @export
 
wrapp.scimpute <- function(sce, 
                           scImpute_kcluster = NULL, 
                           kcluster_modif = 0, 
                           n_cores = 1L
                           ) {
  
  suppressPackageStartupMessages({
    library(data.table)
    library(SingleCellExperiment)
    library(purrr)
    library(penalized)
    library(scImpute)
    library(doParallel)
  })
  
  rand_suffix <- sample(1:1000000, 1)
  rand_dir <- paste0("temp_scImpute", rand_suffix, "/")
  dir.create(rand_dir)
  
  if(!"phenoid" %in% colnames(colData(sce))) stop("No 'phenoid' in the colData names. Please add it. It should contain the identity of the cells.")
  infile = "rds"
  if (length(scImpute_kcluster) == 0) kcluster <- length(unique(sce$phenoid)) else kcluster <- scImpute_kcluster
  
  count_path <- paste0("temp_scImpute", rand_suffix, ".rds")
  saveRDS(counts(sce), file = paste0(rand_dir, count_path))
  input_dir <- rand_dir
  
  cat(kcluster, "clusters recognized in the input data.")
  
  if (kcluster_modif != 0) {
    
    kcluster <- kcluster + kcluster_modif
    cat("...modified to " , kcluster, "by 'kcluster_modif parameter.\n")
    
  }
  
  scimpute(paste0(input_dir, count_path), ncores = n_cores, Kcluster = kcluster , 
           out_dir =  paste0(getwd(), "/", rand_dir), infile = infile, outfile = "rds")
  denois <- readRDS(paste0(rand_dir, "scimpute_count.rds"))
  
  unlink(rand_dir)
  .out_check(sce, denois)
  denois <- .prep(sce, denois, out = "output")
  counts(sce) <- denois
  
  return(sce)
}


#' wrapp.alra
#' 
#' Wrapper for ALRA imputation. 
#' 
#' @param sce An SCE object to perform the imputation on. 
#' @param alra_norm logical, whether to normalize the data with log counts before imputing with alra (advised in the vignettes but not stated as required).
#' @param alra_path path to the `alra.R` script that contains the required functions for the imputation. Can be dl from https://github.com/KlugerLab/ALRA.
#' 
#' @return An SCE object with the imputed data in the 'counts' assay. 
#' @export

wrapp.alra <- function(sce,                              
                       alra_norm = FALSE,
                       alra_path){
  
  suppressPackageStartupMessages({
    library(data.table)
    library(SingleCellExperiment)
    library(purrr)
    library(rsvd)
    source(alra_path)
  })
  
  data <- as.matrix(counts(sce))
  data <- t(data)
  if (alra_norm) data <- normalize_data(log2(data + 1))
  k_choice <- choose_k(data)

  denois <- alra(data, k = k_choice$k)[[3]]
  rownames(denois) <- rownames(data)
  denois <- t(denois)
  
  .out_check(sce, denois)
  denois <- .prep(sce, denois, out = "output")
  
  counts(sce) <- denois
  
  return(sce)
  
}


#' wrapp.dca
#' 
#' Wrapper for DCA imputation. 
#' 
#' @param sce An SCE object to perform the imputation on. 
#' @param dca_path path to the python installation of DCA. Alternatively, can be set to "dca" if the appropriate virtual environment has been set with `reticulate`` on top of the function. 
#' @param n_cores Number of cores to use. 
#' 
#' @return An SCE object with the imputed data in the 'counts' assay. 
#' @export

wrapp.dca <- function(sce, 
                      dca_path = "/usr/bin/python3/dca",                              
                      n_cores = 1L
                      ){
  
  suppressPackageStartupMessages({
    library(data.table)
    library(SingleCellExperiment)
    library(purrr)
  })
  
  rand_suffix <- sample(1:1000000, 1)
  temp_file <- paste0("temp_DCA", rand_suffix, ".csv")
  temp_fold <- paste0("temp_DCA", rand_suffix)
  
  temp <- counts(sce)
  
  # DCA only accepts integers
  # --> floor the count if decimals
  if (all(colSums(temp) %% 1 == 0) == FALSE) temp <- floor(temp)
  write.csv(as.matrix(temp), file = temp_file, quote = FALSE)

  command <- paste(dca_path, temp_file, temp_fold, "--threads", n_cores)
  
  system(command = command)
  denois <- read.csv(paste0(temp_fold, "/mean.tsv"),sep = "\t", row.names = 1 )
  unlink(temp_fold, recursive = TRUE)
  file.remove(temp_file)
  
  sce <- .prep(sce, denois, out = "input")
  counts(sce) <- denois
  
  return(sce)
}

#' wrapp.empiricalbose
#' 
#' Wrapper for EmpiricalBose imputation. 
#' 
#' @param sce An SCE object to perform the imputation on. 
#' @param python_path Path to a python3 binary that has `numpy` installed.
#' @param n_cores Number of cores to use. 
#' @param restr_to_hvgs Logical; restrict the imputation to HVGs only ? If `TRUE`, the output will only contain these genes.
#' @param eb_out EmpiricalBose method: which output to return. Can be "dirichlet" (default) similar to raw counts or "log_p" similar to log(tmp). 
#' 
#' @return An SCE object with the imputed data in the 'counts' assay. 
#' @export

wrapp.empiricalbose <- function(sce, 
                                python_path = '/usr/bin/python3',
                                restr_to_hvgs = FALSE,
                                eb_out = "dirichlet", 
                                n_cores = 1L) {
  
  suppressPackageStartupMessages({
    library(data.table)
    library(SingleCellExperiment)
    library(purrr)
    library(reticulate)
    library(scran)
    use_python(python_path, required = TRUE)
    library('EmpiricalBose')
    library('future')
    plan("multicore", workers = n_cores)
  })
  
  logcounts(sce) <- log2(counts(sce) + 1)
  
  # restrict to highly variable genes
  if (restr_to_hvgs) sce <- restrict_to_hvgs(sce)
  
  data_denois = cancel_noise(sce = sce)
  
  denois <- assay(data_denois, eb_out)
  if (!restr_to_hvgs) {
    .out_check(sce, denois)
    denois <- .prep(sce, denois, out = "output")
  } else {
    sce <- .prep(sce, denois, out = "input")
  }
  
  
  counts(sce) <- denois
    
  return(sce)
  
}

#' wrapp.enhance
#' 
#' Wrapper for ENHANCE imputation. 
#' 
#' @param sce An SCE object to perform the imputation on. 
#' @param enhance_path Path to the R script containing the ENHANCE functions. Can be dl from https://github.com/yanailab/enhance.
#' 
#' @return An SCE object with the imputed data in the 'counts' assay. 
#' @export

wrapp.enhance <- function(sce, 
                          enhance_path) {
  
  suppressPackageStartupMessages({
    library(data.table)
    library(SingleCellExperiment)
    library(purrr)
    source(enhance_path)
  })
  
  data <- as.matrix(counts(sce))
 
  denois <- try(enhance(data))
  if (is(denois, "try-error"))  denois <- enhance(data, k_nn = 2)
  
  .out_check(sce, denois)
  denois <- .prep(sce, denois, out = "output")
  
  counts(sce) <- denois
  
  return(sce)
  
}


#' wrapp.drimpute
#' 
#' Wrapper for ENHANCE imputation. 
#' 
#' @param sce An SCE object to perform the imputation on. 
#' @param n_cores Number of cores to use. 
#' @param DrImpute_prepross Logical, filter the lowly expressed genes/ cells before running DrImpute (advised in the vignette but not stated as required) ?
#' 
#' @return An SCE object with the imputed data in the 'counts' assay. 
#' @export

wrapp.drimpute <- function(sce, 
                           DrImpute_prepross = TRUE, 
                           n_cores = 1L) {
  
  suppressPackageStartupMessages({
    library(data.table)
    library(SingleCellExperiment)
    library(purrr)
    library(DrImpute)
  })
  
  data <- counts(sce)
  
  if (DrImpute_prepross == TRUE) X <- .drimp_preprocess(data, min.expressed.gene = 0) else X <- data    
  Xlog <- log(X + 1)
  denois <- DrImpute(Xlog, mc.cores = n_cores)
  denois <- exp(denois) - 1
  
  sce <- .prep(sce, denois, out = "input")
  counts(sce) <- denois
  
  return(sce)
  
}



#' imp.scVI
#'
#' A function calling a python wrapper (`scVI.py`) around `scVI` imputation, adapted from the the 'Basic usage' Jupyter notebook (https://nbviewer.jupyter.org/github/YosefLab/scVI/blob/master/tests/notebooks/basic_tutorial.ipynb). Note that the function will create a temporary csv file for the intermediate storage of the input count matrix, needed by `scVI`.  
#' 
#' 
#' @param x A SCE object.
#' @param py_script Location of the python script
#' @param py_path Optional. If scVI was installed in a specific python bin, pass here the path to it. 
#' @param train_size Size of training set. Default to 0.8 but tutorial however recommends to use 1. 
#' @param n_cores N. cores
#' 
#' 
#' @return An object of the same class as `x` with updated slots.

imp.scVI <- function(x, py_script = system.file("extdata", "scVI.py", package="pipeComp"), py_path = NULL, n_cores = 1L, train_size = 1) {
  n_cores <- as.integer(n_cores)
  suppressPackageStartupMessages(library(reticulate))
  if (length(py_path)>0) use_python(py_path ,required=TRUE)
  trysource <- try(source_python(py_script))
  if (class(trysource) == "try-error") stop("Cannot source the python wrapper.") 
  tfile <- tempfile(fileext=".csv", tmpdir = ".")
  write.csv(counts(x), tfile)
  out <- scVI_imput(csv_file = tfile, csv_path = ".", n_cores = n_cores,
                    train_size = train_size)
  val <- t(out[[1]])
  gnames <- as.character(out[[2]])
  file.remove(tfile)
  dimnames(val) <- list(gnames, colnames(counts(x)))
  x <- x[gnames, ]
  counts(x) <- as.matrix(val)
}



# MISC. ========================================================================

.out_check <- function(input, output) {
  # Check that input dimensions = output dimensions in some tools
  # else stop
  if (!all(dim(input) == dim(output))) {
    stop("Output dimension differ from input dimension.\nPlease verify. Dimensions from input and output should be the same")
  }
}


.prep <- function(input, output, out) {
  # Reordering of output rows/ columns
  if (out == "input") {
    input <- input[rownames(input) %in% rownames(output), 
                   colnames(input) %in% colnames(output)]
    input <- input[match(rownames(output), rownames(input)), 
                   match(colnames(output), colnames(input))]
    return(input)
  } else {
    output <- output[match(rownames(input), rownames(output)), 
                     match(colnames(input), colnames(output))]
    return(output)
  }
  
}

.drimp_preprocess <- function(x, min.expressed.gene = 0, min.expressed.cell = 2, 
                              max.expressed.ratio = 1, 
                              normalize.by.size.effect = FALSE){
  # preprocessign function from DrImpute 
  if (is(x, 'SummarizedExperiment'))
    X <- assays(x)$count
  else if (is(x, 'matrix'))
    X <- x
  else if (is(x, 'sparseMatrix'))
    X <- x
  else
    stop(sprintf('unknown class(x): %s', class(x)))
  
  M <- ncol(X)
  N <- nrow(X)
  m <- Matrix::colSums(X > 1) >= min.expressed.gene	# cells that have at least min.expressed.gene expreseed genes
  n <- Matrix::rowSums(X > 1) <= max.expressed.ratio * M & Matrix::rowSums(X > 1) >= min.expressed.cell	# genes that are detected in at least min.expressed.cell or at most max.expressed.ratio cells
  if (normalize.by.size.effect){
    sf <- apply((X[n, m] + 1) / exp(Matrix::rowMeans(log(X[n, m] + 1))), 2, median)
    X <- t(t(X[n, m]) / sf)
  }else
    X <- X[n, m]
  
  if (is(x, 'SummarizedExperiment')){
    x <- x[n, m]
    assays(x)$count <- X
  }else if (is(x, 'matrix')){
    x <- as.matrix(X)
  }else if (is(x, 'sparseMatrix')){
    x <- X
  }
  
  x
}

#' @rdname ctrlgenes
#' @name ctrlgenes
#' @aliases ctrlgenes
#'
#' @title Lists of control genes
#'
#' @description
#' Lists of mouse and human control genes (mitochondrial, ribosomal, 
#' protein-coding), as ensembl gene ids or official symbols, for computing cell
#'  QC.
#'
#' @return a list.
NULL


#' @rdname clustMetricsCorr
#' @name clustMetricsCorr
#' @references 
#' See https://doi.org/10.1101/2020.02.02.930578
#' @aliases clustMetricsCorr
#'
#' @title Correlations across clustering evaluation metrics
#'
#' @description
#' A list of two matrices containing, respectively, the Pearson and Spearman
#' pairwise correlations between various clustering evalution metrics, computed
#' across a wide range of scRNAseq clustering analyses (see reference).
#'
#' @return a list.
NULL


#' @rdname exampleResults
#' @name exampleResults
#' @aliases exampleResults
#'
#' @title Example pipeline results
#'
#' @description
#' Example benchmarking results from a scRNAseq pipeline (see vignette 
#' `pipeComp_scRNA`).
#'
#' @return a list.
NULL

#' @rdname exampleDEAresults
#' @name exampleDEAresults
#' @aliases exampleDEAresults
#'
#' @title Example results from the DEA pipeline
#'
#' @description
#' Example benchmarking results from a DEA pipeline (see vignette 
#' `pipeComp_dea`).
#'
#' @return a list.
NULL

#' @rdname stableG
#' @name stableG
#' @aliases stableG
#'
#' @title Lists of stable genes
#'
#' @description
#' Genes were simply obtained by querying the respective GO terms
#'
#' @return a list.
NULL

#' readPipelineResults
#'
#' @param path The path (e.g. folder or prefix) to the results. Either `path` 
#' or `resfiles` should be given.
#' @param resfiles A vector of paths to `*.evaluation.rds` files. Either `path` 
#' or `resfiles` should be given.
#'
#' @return A list of results.
#' @examples
#' # we produce mock pipeline results:
#' pip <- mockPipeline()
#' datasets <- list( ds1=1:3, ds2=c(5,10,15) )
#' tmpdir1 <- paste0(tempdir(),'/')
#' res <- runPipeline(datasets, pipelineDef=pip, output.prefix=tmpdir1,
#'                    alternatives=list() )
#' # we read the evaluation files:
#' res <- readPipelineResults(tmpdir1)
#' @export
readPipelineResults <- function(path = NULL, resfiles = NULL) {
  if ( (!is.null(path) && !is.null(resfiles)) || 
       (is.null(path) && is.null(resfiles)) ) 
    stop("Exactly one of `path` or `resfiles` should be given.")
  if (!is.null(path)) {
    resfiles <- list.files(path, pattern="evaluation\\.rds", full.names=TRUE)
    if (length(resfiles) == 0) 
      resfiles <- list.files(dirname(path), full.names=TRUE, 
                             pattern=paste0(gsub("\\.","\\\\.",basename(path)),
                                            ".*\\.evaluation\\.rds$"))
    if (length(resfiles) == 0) 
      stop("Could not find evaluation files.")
  }
  ds <- vapply(strsplit(basename(resfiles), "\\."), FUN=function(x) rev(x)[3], 
               FUN.VALUE=character(1))
  if (any(duplicated(ds))) 
    stop("Some datasets appear to occur in more than one file. If these are ",
          "the result of multiple `runPipeline` calls, please read them ",
          "separately and use `mergePipelineResults()`.")
  names(resfiles) <- ds
  lapply(resfiles, readRDS)
}


#' aggregatePipelineResults
#'
#' Aggregates the evaluation and running times of `runPipeline` results. 
#' Results should be indicated either as a `path`` prefix or as a vector of 
#' paths to `evaluation\\.rds` files (`resfiles`).
#'
#' @param res A (named) list of results (per dataset), as produced by 
#' \code{\link{readPipelineResults}} (or `mergePipelineResults`).
#' @param pipDef An optional \code{\link{PipelineDefinition}} containing the 
#' aggregation methods. If omitted, that from the results will be used.
#'
#' @return A list with a slot for each step for which there is an aggregation 
#' method, or (if no aggregation method available) a list of the 
#' `stepIntermediateReturnObjects` of `runPipeline`
#'
#' @import S4Vectors
#' @export
#' @examples
#' # we produce mock pipeline results:
#' pip <- mockPipeline()
#' datasets <- list( ds1=1:3, ds2=c(5,10,15) )
#' tmpdir1 <- paste0(tempdir(),'/')
#' res <- runPipeline(datasets, pipelineDef=pip, output.prefix=tmpdir1,
#'                    alternatives=list() )
#' # we read the evaluation files:
#' res <- readPipelineResults(tmpdir1)
#' # we aggregate the results (equivalent to the output of `runPipeline`):
#' res <- aggregatePipelineResults(res)
aggregatePipelineResults <- function(res, pipDef = NULL) {
  if (length(res) == 2 && all(names(res) == c("evaluation", "elapsed"))) 
    stop("`res` appears to be already aggregated, or the results of a single", 
         " dataset")
  .checkRes(res, requirePDidentity = is.null(pipDef))
  if (is.null(pipDef)) 
    pipDef <- metadata(res[[1]])$PipelineDefinition
  if (is.null(pipDef)) 
    stop("No PipelineDefinition found!")
  
  # aggregating elapsed time
  names(steps) <- steps <- names(res[[1]]$elapsed$stepwise)
  reso <- SimpleList(
    evaluation=NULL, 
    elapsed=list(stepwise=lapply(steps, FUN=function(step){
        .aggElapsed(lapply(res, FUN = function(x) x$elapsed$stepwise[[step]]))
      }),
      total=.aggElapsed(lapply(res, FUN=function(x) x$elapsed$total)))
  )
  metadata(reso)$PipelineDefinition <- pipDef
  
  isn <- vapply(stepFn(pipDef, type = "aggregation"), is.null, logical(1))
  if (all(isn)) {
    warning("No aggregation defined in the pipelineDefinition; returning only",
    " running times.")
    return(reso)
  }
  
  names(isn) <- isn <- names(isn)[!isn]
  res <- lapply(res, FUN = function(x) x$evaluation)
  
  fullnames <- parsePipNames(names(res[[1]][[length(res[[1]])]]))
  reso$evaluation <- lapply(isn, FUN = function(x) {
    message("Aggregating evaluation results for: ", x)
    stepFn(pipDef,type="aggregation")[[x]](lapply(res, FUN=function(y) y[[x]]))
  })
  reso
}

.aggElapsed <- function(res) {
  el.tot <- parsePipNames(names(res[[1]]))
  el.tot <- el.tot[rep(seq_len(nrow(el.tot)), length(res)), , drop = FALSE]
  row.names(el.tot) <- NULL
  el.tot$dataset <- factor(rep(names(res), each = length(res[[1]])))
  el.tot$elapsed <- as.numeric(unlist(res))
  el.tot
}

.checkRes <- function(res1, res2 = NULL, requirePDidentity = TRUE) {
  res1 <- lapply(res1, FUN = function(x) x$evaluation)
  # check that all datasets have the same steps and number of analyses
  if (!all(table(unlist(lapply(res1, names))) == length(res1))) 
    stop("The different datasets were not produced with the same pipeline!")
  for (step in names(res1[[1]])) {
    tt <- table(unlist(lapply(res1, FUN = function(x) names(x[[step]]))))
    if (!all(tt == length(res1))) 
      stop("The different datasets do not have the same runs, i.e. they ",
          "include different sets of alternative parameters.")
  }
  if (!is.null(res2)) {
    .checkRes(res2)
    res2 <- lapply(res2, FUN = function(x) x$evaluation)
    if (names(res1)[[1]] != names(res2)[[1]]) 
      stop("The two sets of results were not produced with the same pipeline.")
    if (is(res1,"SimpleList") && !is.null(metadata(res1)$PipelineDefinition) && 
        is(res2,"SimpleList") && !is.null(metadata(res2)$PipelineDefinition)) {
      # we require that the evaluation functions be the same
      pd1 <- metadata(res1)$PipelineDefinition
      pd2 <- metadata(res2)$PipelineDefinition
      if (!identical( stepFn(pd1, type = "evaluation"),
                      stepFn(pd2, type = "evaluation") )) {
        msg <- paste("The evaluation functions of the PipelineDefinitions are", 
                     "not identical")
        if (requirePDidentity) 
          stop(msg)
        warning(msg)
      }
    }
  }
}

#' mergePipelineResults
#' 
#' Merges the (non-aggregated) results of any number of runs of `runPipeline`
#' using the same \code{\link{PipelineDefinition}} (but on different datasets 
#' and/or using different parameters). First read the different sets of results 
#' using \code{\link{readPipelineResults}}, and pass them to this function.
#' 
#'
#' @param ... Any number of lists of pipeline results, each as produced by 
#' \code{\link{readPipelineResults}}
#' @param rr Alternatively, the pipeline results can be passed as a list (in 
#' which case `...` is ignored)
#' @param verbose Whether to print processing information
#'
#' @return A list of merged pipeline results.
#' @examples
#' # we produce 2 mock pipeline results:
#' pip <- mockPipeline()
#' datasets <- list( ds1=1:3, ds2=c(5,10,15) )
#' tmpdir1 <- paste0(tempdir(),'/')
#' res <- runPipeline(datasets, pipelineDef=pip, output.prefix=tmpdir1,
#'                    alternatives=list() )
#' alternatives <- list(meth1=c('log2','sqrt'), meth2='cumsum')
#' tmpdir2 <- paste0(tempdir(),'/')
#' res <- runPipeline(datasets, alternatives, pip, output.prefix=tmpdir2)
#' # we read the evaluation files:
#' res1 <- readPipelineResults(tmpdir1)
#' res2 <- readPipelineResults(tmpdir2)
#' # we merge them:
#' res <- mergePipelineResults(res1,res2)
#' # and we aggregate:
#' res <- aggregatePipelineResults(res)
#' @export
mergePipelineResults <- function(..., rr=NULL, verbose=TRUE){
  if(is.null(rr)) rr <- list(...)
  if(any(vapply(rr, FUN.VALUE=logical(1L), 
                FUN=function(x) is.null(x[[1]]$evaluation))))
    stop("Some of the objects appear not to be pipeline results.")
  if(is.null(names(rr))) names(rr) <- paste0("res",1:length(rr))
  for(ds in rr) .checkSameSteps(rr)
  .checkSameSteps(lapply(rr, FUN=function(x) x[[1]]))
  if(verbose) print(lapply(rr, FUN=function(res){
    vapply(res, FUN.VALUE=integer(1L), 
           FUN=function(x) length(rev(x$evaluation)[[1]]))}))
  
  # concatenate results
  names(ds) <- ds <- unique(unlist(lapply(rr, names)))
  hasdup <- FALSE
  res <- lapply(ds, FUN=function(dataset){
    r2 <- lapply(rr, FUN=function(x) x[[dataset]])
    r2 <- r2[!vapply(r2,is.null,logical(1L))]
    if(length(r2)==1) return(r2[[1]])
    if(!hasdup){
      rn <- unlist(lapply(r2, FUN=function(x) names(rev(x$evaluation)[[1]])))
      if(any(duplicated(rn))) hasdup <- TRUE
    }
    res <- r2[[1]]
    res$errors <- NULL
    for(i in seq(2,length(r2))){
      x <- setdiff(names(r2[[i]]$elapsed$total), names(res$elapsed$total))
      res$elapsed$total <- c(res$elapsed$total, r2[[i]]$elapsed$total[x])
      for(step in names(res$evaluation)){
        x <- setdiff(names(r2[[i]]$evaluation[[step]]), 
                     names(res$evaluation[[step]]))
        res$evaluation[[step]] <- c(res$evaluation[[step]], 
                                    r2[[i]]$evaluation[[step]][x])
        res$elapsed$stepwise[[step]] <- c(res$elapsed$stepwise[[step]], 
                                          r2[[i]]$elapsed$stepwise[[step]][x])
      }
    }
    res
  })
  rm(rr)
  if(hasdup && verbose) 
    message("Some analyses were redundant across results sets, ",
            "and only the first given was kept.")
  
  # retain only complete parameter sets
  hasmissing <- FALSE
  for(step in names(res[[1]]$evaluation)){
    a <- table(unlist(lapply(res,FUN=function(x) names(x$evaluation[[step]]))))
    if(length(a)>0){
      if(!all(w <- a==length(res))) hasmissing <- TRUE
      a <- sort(names(a)[w])
      if(length(a)==0) stop("No complete parameter set!")
      res <- lapply(res, FUN=function(x){
        x$evaluation[[step]] <- x$evaluation[[step]][a]
        x$elapsed$stepwise[[step]] <- x$elapsed$stepwise[[step]][a]
        if(step==rev(names(x$evaluation))[1])
          x$elapsed$total <- x$elapsed$total[a]
        x
      })
    }
  }
  if(hasmissing && verbose) 
    warning("Some parameter combinations were not available for all datasets ",
            "and were dropped.")
  
  if(verbose) print(list(merged=vapply(res, FUN.VALUE=integer(1L), 
           FUN=function(x) length(rev(x$evaluation)[[1]]))))
  res
}

.checkSameSteps <- function(x, stopifnot=TRUE){
  steps <- table(unlist(lapply(x, FUN=function(x) names(x$evaluation))))
  if(all(steps==length(x))) return(TRUE)
  if(stopifnot) stop("Some datasets have different steps - were then run using",
                      " the same PipelineDefinition?")
  FALSE
}

.dsMergeResults <- function(res1, res2) {
  names(steps) <- steps <- names(res1$evaluation)
  esteps <- vapply(res1$evaluation, FUN = function(x) {
    !is.null(x) && length(x) > 0
  }, logical(1))
  edif <- setdiff(names(res2$elapsed$total), names(res1$elapsed$total))
  res <- SimpleList(evaluation = lapply(steps[esteps], FUN = function(step) {
    r1 <- res1$evaluation[[step]]
    r2 <- res2$evaluation[[step]]
    dif <- setdiff(names(r2), names(r1))
    c(r1, r2[dif])
  }), elapsed = list(stepwise = lapply(steps, FUN = function(step) {
    r1 <- res1$elapsed$stepwise[[step]]
    r2 <- res2$elapsed$stepwise[[step]]
    dif <- setdiff(names(r2), names(r1))
    c(r1, r2[dif])
  }), total = c(res1$elapsed$total, res2$elapsed$total[edif])))
  if (!is.null(metadata(res1)$PipelineDefinition)) {
    metadata(res)$PipelineDefinition <- metadata(res1)$PipelineDefinition
  } else if (!is.null(metadata(res2)$PipelineDefinition)) {
    metadata(res)$PipelineDefinition < metadata(res2)$PipelineDefinition
  }
  res
}

#' defaultStepAggregation
#'
#' @param x A list of results per dataset, each containing a list (1 element 
#' per combination of parameters) of evaluation metrics (coercible to vectors 
#' or matrix).
#'
#' @return A data.frame.
#' @export
#' @importFrom dplyr bind_rows
defaultStepAggregation <- function(x) {
  y <- x[[1]][[1]]
  if (is(y, "list") || is(y, "SimpleList")) {
    res <- lapply(seq_along(y), FUN = function(i) {
      defaultStepAggregation(lapply(x, FUN = function(x) {
        lapply(x, FUN = function(x) x[[i]])
      }))
    })
    names(res) <- names(y)
    return(res)
  }
  dplyr::bind_rows(lapply(x, FUN = function(x) {
    x <- cbind(parsePipNames(names(x)), do.call(rbind, x))
    row.names(x) <- NULL
    x
  }), .id = "dataset")
}

# ==============================================================================
# Author: Anthony Sonrel 
# Email:  anthony.sonrel@uzh.ch
# Created date: -
# ------------------------------------------------------------------------------
# Project: 
#   pipeComp
#
# Description: 
#   Wrapper of data imputation functions, optimized for .rds or .csv files.  
#   Arguments of the wrapper below the function start.
#   Designed to be run locally or on a server (use the correct python/ tool paths!)
#   For scImpute and DCA, the wrapper will create temporary folders for 
#   intermediate results. 
#
#
# ==============================================================================


DoDataImputation <- function(count, 
                             method = c("SAVERX", "scImpute", "enhance", 
                                        "dca",  "DrImpute", 
                                        "alra"),
                             organism = c("auto", "Human", "Mouse"), 
                             out_dir = getwd(), 
                             n_cores = 3L, 
                             enhance_path = NULL, 
                             alra_path = NULL, 
                             alra_norm = FALSE,
                             DrImpute_prepross = TRUE, 
                             dca_path = NULL, 
                             eb_out = "dirichlet",  
                             scImpute_kcluster = NULL, 
                             kcluster_modif = 0, 
                             restr_to_hvgs = FALSE,
                             python_path = '/usr/bin/python3'){
  # count: path to the .rds (SCE) or .csv file containing the dataset to impute on.
  # method: imputation package to use. 
  # organism: can keep 'auto' for the datasets we use in the pipeComp project. Else, please specify if "Human" or "Mouse".
  # out_dir: deprecated, not used for the moment
  # n_cores: number of cores to use for SAVERX, scImpute, DCA. 
  # enhance_path: path to the enhance R script tool, to dl from https://github.com/yanailab/enhance.
  # alra_path: path to the 'alra.R' script, to dl from https://github.com/KlugerLab/ALRA.
  # alra_norm: logical, whether to normalize the data with log counts before imputing with alra (advised in the vignettes but not stated as required).
  # DrImpute_prepross: logical, filter the lowly expressed genes/ cells before running DrImpute (advised in the vignette but not stated as required) ?
  # dca_path: path to the DCA bin. Alternatively, can be simply set to "dca" if the appropriate virtual environment has been set with 'reticulate'. 
  # python_path: to specify if you installed 'sctransfer' on a particular python path
  # kcluster_modif : add or substract the estimated number of cluster by this parameter when using scimpute.
  # python_path: path to python bin, passed to reticulate for SAVERX
  # scImpute_kcluster: integer, number of kcluster expected in the data. Can be set. But by default, is is automatically inferred if a 'sce' if given with a 'phenoid' column in the colData or in the colnames of csv files (warning, suffix numbers are removed as it often use for cell id). 
  
  suppressPackageStartupMessages({
    library(data.table)
    library(SingleCellExperiment)
    library(purrr)
  })
  
  if (all(c("auto", "Human", "Mouse") == organism)) organism <- "auto"
  if (length(method) != 1) stop("Please provide 1 method.")
  
  # SAVERX   ===================================================================
  if (method == "SAVERX") {
    
    if (length(grep("\\.rds$|\\.txt$|\\.csv$|.rds$", count)) != 1) stop("SAVERX needs either a txt, csv or rds file.")
    if (organism == "auto") {
      if (length(grep("Kumar|simMix2", count)) == 1) organism <- "Mouse" else organism <- "Human"
    } 
    
    suppressPackageStartupMessages({
      library(SAVERX)
      library(reticulate)
      reticulate::use_python(python = python_path, required = TRUE)
      library(tensorflow)
      library(keras)
      config <- tf$ConfigProto(intra_op_parallelism_threads = n_cores,
                               inter_op_parallelism_threads = n_cores)
      session = tf$Session(config = config)
      k_set_session(session)
    })
    
 
    if (length(grep("\\.rds$", count)) == 1) {
      
      library(SingleCellExperiment)
      data <- readRDS(count) 
      saveRDS(counts(data), file = "temp.rds")
      
      res <- saverx(input.file.name = "temp.rds", data.species = organism,
                    clearup.python.session = TRUE, ncores = n_cores)
      file.remove("temp.rds")
      
    } else {
      
      res <- saverx(input.file.name = count, data.species = organism,
                    clearup.python.session = TRUE, ncores = n_cores)
      
    }
    
    denois <- readRDS(res) %>% .$estimate
    # file.remove(res, recursive = TRUE)
    # unlink(gsub("\\/.*", "", res), recursive = TRUE)
    cat("If you want to run SAVERX a second time, please restart the R session (open issue of the package).\n")
    
  }
  
  # SCIMPUTE ===================================================================
  
  if (method == "scImpute") {
    
    suppressPackageStartupMessages({
      library("penalized")
      library("scImpute")
    })
    
    rand_suffix <- sample(1:1000000, 1)
    rand_dir <- paste0("temp_scImpute", rand_suffix, "/")
    dir.create(rand_dir)
    
    # file format
    if (length(grep("\\.rds", count)) == 1) {
      
      data <- readRDS(count) 
      if(!"phenoid" %in% colnames(colData(data))) stop("No 'phenoid' in the colData names. Please add it. It should contain the identity of the cells.")
      infile = "rds"
      if (length(scImpute_kcluster) == 0) kcluster <- length(unique(data$phenoid)) else kcluster <- scImpute_kcluster
      
      count <- paste0("temp_scImpute", rand_suffix, ".rds")
      saveRDS(counts(data), file = paste0(rand_dir, count))
      input_dir <- rand_dir
      
    } else if (length(grep("\\.csv", count)) == 1) {
      
      infile <- "csv"
      data <- read.csv(count, row.names = 1) 
      if (length(scImpute_kcluster) == 0) kcluster <- gsub("[0-9]*$", "", colnames(data)) %>% unique(.) %>% length(.) else kcluster <- scImpute_kcluster
      input_dir <- "./"
      
    }
    
    cat(kcluster, "clusters recognized in the input data.")
    
    if (kcluster_modif != 0) {
      
      kcluster <- kcluster + kcluster_modif
      cat("...modified to " , kcluster, "by 'kcluster_modif parameter.\n")
      
    }
    
    library(doParallel)
    scimpute(paste0(input_dir, count), ncores = n_cores, Kcluster = kcluster , 
             out_dir =  paste0(getwd(), "/", rand_dir), infile = infile, outfile = "rds")
    denois <- readRDS(paste0(rand_dir, "scimpute_count.rds"))
    
    # unlink(rand_dir, recursive = TRUE)
    
  }
  
  # ALRA     ===================================================================
  
  if (method == "alra") {
    
    library(rsvd)
    source(alra_path)
    
    if (length(grep("\\.rds", count)) == 1) {
      
      data <- readRDS(count) 
      data <- as.matrix(counts(data))
      
    } else if (length(grep("\\.csv", count)) == 1) {
      
      data <- read.csv(count, row.names = 1) 
      
    }
    
    data <- t(data)
    if (alra_norm) data <- normalize_data(log2(data + 1))
    k_choice <- choose_k(data)
    
    
    denois <- alra(data, k = k_choice$k)[[3]]
    rownames(denois) <- rownames(data)
    if (!all(dim(denois) == dim(data))) stop("Output dims differ from input dims. Please verify!")
    denois <- t(denois)
    
  }

  # DCA ========================================================================

  if (method == "dca") {
    
    if (!is(count, "character")) stop("'dca' needs raw count data in TSV/CSV format as input.")
    
    rand_suffix <- sample(1:1000000, 1)
    temp_file <- paste0("temp_DCA", rand_suffix, ".csv")
    temp_fold <- paste0("temp_DCA", rand_suffix)
    
    if (length(grep("\\.rds", count)) == 1) {
      
      temp <- readRDS(count)
      temp <- counts(temp)
      
      # DCA only accepts integers
      # --> floor the count if decimals
      if (all(colSums(temp) %% 1 == 0) == FALSE) temp <- floor(temp)
      write.csv(as.matrix(temp), file = temp_file, quote = FALSE)
      count <- temp_file
      
    } else {
      
      temp <- read.csv(count, row.names = 1)
      if (all(colSums(temp) %% 1 == 0) == FALSE) temp <- floor(temp)
      write.csv(temp, file = temp_file, quote = FALSE)
      
    }
    
    command <- paste(dca_path, temp_file, temp_fold, "--threads", n_cores)
    
    system(command = command)
    denois <- read.csv(paste0(temp_fold, "/mean.tsv"),sep = "\t", row.names = 1 )
    # unlink(temp_fold, recursive = TRUE)
    # file.remove(temp_file)
    
  }
  
  # ENHANCE ====================================================================
  
  if (method == "enhance") {
    
    cat("Using 'enhance' tool\n")
    source(enhance_path)
    if (length(grep("\\.rds", count)) == 1) {
      
      data <- readRDS(count) 
      data <- as.matrix(counts(data))
      
    } else if (length(grep("\\.csv", count)) == 1) {
      
      data <- read.csv(count, row.names = 1) 
      
    }
    
    denois <- try(enhance(data))
    if(is(denois, "try-error"))  denois <- enhance(data, k_nn = 2)

  }
  
  # DrImpute ===================================================================
  
  if (method == "DrImpute") {
    
    suppressPackageStartupMessages({
      library('DrImpute')
    })
    
    # preprocessign function from DrImpute 
    preprocess <- function(x, min.expressed.gene = 0, min.expressed.cell = 2, max.expressed.ratio = 1, normalize.by.size.effect = FALSE){
      
      if (is(x, 'SummarizedExperiment'))
        X <- assays(x)$count
      else if (is(x,'matrix'))
        X <- x
      else if (is(x, 'sparseMatrix'))
        X <- x
      else
        stop(sprintf('unknown class(x): %s', class(x)))
      
      M <- ncol(X)
      N <- nrow(X)
      m <- Matrix::colSums(X > 1) >= min.expressed.gene	# cells that have at least min.expressed.gene expreseed genes
      n <- Matrix::rowSums(X > 1) <= max.expressed.ratio * M & Matrix::rowSums(X > 1) >= min.expressed.cell	# genes that are detected in at least min.expressed.cell or at most max.expressed.ratio cells
      if (normalize.by.size.effect){
        sf <- apply((X[n, m] + 1) / exp(Matrix::rowMeans(log(X[n, m] + 1))), 2, median)
        X <- t(t(X[n, m]) / sf)
      }else
        X <- X[n, m]
      
      if (is(x, 'SummarizedExperiment')){
        x <- x[n, m]
        assays(x)$count <- X
      }else if (is(x, 'matrix')){
        x <- as.matrix(X)
      }else if (is(x, 'sparseMatrix')){
        x <- X
      }
      
      x
    } # end of preprocess
    
    if (length(grep("\\.rds", count)) == 1) {
      
      data <- readRDS(count)
      data <- counts(data)
      
    } 
    
    if (length(grep("\\.csv", count)) == 1) {
      
      data <- read.csv(count, row.names = 1)
      data <- as.matrix(data)
      
    }
    
    if (DrImpute_prepross == TRUE) X <- preprocess(data, min.expressed.gene = 0) else X <- data    
    Xlog <- log(X + 1)
    denois <- DrImpute(Xlog, mc.cores = n_cores)
    denois <- exp(denois) - 1
    
  }
  
  return(denois)
  
}

#' dea_pipeline
#' 
#' The `PipelineDefinition` for bulk RNAseq differential expression analysis 
#' (DEA).
#' 
#' @return A `PipelineDefinition` object to be used with `runPipeline`.
#' 
#' @export
#' @examples
#' pip <- dea_pipeline()
#' pip
dea_pipeline <- function(){
  # description for each step
  desc <- list( 
    filtering=
paste("Takes a SE object, passes it through the function `filt` (with param",
" `minCount`), and outputs a filtered SE object."),
    sva=
paste("Takes a SE object, passes it through the function `sva.method`, and",
      "returns a SE object."),
    dea=
paste("Takes a SE object, passes it through the function `dea.method`, and",
      "returns a DEA data.frame.")
  )
  
  # functions list
  f <- list(
    filtering=function(x, filt, minCount=10) get(filt)(x, minCount=minCount),
    sva=function(x, sva.method, k=1){ 
      get(sva.method)(x, k=k)
    },
    dea=function(x, dea.method){
      mm <- pipeComp:::.getMM(x)
      x2 <- pipeComp:::.homogenizeDEA(get(dea.method)(x,mm))
      metadata(x2)$truth <- metadata(x)$truth
      metadata(x2)$mm <- mm
      x2
    }
  )
  
  agg <- eva <- lapply(f, FUN=function(x) NULL)
  eva$dea <- evaluateDEA
  agg$dea <- function(res){
    res <- defaultStepAggregation(res)
    lapply( res, FUN=function(x){
      x$sva.method <- gsub("^sva\\.","",x$sva.method)
      x$dea.method <- gsub("^dea\\.","",x$dea.method)
      x
    })
  }

  # default arguments
  def <- list(minCount=10, k=1)

  # initiation function
  initf <- function(x){
    if(is.character(x) && length(x)==1) x <- readRDS(x)
    metadata(x)$truth <- rowData(x)[,c("expected.beta","isDE")]
    cn <- grep("^SV[[:digit:]]+$", colnames(colData(x)), invert=TRUE)
    colData(x) <- colData(x)[,cn,drop=FALSE]
    x
  }

  PipelineDefinition(functions=f, descriptions=desc, evaluation=eva,
                     aggregation=agg, initiation=initf, 
                     defaultArguments=def, verbose=FALSE)
}

#' @importFrom S4Vectors DataFrame
.homogenizeDEA <- function(x, g=NULL){
  colnames(x)[which(colnames(x) %in% c("FDR","padj","adj.P.Val"))] <- "FDR"
  colnames(x)[which(colnames(x) %in% c("P.Value","pvalue","PValue"))] <- "PValue"
  colnames(x)[which(colnames(x) %in% c("log2FoldChange","logFC"))] <- "logFC"
  if(is.null(g)) g <- row.names(x)
  x <- x[g,c("logFC","PValue","FDR")]
  row.names(x) <- g
  if(!is(x,"DataFrame")) x <- DataFrame(x)
  x
}

#' @importFrom stats model.matrix
.getMM <- function(se){
  v <- c( grep("^SV[[:digit:]]+$", colnames(colData(se)), value=TRUE), 
          "condition" )
  f <- as.formula(paste0("~",paste(v,collapse="+")))
  model.matrix(f, data=as.data.frame(colData(se)))
}

---
title: "The scRNA PipelineDefinition"
author:
- name: Pierre-Luc Germain
  affiliation: 
  - &uzh DMLS, University of Zürich
  - D-HEST Institute for Neuroscience, ETH Zürich
- name: Anthony Sonrel
  affiliation: *uzh
- name: Mark D. Robinson
  affiliation: *uzh
package: pipeComp
output:
  BiocStyle::html_document
abstract: |
  A description of the PipelineDefinition for scRNAseq clustering and its evaluation metrics.
vignette: |
  %\VignetteIndexEntry{pipeComp_scRNA}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r, include=FALSE}
library(BiocStyle)
```

# Introduction

This vignette is centered around the application of `r Rpackage("pipeComp")` to scRNA-seq clustering pipelines, and assumes a general understanding of `r Rpackage("pipeComp")` (for an overview, see the [pipeComp vignette](pipeComp.html)).

The scRNAseq `PipelineDefinition` comes in two variants determined by the object used as a backbone, either `r Biocpkg("SingleCellExperiment")` (SCE) or `r Githubpkg("satijalab.org/seurat")` (see `?scrna_pipeline`). Both use the same evaluation metrics, and most method wrappers included in the package have been made so that they are compatible with both. For simplicity, we will therefore stick to just one variant here, and will focus on few very basic comparisons to illustrate the main functionalities, metrics and evaluation plots. For more detailed benchmarks, refer to our preprint:

_pipeComp, a general framework for the evaluation of computational pipelines, reveals performant single-cell RNA-seq preprocessing tools_<br/>
Pierre-Luc Germain, Anthony Sonrel & Mark D Robinson, 
bioRxiv [2020.02.02.930578](https://doi.org/10.1101/2020.02.02.930578)

<br/><br/>

## The PipelineDefinition

The `PipelineDefinition` can be obtained with the following function:

```{r}
library(pipeComp)
# we use the variant of the pipeline used in the paper
pipDef <- scrna_pipeline(pipeClass = "seurat")
pipDef
```

## Example run

To illustrate the use of the pipeline, we will run a basic comparison using wrappers that are included in the package. However, in order for `r Rpackage("pipeComp")` not to systematically require the installation of all dependencies related to all methods for which there are wrappers, they were not included in the package code but rather as source files, which can be loaded in the following way:

```{r}
source(system.file("extdata", "scrna_alternatives.R", package="pipeComp"))
```

(To know which packages are required by the set of wrappers you intend to use, see `?checkPipelinePackages`)

Any function that has been loaded in the environment can then be used as alternative. We define a small set of alternatives to test:

```{r}
alternatives <- list(
  doubletmethod=c("none"),
  filt=c("filt.lenient", "filt.stringent"),
  norm=c("norm.seurat", "norm.sctransform", "norm.scran"),
  sel=c("sel.vst"),
  selnb=2000,
  dr=c("seurat.pca"),
  clustmethod=c("clust.seurat"),
  dims=c(10, 15, 20, 30),
  resolution=c(0.01, 0.1, 0.2, 0.3, 0.5, 0.8, 1, 1.2, 2)
)
```

We also assume three datasets in \Rclass{SingleCellExperiment} (SCE) format (not included in the package - see the last section of this vignette) and run the pipeline:

```{r, eval=FALSE}
# available on https://doi.org/10.6084/m9.figshare.11787210.v1
datasets <- c( mixology10x5cl="/path/to/mixology10x5cl.SCE.rds",
               simMix2="/path/to/simMix2.SCE.rds",
               Zhengmix8eq="/path/to/Zhengmix8eq.SCE.rds" )
# not run
res <- runPipeline( datasets, alternatives, pipDef, nthreads=3)
```

Instead of running the analyses here, we will load the final example results:

```{r}
data("exampleResults", package = "pipeComp")
res <- exampleResults
```

<br/><br/>

# Exploring the metrics

Benchmark metrics are organized according to the step at which they are computed, and will be presented here in this fashion. This does not mean that they are relevant only for that step: alternative parameters at a given step can also be evaluated with respect to the metrics defined in all downstream steps.

## Doublet detection and cell filtering

The evaluation performed after the first two steps (doublet detection and filtering) is the same: 
```{r}
head(res$evaluation$filtering)
```

For each method and subpopulation, we report:

* `N.before` the number of cells before the step
* `N.lost` the number of cells excluded by the step
* `pc.lost` the percentage of cells lost (relative to the supopulation)

As noted in [our manuscript](https://doi.org/10.1101/2020.02.02.930578), stringent filtering can lead to strong bias against certain supopulations. We therefore especially monitor the max `pc.lost` of different methods in relation to the impact on clustering accuracy (privileging, at this step, metrics that are not dependent on the relative abundances of the subpopulations, such as the mean F1 score per subpopulation). This can conveniently be done using the following function:

```{r, fig.width=6, fig.height=2.5}
scrna_evalPlot_filtering(res)
```

## Evaluation based on the reduced space

Evaluations based on the reduced space are much more varied:

```{r}
names(res$evaluation$dimreduction)
```

### Subpopulation silhouette

The `silhouette` slot contains information about the silhouettes width of true subpopulations. Depending on the methods used for dimensionality (i.e. fixed vs estimated number of dimensions), there will be a single output or outputs for different sets of dimensions, as it is the case in our example:

```{r}
names(res$evaluation$dimreduction$silhouette)
```

For each of them we have a data.frame including, for each subpopulation in each analysis (i.e. combination of parameters), the minimum, maximum, median and mean silhouette width:

```{r}
head(res$evaluation$dimreduction$silhouette$top_10_dims)
```

This information can be plotted using the function `scrna_evalPlot_silh`; the function outputs a `r CRANpkg("ComplexHeatmap")`, which means that many arguments of that package and options can be used, for instance:

```{r, fig.width=8.5, fig.height=3}
library(ComplexHeatmap)
scrna_evalPlot_silh( res )
h <- scrna_evalPlot_silh( res, heatmap_legend_param=list(direction="horizontal") )
draw(h, heatmap_legend_side="bottom", annotation_legend_side = "bottom", merge_legend=TRUE)
```

See `?scrna_evalPlot_silh` for more options.

### Variance in the PCs explained by the subpopulations

The slot `varExpl.subpops` indicates, for each analysis, the proportion of variance of each principal component explained by the true supopulations.

```{r}
res$evaluation$dimreduction$varExpl.subpops[1:5,1:15]
```

### Correlation with covariates

The following slots in `res$evaluation$dimreduction` track the correlation between principal components (PCs) and predefined cell-level covariates such as library size and number of detected genes:
* `corr.covariate` contains the pearson correlation between the covariates and each PC; however, since there are major differences in library sizes between subpopulations, we advise against using this directly.
* `meanAbsCorr.covariate2` circumvents this bias by computing the mean absolute correlation (among the first 5 components) for each subpopulation, and averaging them.
* `PC1.covar.adjR2` gives the difference in adjusted _R^2_ between a model fit on PC1 containing the covariate along with subpopulations (PC1~subpopulation+covariate) and one without the covariate (PC1~subpopulation).

These metrics, as well as the following ones, can be plotted using generic `pipeComp` plotting functions, for example:

```{r, fig.width=8, fig.height=3}
evalHeatmap(res, step="dimreduction", what="log10_total_features", 
            what2="meanAbsCorr.covariate2")
```

Since the output of these plotting functions are of class `r CRANpkg("ComplexHeatmap")`, they can be combined:

```{r, eval=FALSE}
evalHeatmap(res, step="dimreduction", what="log10_total_features", 
            what2="meanAbsCorr.covariate2") +
  evalHeatmap(res, step="dimreduction", what="log10_total_counts", 
            what2="meanAbsCorr.covariate2")
```

Alternatively, when the other arguments are shared, the following construction can
also be used:

```{r, fig.width=8, fig.height=3}
evalHeatmap( res, step="dimreduction", what2="meanAbsCorr.covariate2", 
             what=c("log10_total_features","log10_total_counts"), 
             row_title="mean(abs(correlation))\nwith covariate" )
```

We see here for instance that `r Githubpkg("ChristophH/sctransform")` successfully reduces the correlation with covariates, and that `r Biocpkg("scran")` is somewhat in the middle.

## Clustering

### Metrics

We compute several metrics comparing the clustering to the true cell labels:

```{r}
colnames(res$evaluation$clustering)
```

The first columns represent the parameters, while the others are evaluation metrics:

* `n_clus`: the number of clusters produced by the method
* `mean_pr`, `mean_re`, and `mean_F1`: respectively the mean precision, recall and F1 score (harmonic mean of precision and recall) per (true) subpopulation, using the Hungarian algorithm for label matching (see `?match_evaluate_multiple`).
* `min_pr`, `min_re` and `min_F1`: the minimum precision/recall/F1 per (true) subpopulation
* `RI` and `ARI`: the Rand index and adjusted Rand index.
* `MI` and `AMI`: the mutual information and adjusted mutual information, respectively.
* `ID`, `NID`, `VI`, `NVI`: the information difference, variation of information, and their normalized counterparts; these decrease with increasing clustering accuracy. See the `r CRANpkg("aricode")` package for more information.

There is a high redundancy between some of these metrics, and their relationship across a vast number of scRNAseq clusterings is represented here (see [our preprint](https://doi.org/10.1101/2020.02.02.930578) for more detail):

```{r}
data("clustMetricsCorr", package="pipeComp")
ComplexHeatmap::Heatmap(clustMetricsCorr$pearson, name = "Pearson\ncorr")
```

We also included, here, the deviation (`nbClust.diff`) and absolute deviation (`nbClust.absDiff`) from the true number of clusters. This shows that, for instance, most metrics (including the commonly-used ARI) are highly correlated (or anti-correlated) with the absolute deviation from the true number of clusters (`nbClust.absDiff`), making the number of clusters called the primary determinant of the score. Instead, mutual information (MI) is considerably less sensitive to this, but does tend to increase when the number of clusters is increased (positive correlation with `nbClust.diff`). We therefore recommend using a combination of MI, ARI, and ARI at the right number of clusters.

### Plotting

Plotting all combinations is undesirable with the parameters such as resolution, which can take very many values. We therefore need to aggregate by parameters of interest:

```{r, fig.height=3, fig.width=7}
evalHeatmap(res, step="clustering", what=c("MI","ARI"), agg.by=c("filt","norm"))
```

Steps for which there was a single alternative (after aggregation) are not included in the labels. 
We could investigate the joint impact of the normalization method and of the number of dimensions included using:

```{r, fig.width=7, fig.height=4}
evalHeatmap(res, step = "clustering", what=c("MI","ARI"), 
            agg.by=c("norm", "dims"), row_split=norm)
```

Here, we've used the `row_split` argument to improve the clarity of the figure. The argument can accept either the name of a parameter, or any expression using them (e.g. `row_split=norm!="norm.scran"`).

We can also filter the analyses before aggregation. For instance, if we wish to plot the ARI only at the true number of clusters, we can filter to those analyses where the detected number of clusters (`n_clus`) is equal to the true one (`true.nbClusts`):

```{r, fig.width=8.5, fig.height=4}
evalHeatmap(res, step = "clustering", what=c("MI","ARI"), agg.by=c("filt","norm")) +
  evalHeatmap(res, step = "clustering", what="ARI", agg.by=c("filt", "norm"),
              filter=n_clus==true.nbClusts, title="ARI at\ntrue k")
```

Finally, a pipeline-specific plotting function enables overview heatmaps across steps:

```{r, fig.width=8, fig.height=5}
h <- scrna_evalPlot_overall(res)
draw(h, heatmap_legend_side="bottom")
```

## Computing time

There is nothing specific to the scRNAseq pipeline about computing times, but the default `pipeComp` functionalities are available: the timings are accessible in `res$elapsed`, and can be plotted either manually or using:

```{r, fig.width=7, fig.height=3}
plotElapsed(res, agg.by="norm")
```

<br/><br/>

# Extension and reuse

The scRNAseq `PipelineDefinition` can be modified or extented with new steps or arguments like any other objects of that class (see the [pipeComp vignette](pipeComp.html)). For instance, in the paper we included tests on an additional step that filtered out classes of genes, which we implemented in the following way:

```{r}
pipDef <- addPipelineStep(pipDef, "featureExcl", after="filtering")
# once the step has been added, we can set its function:
stepFn(pipDef, "featureExcl", type="function") <- function(x, classes){
  if(classes!="all"){
    classes <- strsplit(classes, ",")[[1]]
    x <- x[subsetFeatureByType(row.names(x), classes=classes),]
  }
  x
}
pipDef
```

Then we can simply add alternatives for this new parameter:
```{r}
alternatives$classes <- c("all","Mt","ribo")
# runPipeline...
```

In addition, the evaluation functions used at each step can be accessed from the package's namespace and use for other purposes. See in particular `?evaluateDimRed` and `?evaluateClustering`. If you feel like other metrics should be included, please contact us!

<br/><br/>

# Datasets

## scRNAseq benchmark datasets used in the paper

The scRNAseq datasets used in the paper can be downloaded from [figshare](https://doi.org/10.6084/m9.figshare.11787210.v1), for instance in the following way:

```{r, eval=FALSE}
download.file("https://ndownloader.figshare.com/articles/11787210/versions/1", "datasets.zip")
unzip("datasets.zip", exdir="datasets")
datasets <- list.files("datasets", pattern="SCE\\.rds", full.names=TRUE)
names(datasets) <- sapply(strsplit(basename(datasets),"\\."),FUN=function(x) x[1])
```

## Using new datasets

In order to use new datasets with this pipeline, you need to have them in `r Biocpkg("SingleCellExperiment")` format, with the true subpopulations stored in the `phenoid` column of `colData`. In addition, if you wish to use some of the wrappers included in the package, some cell- and gene-statistics should be generated using the following function:

```{r, eval=FALSE}
source(system.file("extdata", "scrna_alternatives.R", package="pipeComp"))
sce <- add_meta(sce)
# requires the variancePartition packages installed:
sce <- compute_all_gene_info(sce)
```

---
title: "The pipeComp framework"
author:
- name: Pierre-Luc Germain
  affiliation: University and ETH Zürich
package: pipeComp
output:
  BiocStyle::html_document
abstract: |
  An introduction to the pipeComp package, PipelineDefinitions and basic usage.
vignette: |
  %\VignetteIndexEntry{pipeComp}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r, include=FALSE}
library(BiocStyle)
```

# Introduction

`r Rpackage("pipeComp")` is a simple framework to facilitate the comparison of pipelines involving various steps and parameters. It was initially developed to benchmark single-cell RNA sequencing (scRNAseq) pipelines:

_pipeComp, a general framework for the evaluation of computational pipelines, reveals performant single-cell RNA-seq preprocessing tools_<br/>
Pierre-Luc Germain, Anthony Sonrel & Mark D Robinson, _Genome Biology_ 2020, doi: [10.1186/s13059-020-02136-7](https://doi.org/10.1186/s13059-020-02136-7).

However the framework can be applied to any other context. This vignette introduces the package and framework; for information specifically about the scRNAseq pipeline and evaluation metrics, see the [pipeComp_scRNA](pipeComp_scRNA.html) vignette. For a completely different example, with walkthrough the creating of a new `PipelineDefinition`, see the [pipeComp_dea](pipeComp_dea.html) vignette.

# Installation

Install using:

```{r, eval=FALSE}
BiocManager::install("plger/pipeComp")
```

Because `r Rpackage("pipeComp")` was meant as a general pipeline benchmarking framework, we have tried to restrict the package's dependencies to a minimum. 
To use the scRNA-seq pipeline and wrappers, however, requires further packages to be installed. To check whether these dependencies are met for a given `PipelineDefinition` and set of alternatives, see `?checkPipelinePackages`.

<br/><br/>


# _pipeComp_ overview 

```{r echo = FALSE, fig.cap = "Overview of PipeComp and the PipelineDefinition"}
knitr::include_graphics(system.file('docs', 'pipeComp_scheme.png', package = 'pipeComp'),)
```

`r Rpackage("pipeComp")` is built around the S4 class `PipelineDefinition` which defines a basic abstract workflow with different steps (which can have any number of parameters, including subroutines), as depicted in Figure 1A. When a pipeline is executed, each step is consecutively applied to a starting object. Importantly, the step functions are _not_ related to specific methods, but should be generic, whereas the methods to be compared are passed as _parameters_ (e.g. as the name of wrapper functions defined separately from the pipeline). Often, the step function will simply apply the wrapper to the object and do no more. In addition, each step can optionally have evaluation functions, which take the output of the step as an input, and outputs evaluation metrics. Finally, functions can be specified to aggregate these metrics across multiple datasets (in case the evalation output isn't a data.frame or list of data.frames).

To run a benchmark one in addition needs a set of alternative values to the parameters. For example, alternative values for the parameters depicted in Figure 1 could be defined as follows:

```{r}
library(pipeComp)
alternatives <- list(
  par1=c("function_A", "function_B"),
  par2=1:3,
  par3=TRUE,
  # ...
  parN=c(10,25,50)
)
```

Each parameter (slot of the list) can take any number of alternative scalar values (e.g. character, numeric, logical). The name of functions, like `function_A` and `function_B` (which should be loaded in the environment), can be passed if the `PipelineDefinition` allows it. This means that wrappers should be created for distinct methods, and the name of the wrapper functions passed as alternative parameter values.

Given a `PipelineDefinition`, a list of alternative parameters and a list benchmark datasets, the `runPipeline` (Figure 1B) function proceeds through all combinations arguments, avoiding recomputing the same step (with the same parameters) twice and compiling evaluations on the fly to avoid storing potentially large intermediate data:

```{r, eval=FALSE}
res <- runPipeline(datasets, alternatives, pipelineDef=PipelineDefinition)
```

Aggregated evaluation metrics for each combination of parameters, along with computing times, are returned as \Rclass{SimpleList}s with the following structure:

* res$evaluation (step evaluations)
    + $step1
    + $step2
        - $metric_table_1
        - $metric_table_2
* res$elapsed (running times)
    + $stepwise
        - $step1
        - $step2
    + $total

In addition to the (aggregated) output returned by the function, `runPipeline` will produce at least one RDS file (saved according to the `output.prefix` argument) per dataset: the `*.evaluation.rds` contain the (non-aggregated) evaluation results at each step, while the `.endOutputs.rds` files (assuming `saveEndResults=TRUE`) contain the final output of each combination (i.e. the output of the final step).

The `r Rpackage("pipeComp")` package includes a `PipelineDefinition` for single-cell RNA sequencing (scRNAseq) data. For more information about this application and examples of real outputs, see the [pipeComp_scRNA](pipeComp_scRNA.html) vignette.

<br/><br/>

## Running only a subset of the combinations

Rather than running all possible combinations of parameters, one can run only a subset of them through the `comb` parameter of `runPipeline`. The parameter accepts either a matrix (of argument indices) or data.frame (of factors) which can be built manually, but the simplest way is to first create all combinations, and then get rid of the undesired ones:

```{r}
comb <- buildCombMatrix(alternatives)
head(comb)
```

And then we could remove some combinations before passing the argument to `runPipeline`:

```{r, eval=FALSE}
comb <- comb[ (comb$par1 != "function_A" | comb$par2 == 2) ,]
res <- runPipeline( datasets, alternatives, pipelineDef=PipelineDefinition, 
                    nthreads=3, comb=comb )
```

## Dealing with the PipelineDefinition object

### Creating a PipelineDefinition

The `PipelineDefinition` object is, minimally, a set of functions consecutively executed on the output of the previous one, and optionally accompanied by evaluation and aggregation functions. A simple pipeline can be constructed as follows:

```{r}
my_pip <- PipelineDefinition( list( 
  step1=function(x, param1){
    # do something with x and param1
    x
  },
  step2=function(x, method1, param2){
    get(method1)(x, param2) # apply method1 to x, with param2
  },
  step3=function(x, param3){
    x <- some_fancy_function(x, param3)
    # the functions can also output evaluation through the `intermediate_return` slot:
    e <- my_evaluation_function(x)
    list( x=x, intermediate_return=e)
  }
))
my_pip
```

The `PipelineDefinition` can also include descriptions of each step or evaluation and aggregation functions. For example:
```{r}
my_pip <- PipelineDefinition( 
  list( step1=function(x, meth1){ get(meth1)(x) },
        step2=function(x, meth2){ get(meth2)(x) } ),
  evaluation=list( step2=function(x) c(mean=mean(x), max=max(x)) ),
  description=list( step1="This steps applies meth1 to x.",
                    step2="This steps applies meth2 to x.")
)
my_pip
```

Running it with dummy data and functions:
```{r}
datasets <- list( ds1=1:3, ds2=c(5,10,15))
alternatives <- list(meth1=c("log","sqrt"), meth2="cumsum")
tmpdir1 <- paste0(tempdir(),"/")
res <- runPipeline(datasets, alternatives, my_pip, output.prefix=tmpdir1)
res$evaluation$step2
```

Computing times can be accessed through `res$elapsed`; they can either be accessed as the pipeline total for each combination, or in a step-wise fashion. They can also be plotted using `plotElapsed` (see below). Evaluation results can be accessed through `res$evaluation` and plotted with `evalHeatmap` (see below).

### Manipulating a PipelineDefinition

A number of generic methods are implemented for `PipelineDefinition` objects, including `show`, `names`, `length`, `[`, `as.list`. This means that, for instance, a step can be removed from a pipeline in the following way:

```{r}
my_pip[-1]
```

Steps can be added using the `addPipelineStep` function:
```{r}
pip2 <- addPipelineStep(my_pip, name="newstep", after="step1")
pip2
```

Functions for the new step can be specified through the `slots` argument of `addPipelineStep` or afterwards through `stepFn`:

```{r}
stepFn(pip2, "newstep", type="function") <- function(x, newparam){
  do_something(x, newparam)
}
pip2
```

Finally, the `arguments()` method can be used to extract the arguments for each step, and the `defaultArguments` methods can be used to get or set the default arguments.

<br/><br/>

## Merging results of different _runPipeline_ calls

The previous call to `runPipeline` produced one evaluation file for each dataset:

```{r}
list.files(tmpdir1, pattern="evaluation\\.rds")
```

Their aggregation could be repeated manually by reading those files and calling `aggregatePipelineResults`:

```{r}
ds <- list.files(tmpdir1, pattern="evaluation\\.rds", full.names = TRUE)
names(ds) <- basename(ds)
res1 <- readPipelineResults(resfiles=ds)
res <- aggregatePipelineResults(res1)
```

In addition, the results of different calls to `runPipeline` (with partially different datasets and/or parameter combinations) can be merged together, provided that the `PipelineDefinition` is the same. To illustrate this, we first make another `runPipeline` call using slightly different alternative parameter values:

```{r}
alternatives <- list(meth1=c("log2","sqrt"), meth2="cumsum")
tmpdir2 <- paste0(tempdir(),"/")
res <- runPipeline(datasets, alternatives, my_pip, output.prefix=tmpdir2)
```

We then load the (non-aggregated) results of each run from the files, and merge them using `mergePipelineResults`:
```{r}
res1 <- readPipelineResults(tmpdir1)
res2 <- readPipelineResults(tmpdir2)
res <- mergePipelineResults(res1,res2)
```

We can then aggregate the results as we do for a single run:
```{r}
res <- aggregatePipelineResults(res)
res$evaluation$step2
```

<br/><br/>

## Handling errors

### Debugging

Errors typically come from the method wrappers, and debugging them from within `runPipeline` can be complicated by multithreading. For this reason `runPipeline` wraps additional information around error messages. This would be an example of the error report:

```
Error in dataset `mydataset` with parameters:
filt=lenient, norm=norm.test, k=20
in step `normalization`, evaluating command:
`pipDef[["normalization"]](x = x, norm = "norm.test")`
                Error:
Error in get(norm)(x): not enough cells!
```

The offending dataset, pipeline step and exact set of parameters is reported, enabling you to try to repeat the error outside, where it is easier to debug.

### Skipping errors and fixing them afterwards

A useful behavior is for `runPipeline` to continue when encountering errors, so that successful results are not lost. This behavior can be enabled with the `skipErrors=TRUE` argument. We can illustrate this with our above dummy pipeline, by adding an alternative that is bound to give rise to an error:

```{r}
fragile.fun <- function(x){
  if(any(x>10)) stop("Too big!")
  2^x
}
alternatives$meth1 <- c(alternatives$meth1, "fragile.fun")
res <- runPipeline(datasets, alternatives, my_pip, output.prefix=tmpdir1, skipErrors=TRUE)

```

As indicated in the error message, only the analyses successful across all datasets were aggregated:

```{r}
res$evaluation$step2
```

However, all successful results (e.g. including 'fragile.fun' on 'ds1') were saved in the non-aggregated files. This means that one can then correct the problematic function, re-run only the analyses that failed (i.e. only on 'ds2' in this case), and merge the results with the first batch (see `?mergePipelineResults`).

<br/><br/>

## Plotting results

`r Rpackage("pipeComp")` has two general plotting functions which can be used with any PipelineDefinition: `evalHeatmap` and `plotElapsed`. In addition, the package includes pipeline-specific plotting functions (see the [pipeComp_scRNA](pipeComp_scRNA.html) and [pipeComp_dea](pipeComp_dea.html) vignettes).

### Running times

Running times can be plotted with the `plotElapsed` function:

```{r, fig.width=5, fig.height=2}
plotElapsed(res, agg.by=FALSE)
```

In this case we show all tested combinations, but in most cases the `agg.by` argument will be used to aggregate the results by parameters of interest.

Evaluation results can be plotted through the `evalHeatmap` function:

```{r, fig.width=3.5, fig.height=2.5}
evalHeatmap(res, what=c("mean", "max"))
```

By default, the heatmap prints the actual metric values, while the colors is mapped to scaled data. Specifically, `pipeComp` map colors to the signed square-root of the number of (matrix-wise) Median Absolute Deviations from the (column-wise) median. We found this mapping to be particularly useful because differences in color have comparable meaning across datasets, and the color-scale is not primarily capturing outliers or baseline differences between datasets. This behavior can be changed with the `scale` parameter of the function. For more complex examples of using `evalHeatmap`, see its usage in the [pipeComp_scRNA](pipeComp_scRNA.html) vignette, or refer to the function's help.

<br/><br/>

For a more complex, 'real-life' example of the creation of a `PipelineDefinition`, see the [pipeComp_dea](pipeComp_dea.html) vignette. For a complex example of evaluation outputs, see the [pipeComp_scRNA](pipeComp_scRNA.html) vignette.

---
title: "The DEA PipelineDefinition"
author:
- name: Pierre-Luc Germain
  affiliation: 
  - &uzh DMLS, University of Zürich
  - D-HEST Institute for Neuroscience, ETH Zürich
package: pipeComp
output:
  BiocStyle::html_document
abstract: |
  A description of the PipelineDefinition for the interaction between 
  differential expression analysis and SVA/removal of unwanted variation, used
  as an illustration for the process of building a `PipelineDefinition`.
vignette: |
  %\VignetteIndexEntry{pipeComp_dea}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r, include=FALSE}
library(BiocStyle)
```

This vignette is centered around the application of `r Rpackage("pipeComp")` to (bulk RNAseq) differential expression analysis (DEA) pipelines involving multiple steps, such as pre-filtering and estimation of technical or unwanted vectors of variation. It will illustrate the whole process of guiding the creating of a new `PipelineDefinition` with a real example. The vignette assumes a general understanding of `r Rpackage("pipeComp")` (for an overview, see the [pipeComp vignette](pipeComp.html)).

<br/><br/>

# Introduction

We will create a `PipelineDefinition` which starts with a `r Biocpkg("SummarizedExperiment")` (see below for more specific requirements) and performs three steps: 1) gene filtering, 2) surrogate variable analysis (SVA) or something analogical (e.g. removal of unwanted variation), and 3) differential expression analysis. The output of the first two steps will be a \Rclass{SummarizedExperiment} (filtered, and with the surrogate variables added to \Rclass{SummarizedExperiment}), while the output of the third step will be a differential expression \Rclass{DataFrame}.

We could perform multi-step evaluation, for instance monitoring the genes lost in the filtering step, and the extent to which the SVA-corrected data retains correlation with the technical vectors of variation, but for the sake of simplicity, we will run some evaluation metrics only at the last step.

We will build the `PipelineDefinition` so that the datasets are expected to be \Rclass{SummarizedExperiment} objects with a read counts assay (named 'counts'), a `condition` `colData` factor with two levels, and `rowData` with at least the columns `expected.beta` (expected log2-foldchange) and `isDE` (logical indicating whether the gene is differentially-expressed - NA values are accepted). We've prepared three such datasets described in the results section.

<br/><br/>

# Building the PipelineDefinition object

## Preparing evaluation function

We'll first prepare a function which, given DEA results (as a data.frame), returns evaluation metrics of two kinds: 1) correlation and median absolute error of the estimated foldchanges with respect to the expected ones, and 2) sensitivity, specificity, false discovery rate and such:

```{r}
suppressPackageStartupMessages({
  library(pipeComp)
  library(S4Vectors)
})

evaluateDEA <- function(dea, truth=NULL, th=c(0.01,0.05,0.1)){
  ## we make sure that the column names of `dea` are standard:
  dea <- pipeComp:::.homogenizeDEA(dea)
  ## within Pipecomp, the truth should be passed along with the `dea` object, so
  ## we retrieve it here:
  if(is.null(truth)) truth <- metadata(dea)$truth
  dea <- cbind(dea, truth[row.names(dea),])
  ## we get rid of genes for which the truth is unknown:
  dea <- dea[!is.na(dea$expected.beta),]
  ## comparison of estimated and expected log2 folchanges:
  res <- c(logFC.pearson=cor(dea$logFC, dea$expected.beta, use = "pairwise"),
           logFC.spearman=cor(dea$logFC, dea$expected.beta, 
                              use = "pairwise", method="spearman"),
           logFC.mad=median(abs(dea$logFC-dea$expected.beta),na.rm=TRUE),
           ntested=sum(!is.na(dea$PValue) & !is.na(dea$FDR)))
  ## evaluation of singificance calls
  names(th) <- th
  res2 <- t(vapply( th, FUN.VALUE=vector(mode="numeric", length=6), 
                    FUN=function(x){
    ## for each significance threshold, calculate the various metrics
    called=sum(dea$FDR<x,na.rm=TRUE)
    P <- sum(dea$isDE)
    TP <- sum(dea$FDR<x & dea$isDE, na.rm=TRUE)
    c( TP=TP, FP=called-TP, TPR=TP/P, PPV=TP/called, FDR=1-TP/called, 
       FPR=(P-TP)/sum(!dea$isDE) )
  }))
  res2 <- cbind(threshold=as.numeric(row.names(res2)), as.data.frame(res2))
  row.names(res2) <- NULL
  list(logFC=res, significance=res2)
}
```

The function is included in the `pipeComp` package. It outputs a list with two slots: 1) the `logFC` slot contains a vector of the correlations (pearson, spearman, and MAD) with expected logFCs, and 2) the `significance` slot contains a data.frame of accuracy metrics at different thresholds. We can test it with random data:

```{r}
# we build a random DEA dataframe and truth:
dea <- data.frame( row.names=paste0("gene",1:10), logFC=rnorm(10) )
dea$PValue <- dea$FDR <- c(2:8/100, 0.2, 0.5, 1)
truth <- data.frame( row.names=paste0("gene",1:10), expected.beta=rnorm(10),
                    isDE=rep(c(TRUE,FALSE,TRUE,FALSE), c(3,1,2,4)) )
evaluateDEA(dea, truth)
```



## Assembling the PipelineDefinition

We need to define basic functions for each of the steps, including their possible parameters. 
We begin with the filtering step:

```{r}
step.filtering <- function(x, filt, minCount=10){
  # we apply the function `filt` to `x` with the parameter `minCount`
  get(filt)(x, minCount=minCount)
}
```

This means that any filtering function that we try (i.e., alternative values of `filt`) need to accept, as arguments, both `x` and `minCount`.

Next we define the SVA step in a similar fashion, but here we'll also need the GLM model.matrix:

```{r}
step.sva <- function(x, sva.method, k=1){
  # we create the model.matrix:
  mm <- stats::model.matrix(~condition, data=as.data.frame(colData(x)))
  # we apply the function `sva.method` to `x` with the parameter `k`
  get(sva.method)(x, k=k, mm=mm)
}
```

For the DEA step, we'll do a bit more than just applying a function: to make writing the wrappers for specific methods simpler, we'll create here the GLM model.matrix that includes any eventual surrogate variable (used by all methods). Moreover, since the evaluation function requires the truth, we'll copy it from the \Rclass{SummarizedExperiment} and attach it to the DEA results' metadata:

```{r}
step.dea <- function(x, dea.method){
  # run the DEA method, and transform the results into a DataFrame:
  x2 <- DataFrame(get(dea.method)(x,mm))
  # attach the truth to the results:
  metadata(x2)$truth <- metadata(x)$truth
  x2
}
```

Then we are ready to assemble the `PipelineDefinition`:

```{r}
pip <- PipelineDefinition( list( filtering=step.filtering,
                                          sva=step.sva,
                                          dea=step.dea )
                                    )
pip
```


Finally, we need to add the evaluation function:

```{r}
stepFn(pip, step="dea", type="evaluation") <- evaluateDEA
pip
```

The star indicates that the `dea` step includes some evaluations.

<br/><br/>

# Example run

## Building the wrappers

For each method that we want to test, we need to write a wrapper function which accepts at least the parameters included in the step. Here are example wrappers for each steps:

```{r}
def.filter <- function(x, minCounts=10){
  library(edgeR)
  minCounts <- as.numeric(minCounts)
  x[filterByExpr(assay(x), model.matrix(~x$condition), min.count=minCounts),]
}

sva.svaseq <- function(x, k, mm){
  k <- as.integer(k)
  if(k==0) return(x)
  library(sva)
  # run SVA
  sv <- svaseq(assay(x), mod=mm, n.sv=k)
  if(sv$n.sv==0) return(x)
  # rename the SVs and add them to the colData of `x`:
  colnames(sv$sv) <- paste0("SV", seq_len(ncol(sv$sv)))
  colData(x) <- cbind(colData(x), sv$sv)
  x
}

dea.edgeR <- function(x, mm){
  library(edgeR)
  dds <- calcNormFactors(DGEList(assay(x)))
  dds <- estimateDisp(dds, mm)
  fit <- glmFit(dds, mm)
  as.data.frame(topTags(glmLRT(fit, "condition"), Inf))
}

# we also define a function not doing anything:
none <- function(x, ...) x
```

## Defining the alternative parameter values to test

We define the alternatives for the different parameters (use `arguments(pip)` to see the pipeline's paramters) as a named list:

```{r}
alternatives <- list(
  filt=c("none","def.filter"),
  minCount=10,
  sva.method=c("none","sva.svaseq"),
  k=1:2,
  dea.method="dea.edgeR"
)
```

Each parameter (slot of the list) can take any number of scalar values (e.g. character, numeric, logical). In this case, some of the parameters (`filt`, `sva.method` and `dea.method`) expect the names of functions that must be loaded in the environment. `runPipeline` will then run all combinations of the parameters without repeating the same step twice (alternatively, you can also run [only a subset of the combinations](pipeComp.html#running-only-a-subset-of-the-combinations)).

## Benchmark datasets

We created three benchmark datasets for this purpose:

* **ipsc**: 10 vs 10 random samples from the GSE79636 dataset, which contains heterogeneous samples (background genetic variation, some batch effects). No further technical variation was added, and a foldchange was added on 300 genes.
* **seqc**: 5 vs 5 samples of seqc mixtures C and D respectively, which include two different spike-in mixes. The samples where selected from two batches with technical differences so that there is weak partial correlation with the mixtures (3:2 vs 2:3). Since the true differences between mixtures are not entirely known, the analysis was performed on all genes but only the spike-ins were considered for benchmarking.
* **simulation**: 8 vs 8 samples were simulated using `r Biocpkg("polyester")` and the means/dispersions from the GSE79636 (restricted to a single batch and biological group), with 500 DEGs and two batch effects: 1) a technical batch partially correlated with the group (6:2) and affecting 1/3 of the genes, and 2) a linear vector of technical variation uncorrelated with the groups and affecting 1/3 of the genes.

The datasets are available [here](https://github.com/markrobinsonuzh/scRNA_pipelines_paper/tree/master/svadea/datasets), along with the exact code used to prepare them. They could be loaded in the following way:

```{r, eval=FALSE}
datasets <- list.files("path/to/datasets", pattern="rds$", full.names=TRUE)
names(datasets) <- paste0("dataset",1:2)
datasets <- lapply(datasets, readRDS)
```

Note that, since in this case the datasets are relatively small, we simply load them to pass them to `runPipeline`. However, a better practice with large datasets is to pass a named vector of paths to the files. In this case, we could set an initiation function that reads it through:

```{r, eval=FALSE}
# not run
stepFn(pip, type="initiation") <- function(x){
  if(is.character(x) && length(x)==1) x <- readRDS(x)
  x
}
```

## Running the benchmark

Finally, we can run the benchmark:

```{r, eval=FALSE}
res <- runPipeline( datasets, alternatives, pipelineDef=pip, nthreads=4 )

lapply(res$evaluation$dea, head)
```

```
$logFC
   dataset       filt minCount sva.method k dea.method logFC.pearson logFC.spearman logFC.mad ntested
1 dataset1       none       10       none 1  dea.edgeR     0.6271934      0.6801934 0.2549843      90
2 dataset1       none       10       none 2  dea.edgeR     0.6271934      0.6801934 0.2549843      90
3 dataset1       none       10 sva.svaseq 1  dea.edgeR     0.6287638      0.6725422 0.2814868      90
4 dataset1       none       10 sva.svaseq 2  dea.edgeR     0.6399500      0.6901400 0.2542854      90
5 dataset1 def.filter       10       none 1  dea.edgeR     0.9294525      0.8948433 0.1946729      51
6 dataset1 def.filter       10       none 2  dea.edgeR     0.9294525      0.8948433 0.1946729      51

$significance
   dataset       filt minCount sva.method k dea.method threshold TP FP       TPR       PPV        FDR      FPR
1 dataset1       none       10       none 1  dea.edgeR      0.01 26  1 0.3823529 0.9629630 0.03703704 1.909091
2 dataset1       none       10       none 2  dea.edgeR      0.05 31  2 0.4558824 0.9393939 0.06060606 1.681818
3 dataset1       none       10 sva.svaseq 1  dea.edgeR      0.10 35  5 0.5147059 0.8750000 0.12500000 1.500000
4 dataset1       none       10 sva.svaseq 2  dea.edgeR      0.01 26  1 0.3823529 0.9629630 0.03703704 1.909091
5 dataset1 def.filter       10       none 1  dea.edgeR      0.05 31  2 0.4558824 0.9393939 0.06060606 1.681818
6 dataset1 def.filter       10       none 2  dea.edgeR      0.10 35  5 0.5147059 0.8750000 0.12500000 1.500000
```

The results can easily be plotted directly using for instance `r Rpackage("ggplot2")`, and we've included in `r Rpackage("pipeComp")` some convenience plotting functions (illustrated below). For an overview of the general structure of aggregated pipeline results, see the [main pipeComp vignette](pipeComp.html).

<br/><br/>

## Exploring the results

We ran this pipeline on a more interesting set of alternative methods, and included the results in the package:

```{r}
data("exampleDEAresults", package = "pipeComp")
res <- exampleDEAresults
```

We can use default `pipeComp` plotting methods with these results:

```{r}
plotElapsed(res, agg.by="sva.method")
evalHeatmap( res, what=c("TPR","FDR","logFC.pearson"), 
             agg.by=c("sva.method", "dea.method"), row_split = "sva.method" )
```

The `agg.by` argument let's you control for which of the parameters the values should be shown for each alternative (the values are averaged across the alternatives of other parameters). By default, TRP and FDR are here averaged across the significance thresholds used in the evaluation, but we can filter to use a specific threshold:

```{r}
evalHeatmap( res, what=c("TPR","FDR"), agg.by=c("sva.method", "dea.method"), 
             row_split="sva.method", filterExpr=threshold==0.05 )
```

We see from the previous plots that using SVA-based methods improve the correlation with the expected foldchange as well as the power of the DEA, while ensuring error control (with the exception of RUVr).

We can also represent the accuracy using TPR-FDR curves:
```{r, fig.width=9, fig.height=4}
library(ggplot2)
dea_evalPlot_curve(res, agg.by=c("sva.method","dea.method"), 
                   colourBy="sva.method", shapeBy="dea.method")
dea_evalPlot_curve(res, agg.by=c("sva.method")) + 
  ggtitle("SVA methods, averaging across DEA methods")
```

The three points in the curve indicate the nominal FDR thresholds of 0.01, 0.05 and 0.1 respectively (in the second plot, the filled dots indicate that the observed FDR is below or equal to the nominal FDR).

We can also see that error control is maintained even when increasing the number of surrogate variables:

```{r, fig.height=7, fig.width=5}
evalHeatmap(res, what=c("TPR","FDR"), agg.by=c("sva.method","k"), 
                 show_column_names=TRUE, anno_legend = FALSE, 
                 row_split="sva.method", filterExpr=threshold==0.05 )
```

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/misc.R
\name{farthestPoint}
\alias{farthestPoint}
\title{farthestPoint}
\usage{
farthestPoint(y, x = NULL)
}
\arguments{
\item{y}{Monotonically inscreasing or decreasing values}

\item{x}{Optional x coordinates corresponding to `y` (defaults to seq)}
}
\value{
The value of `x` farthest from the diagonal.
}
\description{
Identifies the point farthest from a line passing through by the first and 
last points. Used for automatization of the elbow method.
}
\examples{
y <- 2^(10:1)
plot(y)
x <- farthestPoint(y)
points(x,y[x],pch=16)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/aggregation.R
\name{defaultStepAggregation}
\alias{defaultStepAggregation}
\title{defaultStepAggregation}
\usage{
defaultStepAggregation(x)
}
\arguments{
\item{x}{A list of results per dataset, each containing a list (1 element 
per combination of parameters) of evaluation metrics (coercible to vectors 
or matrix).}
}
\value{
A data.frame.
}
\description{
defaultStepAggregation
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/evalHeatmap.R
\name{evalHeatmap}
\alias{evalHeatmap}
\title{evalHeatmap}
\usage{
evalHeatmap(
  res,
  step = NULL,
  what,
  what2 = NULL,
  agg.by = NULL,
  agg.fn = mean,
  filterExpr = NULL,
  scale = "colCenterScale",
  value_format = "\%.2f",
  reorder_rows = FALSE,
  show_heatmap_legend = FALSE,
  show_column_names = FALSE,
  col = NULL,
  font_factor = 0.9,
  row_split = NULL,
  shortNames = TRUE,
  value_cols = c("black", "white"),
  title = NULL,
  name = NULL,
  anno_legend = TRUE,
  ...
)
}
\arguments{
\item{res}{Aggregated pipeline results (i.e. the output of `runPipeline` or
`aggregateResults`)}

\item{step}{Name of the step for which to plot the evaluation results. If 
unspecified, will use the latest step that has evaluation results.}

\item{what}{What metric to plot.}

\item{what2}{If the step has more than one benchmark data.frame, which one
to use. The function will attempt to guess that automatically based on 
`what`, and will notify in case of ambiguity.}

\item{agg.by}{Aggregate results by these columns (default no aggregation)}

\item{agg.fn}{Function for aggregation (default mean)}

\item{filterExpr}{An optional filtering expression based on the columns of 
the target dataframe, (e.g. `filterExpr=param1=="value1"`).}

\item{scale}{Controls the scaling of the columns for the color mapping. Can 
either be a logical (TRUE will use NA-safe column z-scores, FALSE will not 
scale) or a function performing the scaling. The default uses the
 `colCenterScale` function (per-column centering, but per-matrix variance
 scaling).}

\item{value_format}{Format for displaying cells' values (use 
`value_format=""` to disable)}

\item{reorder_rows}{Logical; whether to sort rows (default FALSE). The row 
names themselves can also be passed to specify an order, or a 
`ComplexHeatmap`.}

\item{show_heatmap_legend}{Passed to `Heatmap` (default FALSE)}

\item{show_column_names}{Passed to `Heatmap` (default FALSE)}

\item{col}{Colors for the heatmap, or a color-mapping function as produced by
`colorRamp2`. If passing a vector of colors and the data is scaled, there 
should be an odd number of colors. By default, will apply linear mapping (if
the data is not scaled) or signed sqrt mapping (if scaled) on the 
`viridisLite::inferno` palette.}

\item{font_factor}{A scaling factor applied to fontsizes (default 1)}

\item{row_split}{Optional column (included in `agg.by`) by which to split
the rows. Alternatively, an expression using the columns (retained after
aggregation) can be passed.}

\item{shortNames}{Logical; whether to use short row names (with only
the parameter values instead of the parameter name and value pairs), default
TRUE.}

\item{value_cols}{A vector of length 2 indicating the colors of the values
(above and below the mean), if printed}

\item{title}{Plot title}

\item{name}{Heatmap name (e.g. used for the legend)}

\item{anno_legend}{Logical; whether to plot the legend for the datasets}

\item{...}{Passed to `Heatmap`}
}
\value{
A Heatmap
}
\description{
General heatmap representation of aggregated evaluation results. By default,
the actual metric values are printed in the cells, and while the coloring is
determined by \code{\link{colCenterScale}} (number of matrix-median absolute
 deviations from the column means). Unless the total number of analyses is
 small, it is strongly recommended to use the `agg.by` argument to limit the
 size and improve the readability of the heatmap.
}
\examples{
data("exampleResults", package="pipeComp")
evalHeatmap( exampleResults, step="clustering", what=c("ARI","MI","min_pr"), 
             agg.by=c("filt", "norm"), row_split = "norm" ) +
evalHeatmap( exampleResults, step="clustering", what="ARI", 
             agg.by=c("filt", "norm"), filterExpr=n_clus==true.nbClusts, 
             name="ARI at true k", title="ARI at
true K" )
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/dea_evaluationFunctions.R
\name{dea_evalPlot_curve}
\alias{dea_evalPlot_curve}
\title{dea_evalPlot_curve}
\usage{
dea_evalPlot_curve(
  res,
  scales = "free",
  agg.by = NULL,
  agg.fn = mean,
  xlim = c(NA, NA),
  colourBy = "method",
  shapeBy = NULL,
  pointsize = 4
)
}
\arguments{
\item{res}{Aggregated results of the DEA pipeline}

\item{scales}{Passed to `facet_grid`}

\item{agg.by}{Aggregate results by these columns (default no aggregation)}

\item{agg.fn}{Function for aggregation (default mean)}

\item{xlim}{Optional vector of x limits}

\item{colourBy}{Name of column by which to colour}

\item{shapeBy}{Name of column determining the shape of the points. If 
omitted, the shape will indicate whether the nominal FDR is below or equal 
the real FDR.}

\item{pointsize}{Size of the points}
}
\value{
A ggplot.
}
\description{
dea_evalPlot_curve
}
\examples{
data("exampleDEAresults", package="pipeComp")
dea_evalPlot_curve(exampleDEAresults, agg.by=c("sva.method"))
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/misc.R
\name{buildCombMatrix}
\alias{buildCombMatrix}
\title{buildCombMatrix}
\usage{
buildCombMatrix(alt, returnIndexMatrix = FALSE)
}
\arguments{
\item{alt}{A named list of alternative parameter values}

\item{returnIndexMatrix}{Logical; whether to return a matrix of indices, 
rather than a data.frame of factors.}
}
\value{
a matrix or data.frame
}
\description{
Builds a matrix of parameter combinations from a list of alternative values.
}
\examples{
buildCombMatrix(list(param1=LETTERS[1:3], param2=1:2))
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/scrna_evaluationFunctions.R
\name{evaluateNorm}
\alias{evaluateNorm}
\title{evaluateNorm}
\usage{
evaluateNorm(x, clusters = NULL, covars)
}
\arguments{
\item{x}{An object of class 'Seurat' or 'SingleCellExperiment' with 
normalized data}

\item{clusters}{A vector of true cluster identities. If missing, will 
attempt to fetch it from the `phenoid` colData.}

\item{covars}{Covariates to include, either as data.frame or as colData
columns of `x`}
}
\value{
a data.frame.
}
\description{
evaluateNorm
}
\examples{
# random data
library(scater)
sce <- logNormCounts(mockSCE(ngenes = 500))
sce <- addPerCellQC(sce)
# random population labels
sce$cluster <- sample(LETTERS[1:3], ncol(sce), replace=TRUE)
evaluateNorm(sce, sce$cluster, covars="detected")
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/dea_pipeline.R
\name{dea_pipeline}
\alias{dea_pipeline}
\title{dea_pipeline}
\usage{
dea_pipeline()
}
\value{
A `PipelineDefinition` object to be used with `runPipeline`.
}
\description{
The `PipelineDefinition` for bulk RNAseq differential expression analysis 
(DEA).
}
\examples{
pip <- dea_pipeline()
pip
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/scrna_pipeline.R
\name{scrna_pipeline}
\alias{scrna_pipeline}
\title{scrna_pipeline}
\usage{
scrna_pipeline(saveDimRed = FALSE, pipeClass = c("seurat", "sce"))
}
\arguments{
\item{saveDimRed}{Logical; whether to save the dimensionality reduction for 
each analysis (default FALSE)}

\item{pipeClass}{`sce` or `seurat`; which object class to use throughout the
pipeline. Note that the `alternatives` functions have to be built around the
chosen class. Given that, if running the `scrna_alternatives`, the class of 
whole pipeline is determined by the output of the filtering, only this step 
is affected by this option.}
}
\value{
A `PipelineDefinition` object to be used with `runPipeline`.
}
\description{
The `PipelineDefinition` for the default scRNAseq clustering pipeline, with 
steps for doublet identification, filtering, normalization, feature 
selection, dimensionality reduction, and clustering.
Alternative arguments should be character, numeric or logical vectors of
length 1 (e.g. the function name for a method, the number of dimensions, 
etc). The default pipeline has the following steps and arguments:
\itemize{
\item doublet: `doubletmethod` (name of the doublet removal function)
\item filtering: `filt` (name of the filtering function, or filter string)
\item normalization: `norm` (name of the normalization function)
\item selection: `sel` (name of the selection function, or variable of 
rowData on which to select) and `selnb` (number of features to select)
\item dimreduction: `dr` (name of the dimensionality reduction function) and
 `maxdim` (maximum number of components to compute)
\item clustering: `clustmethod` (name of the clustering function), 
`dims` (number of dimensions to use), `k` (number of nearest neighbors to 
use, if applicable), `steps` (number of steps in the random walk, if 
applicable), `resolution` (resolution, if applicable), `min.size` (minimum 
cluster size, if applicable). If using the `scrna_alternatives.R` wrappers, 
the dimensionality can be automatically estimated by specifying 
`dims = "method_name"`. 
}
}
\examples{
pip <- scrna_pipeline()
pip
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plotElapsed.R
\name{plotElapsed}
\alias{plotElapsed}
\title{plotElapsed}
\usage{
plotElapsed(
  res,
  steps = names(res$elapsed$stepwise),
  agg.by,
  agg.fn = mean,
  width = 0.9,
  split.datasets = TRUE,
  return.df = FALSE
)
}
\arguments{
\item{res}{Aggregated pipeline results}

\item{steps}{The step(s) to plot (default all)}

\item{agg.by}{The parameters by which to aggregate (set to FALSE to disable 
aggregation)}

\item{agg.fn}{Aggregation function}

\item{width}{Width of the bar; default 0.9, use 1 to remove the gaps}

\item{split.datasets}{Logical; whether to split the datasets into facets}

\item{return.df}{Logical; whether to return the data.frame instead of plot}
}
\value{
A ggplot, or a data.frame if `return.df=TRUE`
}
\description{
Plot total elapsed time per run, split per step.
}
\examples{
data("exampleResults", package="pipeComp")
plotElapsed(exampleResults, agg.by = "norm")

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/evalHeatmap.R
\name{colCenterScale}
\alias{colCenterScale}
\title{colCenterScale}
\usage{
colCenterScale(
  x,
  centerFn = median,
  scaleFn = function(x, na.rm) median(abs(x), na.rm = na.rm)
)
}
\arguments{
\item{x}{A numeric matrix.}

\item{centerFn}{The function for calculating centers. Should accept the 
`na.rm` argument. E.g. `centerFn=mean` or `centerFn=median`.}

\item{scaleFn}{The function for calculating the (matrix-wise) scaling
factor. Should accept the `na.rm` argument. Default `median(abs(x))`.}
}
\value{
A scaled matrix of the same dimensions as `x`.
}
\description{
Matrix scaling by centering columns separately and then performing variance 
scaling on the whole matrix, in a NA-robust fashion. With the default 
arguments, the output will be the number of (matrix-)median absolute 
deviations from the column-median.
}
\examples{
# random data with column mean differences
d <- cbind(A=rnorm(5, 10, 2), B=rnorm(5, 20, 2), C=rnorm(5,30, 2))
colCenterScale(d)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/runPipeline.R
\docType{package}
\name{pipeComp-package}
\alias{pipeComp-package}
\alias{pipeComp}
\title{pipeComp - a framework for pipeline benchmarking}
\description{
\pkg{pipeComp} is a simple framework to facilitate the comparison of 
pipelines involving various steps and parameters. It was initially developed 
to benchmark single-cell RNA sequencing pipelines, and contains pre-defined
\code{\link{PipelineDefinition}}s and functions to that effect, but could be
applied to any context. See `vignette("pipeComp")` for an introduction.
}
\author{
Pierre-Luc Germain \email{pierre-luc.germain@hest.ethz.ch}

Anthony Sonrel \email{anthony.sonrel@uzh.ch}

Mark D. Robinson \email{mark.robinson@imls.uzh.ch}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\name{exampleResults}
\alias{exampleResults}
\title{Example pipeline results}
\value{
a list.
}
\description{
Example benchmarking results from a scRNAseq pipeline (see vignette 
`pipeComp_scRNA`).
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/dea_evaluationFunctions.R
\name{evaluateDEA}
\alias{evaluateDEA}
\title{evaluateDEA}
\usage{
evaluateDEA(dea, truth = NULL, th = c(0.01, 0.05, 0.1))
}
\arguments{
\item{dea}{Expects a data.frame with logFC and FDR, as produced by 
`edgeR::topTags`, `limma::topTable` or `DESeq2::results`.}

\item{truth}{A data.frame containing the columns `expected.beta` (real logFC)
and `isDE` (logical indicating whether there is a difference or not; accepts
NA values)}

\item{th}{The significance thresholds for which to compute the metrics.}
}
\value{
A list with two slots: `logFC` (vector of metrics on logFC) and 
`significance` table of significance-related statistics.
}
\description{
Evaluates a differential expression analysis (DEA).
}
\examples{
# fake DEA results
dea <- data.frame( row.names=paste0("gene",1:10), logFC=rnorm(10) )
dea$PValue <- dea$FDR <- c(2:8/100, 0.2, 0.5, 1)
truth <- data.frame( row.names=paste0("gene",1:10), expected.beta=rnorm(10),
                     isDE=rep(c(TRUE,FALSE,TRUE,FALSE), c(3,1,2,4)) )
evaluateDEA(dea, truth)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/misc.R
\name{parsePipNames}
\alias{parsePipNames}
\title{parsePipNames}
\usage{
parsePipNames(x, setRowNames = FALSE, addcolumns = NULL)
}
\arguments{
\item{x}{The names to parse, or a data.frame with the names to parse as 
row.names. All names are expected to contain the same parameters.}

\item{setRowNames}{Logical; whether to set original names as row.names of
the output data.frame (default FALSE)}

\item{addcolumns}{An optional data.frame of `length(x)` rows to cbind to the
output.}
}
\value{
A data.frame
}
\description{
Parses the names of analyses performed through `runPipeline` to extract a 
data.frame of parameter values (with decent classes).
}
\examples{
my_names <- c("param1=A;param2=5","param1=B;param2=0")
parsePipNames(my_names)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/misc.R
\name{checkPipelinePackages}
\alias{checkPipelinePackages}
\title{checkPipelinePackages}
\usage{
checkPipelinePackages(alternatives, pipDef = NULL)
}
\arguments{
\item{alternatives}{A named list of alternative parameter values}

\item{pipDef}{An object of class `PipelineDefinition`.}
}
\value{
Logical.
}
\description{
Checks whether the packages required by a pipeline and its alternative 
methods are available.
}
\examples{
checkPipelinePackages(list(argument1="mean"), scrna_pipeline())
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/scrna_plot.R
\name{scrna_evalPlot_overall}
\alias{scrna_evalPlot_overall}
\title{scrna_evalPlot_overall}
\usage{
scrna_evalPlot_overall(
  res,
  agg.by = NULL,
  width = NULL,
  datasets_as_columnNames = TRUE,
  rowAnnoColors = NULL,
  column_names_gp = gpar(fontsize = 10),
  column_title_gp = gpar(fontsize = 12),
  heatmap_legend_param = list(by_row = TRUE, direction = "horizontal", nrow = 1),
  ...
)
}
\arguments{
\item{res}{Aggregated pipeline results (i.e. the output of `runPipeline` or
`aggregateResults`)}

\item{agg.by}{The paramters by which to aggregate.}

\item{width}{The width of individual heatmap bodies.}

\item{datasets_as_columnNames}{Logical; whether dataset names should be 
printed below the columns (except for silhouette) rather than using a
legend.}

\item{rowAnnoColors}{Optional list of colors for the row annotation variables
(passed to `HeatmapAnnotation(col=...)`)}

\item{column_names_gp}{Passed to each calls to `Heatmap`}

\item{column_title_gp}{Passed to each calls to `Heatmap`}

\item{heatmap_legend_param}{Passed to each calls to `Heatmap`}

\item{...}{Passed to each calls to `Heatmap`}
}
\value{
A HeatmapList
}
\description{
Plots a multi-level summary heatmap of many analyses of the `scrna_pipeline`.
}
\examples{
library(ComplexHeatmap)
data("exampleResults")
h <- scrna_evalPlot_overall(exampleResults)
draw(h, heatmap_legend_side="bottom")
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\name{ctrlgenes}
\alias{ctrlgenes}
\title{Lists of control genes}
\value{
a list.
}
\description{
Lists of mouse and human control genes (mitochondrial, ribosomal, 
protein-coding), as ensembl gene ids or official symbols, for computing cell
 QC.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/PipelineDefinition.R
\name{PipelineDefinition}
\alias{PipelineDefinition}
\alias{PipelineDefinition-class}
\title{PipelineDefinition}
\usage{
PipelineDefinition(
  functions,
  descriptions = NULL,
  evaluation = NULL,
  aggregation = NULL,
  initiation = identity,
  defaultArguments = list(),
  misc = list(),
  verbose = TRUE
)
}
\arguments{
\item{functions}{A list of functions for each step}

\item{descriptions}{A list of descriptions for each step}

\item{evaluation}{A list of optional evaluation functions for each step}

\item{aggregation}{A list of optional aggregation functions for each step}

\item{initiation}{A function ran when initiating a dataset}

\item{defaultArguments}{A lsit of optional default arguments}

\item{misc}{A list of whatever.}

\item{verbose}{Whether to output additional warnings (default TRUE).}
}
\value{
An object of class `PipelineDefinition`, with the slots functions,
descriptions, evaluation, aggregation, defaultArguments, and misc.
}
\description{
Creates on object of class `PipelineDefinition` containing step functions,
as well as optionally step evaluation and aggregation functions.
}
\examples{
PipelineDefinition(
  list( step1=function(x, meth1){ get(meth1)(x) },
        step2=function(x, meth2){ get(meth2)(x) } )
)
}
\seealso{
\code{\link{PipelineDefinition-methods}}, 
\code{\link{addPipelineStep}}. For an example pipeline, see 
\code{\link{scrna_pipeline}}.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/scrna_evaluationFunctions.R
\name{match_evaluate_multiple}
\alias{match_evaluate_multiple}
\title{match_evaluate_multiple}
\usage{
match_evaluate_multiple(clus_algorithm, clus_truth = NULL)
}
\arguments{
\item{clus_algorithm}{cluster labels from algorithm}

\item{clus_truth}{true cluster labels. If NULL, will attempt to read them 
from the names of `clus_algorithm` (expecting the format 
`clusterName.cellName`)}
}
\value{
A list.
}
\description{
Function to match cluster labels with 'true' clusters using the Hungarian 
algorithm, and return precision, recall, and F1 score. Written by Lukas 
Weber in August 2016 as part of his 
\href{https://github.com/lmweber/cytometry-clustering-comparison}{cytometry
clustering comparison}, with just slight modifications on initial handling 
of input arguments.
}
\examples{
# random data
dat <- data.frame( 
 cluster=rep(LETTERS[1:3], each=10),
 x=c(rnorm(20, 0), rnorm(10, 1)),
 y=c(rnorm(10, 1), rnorm(20, 0))
)
# clustering
dat$predicted <- kmeans(dist(dat[,-1]),3)$cluster
# evaluation
match_evaluate_multiple(dat$predicted, dat$cluster)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/scrna_plot.R
\name{scrna_evalPlot_filtering}
\alias{scrna_evalPlot_filtering}
\title{scrna_evalPlot_filtering}
\usage{
scrna_evalPlot_filtering(
  res,
  steps = c("doublet", "filtering"),
  clustMetric = "mean_F1",
  filterExpr = TRUE,
  atNearestK = FALSE,
  returnTable = FALSE,
  point.size = 2.2,
  ...
)
}
\arguments{
\item{res}{Aggregated pipeline results (i.e. the output of `runPipeline` or
`aggregateResults`)}

\item{steps}{Steps to include (default 'doublet' and 'filtering'); other 
steps will be averaged.}

\item{clustMetric}{Clustering accuracy metric to use (default `mean_F1``)}

\item{filterExpr}{An optional filtering expression based on the columns of 
the clustering evaluation (e.g. `filterExpr=param1=="value1"` or 
`filterExpr=n_clus==true.nbClusts`).}

\item{atNearestK}{Logical; whether to restrict analyses to those giving the 
smallest deviation from the real number of clusters (default FALSE).}

\item{returnTable}{Logical; whether to return the data rather than plot.}

\item{point.size}{Size of the points}

\item{...}{passed to `geom_point`}
}
\value{
A ggplot, or a data.frame if `returnTable=TRUE`
}
\description{
scrna_evalPlot_filtering
}
\examples{
data("exampleResults", package="pipeComp")
scrna_evalPlot_filtering(exampleResults)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/scrna_utils.R
\name{getDimensionality}
\alias{getDimensionality}
\title{getDimensionality}
\usage{
getDimensionality(dat, method, maxDims = NULL)
}
\arguments{
\item{dat}{A Seurat or SCE object with a pca embedding.}

\item{method}{The dimensionality method to use.}

\item{maxDims}{Deprecated and ignored.}
}
\value{
An integer.
}
\description{
Returns the estimated intrinsic dimensionality of a dataset.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/misc.R
\name{getQualitativePalette}
\alias{getQualitativePalette}
\title{getQualitativePalette}
\usage{
getQualitativePalette(nbcolors)
}
\arguments{
\item{nbcolors}{A positive integer indicating the number of colors}
}
\value{
A vector of colors
}
\description{
Returns a qualitative color palette of the given size. If less than 23 colors
 are required, the colors are based on Paul Tol's palettes. If more, the 
 `randomcoloR` package is used.
}
\examples{
getQualitativePalette(5)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/runPipeline.R
\name{runPipeline}
\alias{runPipeline}
\title{runPipeline}
\usage{
runPipeline(
  datasets,
  alternatives,
  pipelineDef,
  comb = NULL,
  output.prefix = "",
  nthreads = 1,
  saveEndResults = TRUE,
  debug = FALSE,
  skipErrors = TRUE,
  ...
)
}
\arguments{
\item{datasets}{A named vector of initial objects or paths to rds files.}

\item{alternatives}{The (named) list of alternative values for each 
parameter.}

\item{pipelineDef}{An object of class \code{\link{PipelineDefinition}}.}

\item{comb}{An optional matrix of indexes indicating the combination to run. 
Each column should correspond to an element of `alternatives`, and contain 
indexes relative to this element. If omitted, all combinations will be 
performed.}

\item{output.prefix}{An optional prefix for the output files.}

\item{nthreads}{Number of threads, default 1. If the memory requirements are
very high or the first steps very long to compute, consider setting this as
the number of datasets or below.}

\item{saveEndResults}{Logical; whether to save the output of the last step.}

\item{debug}{Logical (default FALSE). When enabled, disables multithreading 
and prints extra information.}

\item{skipErrors}{Logical. When enabled, `runPipeline` will
continue even when an error has been encountered, and report the list of 
steps/datasets in which errors were encountered.}

\item{...}{passed to MulticoreParam. Can for instance be used to set 
`makeCluster` arguments, or set `threshold="TRACE"` when debugging in a 
multithreaded context.}
}
\value{
A SimpleList with elapsed time and the results of the evaluation 
functions defined by the given `pipelineDef`.

The results are also stored in the output folder with: 
\itemize{
\item The clustering results for each dataset (`endOutputs.rds` files),
\item A SimpletList of elapsed time and evaluations for each dataset 
 (`evaluation.rds` files),
\item A list of the `pipelineDef`, `alternatives`, `sessionInfo()` and
 function call used to produce the results (`runPipelineInfo.rds` file),
\item A copy of the SimpleList returned by the function 
 (`aggregated.rds`file). 
}
}
\description{
This function runs a pipeline with combinations of parameter variations on 
nested steps. The pipeline has to be defined as a list of functions applied 
consecutively on their respective outputs. See 'examples' for more details.
}
\examples{
pip <- mockPipeline()
datasets <- list( ds1=1:3, ds2=c(5,10,15) )
tmpdir1 <- paste0(tempdir(),"/")
res <- runPipeline(datasets, pipelineDef=pip, output.prefix=tmpdir1,
                   alternatives=list() )
# See the `pipeComp_scRNA` vignette for a more complex example

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/scrna_plot.R
\name{scrna_evalPlot_silh}
\alias{scrna_evalPlot_silh}
\title{scrna_evalPlot_silh}
\usage{
scrna_evalPlot_silh(
  res,
  what = c("minSilWidth", "meanSilWidth"),
  step = "dimreduction",
  dims = 1,
  agg.by = NULL,
  agg.fn = mean,
  filterExpr = NULL,
  value_format = "",
  reorder_rows = FALSE,
  reorder_columns = TRUE,
  show_heatmap_legend = TRUE,
  show_column_names = FALSE,
  col = rev(RColorBrewer::brewer.pal(n = 11, "RdBu")),
  font_factor = 0.9,
  row_split = NULL,
  shortNames = TRUE,
  value_cols = c("white", "black"),
  title = NULL,
  anno_legend = TRUE,
  ...
)
}
\arguments{
\item{res}{Aggregated pipeline results (i.e. the output of `runPipeline` or
`aggregateResults`)}

\item{what}{What metric to plot, possible values are “minSilWidth”, 
“meanSilWidth” (default), “medianSilWidth”, or “maxSilWidth”.}

\item{step}{Name of the step for which to plot the evaluation results. 
Defaults to "dimreduction".}

\item{dims}{If multiple sets of dimensions are available, which one to use
(defaults to the first).}

\item{agg.by}{Aggregate results by these columns (default no aggregation)}

\item{agg.fn}{Function for aggregation (default mean)}

\item{filterExpr}{An optional filtering expression based on the columns of 
the target dataframe, (e.g. `filterExpr=param1=="value1"`).}

\item{value_format}{Format for displaying cells' values (no label by default)}

\item{reorder_rows}{Whether to sort rows (default FALSE). The row 
names themselves can also be passed to specify an order, or a 
`ComplexHeatmap`.}

\item{reorder_columns}{Whether to sort columns (default TRUE).}

\item{show_heatmap_legend}{Passed to `Heatmap` (default FALSE)}

\item{show_column_names}{Passed to `Heatmap` (default FALSE)}

\item{col}{Colors for the heatmap}

\item{font_factor}{A scaling factor applied to fontsizes (default 1)}

\item{row_split}{Optional column (included in `agg.by`) by which to split
the rows. Alternatively, an expression using the columns (retained after
aggregation) can be passed.}

\item{shortNames}{Logical; whether to use short row names (with only
the parameter values instead of the parameter name and value pairs), default
TRUE.}

\item{value_cols}{A vector of length 2 indicating the colors of the values
(above and below the mean), if printed}

\item{title}{Plot title}

\item{anno_legend}{Logical; whether to plot the legend for the datasets}

\item{...}{Passed to `Heatmap`}
}
\value{
A Heatmap
}
\description{
Plot a min/max/mean/median silhouette width heatmap from aggregated 
evaluation results of the `scrna_pipeline`.
}
\examples{
data("exampleResults", package="pipeComp")
scrna_evalPlot_silh( exampleResults, agg.by=c("filt","norm"), 
                     row_split="norm" )
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/aggregation.R
\name{mergePipelineResults}
\alias{mergePipelineResults}
\title{mergePipelineResults}
\usage{
mergePipelineResults(..., rr = NULL, verbose = TRUE)
}
\arguments{
\item{...}{Any number of lists of pipeline results, each as produced by 
\code{\link{readPipelineResults}}}

\item{rr}{Alternatively, the pipeline results can be passed as a list (in 
which case `...` is ignored)}

\item{verbose}{Whether to print processing information}
}
\value{
A list of merged pipeline results.
}
\description{
Merges the (non-aggregated) results of any number of runs of `runPipeline`
using the same \code{\link{PipelineDefinition}} (but on different datasets 
and/or using different parameters). First read the different sets of results 
using \code{\link{readPipelineResults}}, and pass them to this function.
}
\examples{
# we produce 2 mock pipeline results:
pip <- mockPipeline()
datasets <- list( ds1=1:3, ds2=c(5,10,15) )
tmpdir1 <- paste0(tempdir(),'/')
res <- runPipeline(datasets, pipelineDef=pip, output.prefix=tmpdir1,
                   alternatives=list() )
alternatives <- list(meth1=c('log2','sqrt'), meth2='cumsum')
tmpdir2 <- paste0(tempdir(),'/')
res <- runPipeline(datasets, alternatives, pip, output.prefix=tmpdir2)
# we read the evaluation files:
res1 <- readPipelineResults(tmpdir1)
res2 <- readPipelineResults(tmpdir2)
# we merge them:
res <- mergePipelineResults(res1,res2)
# and we aggregate:
res <- aggregatePipelineResults(res)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\name{stableG}
\alias{stableG}
\title{Lists of stable genes}
\value{
a list.
}
\description{
Genes were simply obtained by querying the respective GO terms
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\name{clustMetricsCorr}
\alias{clustMetricsCorr}
\title{Correlations across clustering evaluation metrics}
\value{
a list.
}
\description{
A list of two matrices containing, respectively, the Pearson and Spearman
pairwise correlations between various clustering evalution metrics, computed
across a wide range of scRNAseq clustering analyses (see reference).
}
\references{
See https://doi.org/10.1101/2020.02.02.930578
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/scrna_plot.R
\name{scrna_describeDatasets}
\alias{scrna_describeDatasets}
\title{scrna_describeDatasets}
\usage{
scrna_describeDatasets(sces, pt.size = 0.3, ...)
}
\arguments{
\item{sces}{A character vector of paths to SCE rds files, or a list of SCEs}

\item{pt.size}{Point size (for reduced dims)}

\item{...}{Passed to geom_point()}
}
\value{
A plot_grid output
}
\description{
Plots descriptive information about the datasets
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/PipelineDefinition.R
\name{addPipelineStep}
\alias{addPipelineStep}
\title{addPipelineStep}
\usage{
addPipelineStep(object, name, after = NULL, slots = list())
}
\arguments{
\item{object}{A \code{\link{PipelineDefinition}}}

\item{name}{The name of the step to add}

\item{after}{The name of the step after which to add the new step. If NULL,
will add the step at the beginning of the pipeline.}

\item{slots}{A optional named list with slots to fill for that step (i.e. 
`functions`, `evaluation`, `aggregation`, `descriptions` - will be parsed)}
}
\value{
A \code{\link{PipelineDefinition}}
}
\description{
Add a step to an existing \code{\link{PipelineDefinition}}
}
\examples{
pd <- mockPipeline()
pd
pd <- addPipelineStep(pd, name="newstep", after="step1", 
                      slots=list(description="Step that does nothing..."))
pd
}
\seealso{
\code{\link{PipelineDefinition}}, 
\code{\link{PipelineDefinition-methods}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\name{exampleDEAresults}
\alias{exampleDEAresults}
\title{Example results from the DEA pipeline}
\value{
a list.
}
\description{
Example benchmarking results from a DEA pipeline (see vignette 
`pipeComp_dea`).
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/aggregation.R
\name{aggregatePipelineResults}
\alias{aggregatePipelineResults}
\title{aggregatePipelineResults}
\usage{
aggregatePipelineResults(res, pipDef = NULL)
}
\arguments{
\item{res}{A (named) list of results (per dataset), as produced by 
\code{\link{readPipelineResults}} (or `mergePipelineResults`).}

\item{pipDef}{An optional \code{\link{PipelineDefinition}} containing the 
aggregation methods. If omitted, that from the results will be used.}
}
\value{
A list with a slot for each step for which there is an aggregation 
method, or (if no aggregation method available) a list of the 
`stepIntermediateReturnObjects` of `runPipeline`
}
\description{
Aggregates the evaluation and running times of `runPipeline` results. 
Results should be indicated either as a `path`` prefix or as a vector of 
paths to `evaluation\\.rds` files (`resfiles`).
}
\examples{
# we produce mock pipeline results:
pip <- mockPipeline()
datasets <- list( ds1=1:3, ds2=c(5,10,15) )
tmpdir1 <- paste0(tempdir(),'/')
res <- runPipeline(datasets, pipelineDef=pip, output.prefix=tmpdir1,
                   alternatives=list() )
# we read the evaluation files:
res <- readPipelineResults(tmpdir1)
# we aggregate the results (equivalent to the output of `runPipeline`):
res <- aggregatePipelineResults(res)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/scrna_evaluationFunctions.R
\name{evaluateDimRed}
\alias{evaluateDimRed}
\title{evaluateDimRed}
\usage{
evaluateDimRed(x, clusters = NULL, n = c(10, 20, 50), covars)
}
\arguments{
\item{x}{The matrix of the reduced space, with cells as rows and components 
as columns}

\item{clusters}{The vector indicating each cell's cluster.}

\item{n}{A numeric vector indiciating the number of top dimensions at which 
to gather statistics (default `c(10,20,50)`). Will use all available 
dimensions if a higher number is given.}

\item{covars}{A character vectors containing any additional covariates 
(column names of `colData`) to track during evalutation. If missing, will
attempt to use default covariates. To disable, set `covars=c()`.}
}
\value{
A list with the following components:
* silhouettes: a matrix of the silhouette for each cell-cluster pair at each 
value of `n`
* clust.avg.silwidth: a matrix of the cluster average width at each value of 
`n`
* R2: the proportion of variance in each component (up to `max(n)`) that is 
explained by the clusters (i.e. R-squared of a linear model).
}
\description{
Gathers evaluation statistics on a reduced space using known cell labels.
If using `evaluteDimRed` in a custom pipeline, you will probably want to use
`pipeComp:::.aggregateDR` as the corresponding aggregation function.
}
\examples{
# random data
library(scater)
sce <- runPCA(logNormCounts(mockSCE(ngenes = 500)))
sce <- addPerCellQC(sce)
# random population labels
sce$cluster <- sample(LETTERS[1:3], ncol(sce), replace=TRUE)
res <- evaluateDimRed(sce, sce$cluster, covars=c("sum","detected"))
# average silhouette widths:
res$clust.avg.silwidth
# adjusted R2 of covariates:
res$covar.adjR2
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/PipelineDefinition.R
\name{PipelineDefinition-methods}
\alias{PipelineDefinition-methods}
\alias{PipelineDefinition-method}
\alias{show,PipelineDefinition-method}
\alias{names,PipelineDefinition-method}
\alias{names<-,PipelineDefinition-method}
\alias{$,PipelineDefinition-method}
\alias{length,PipelineDefinition-method}
\alias{[,PipelineDefinition,ANY,ANY,ANY-method}
\alias{as.list,PipelineDefinition-method}
\alias{arguments}
\alias{arguments,PipelineDefinition-method}
\alias{defaultArguments}
\alias{defaultArguments<-}
\alias{defaultArguments,PipelineDefinition-method}
\alias{defaultArguments<-,PipelineDefinition-method}
\alias{stepFn}
\alias{stepFn,PipelineDefinition-method}
\alias{stepFn<-}
\alias{stepFn<-,PipelineDefinition-method}
\title{Methods for \code{\link{PipelineDefinition}} class}
\usage{
\S4method{show}{PipelineDefinition}(object)

\S4method{names}{PipelineDefinition}(x)

\S4method{names}{PipelineDefinition}(x) <- value

\S4method{$}{PipelineDefinition}(x, name)

\S4method{length}{PipelineDefinition}(x)

\S4method{[}{PipelineDefinition,ANY,ANY,ANY}(x, i)

\S4method{as.list}{PipelineDefinition}(x)

arguments(object)

\S4method{arguments}{PipelineDefinition}(object)

defaultArguments(object)

defaultArguments(object) <- value

\S4method{defaultArguments}{PipelineDefinition}(object)

\S4method{defaultArguments}{PipelineDefinition}(object) <- value

stepFn(object, step = NULL, type)

\S4method{stepFn}{PipelineDefinition}(object, step = NULL, type)

stepFn(object, step, type) <- value

\S4method{stepFn}{PipelineDefinition}(object, step, type) <- value
}
\arguments{
\item{object}{An object of class \code{\link{PipelineDefinition}}}

\item{x}{An object of class \code{\link{PipelineDefinition}}}

\item{value}{Replacement values}

\item{name}{The step name}

\item{i}{The index(es) of the steps}

\item{step}{The name of the step for which to set or get the function}

\item{type}{The type of function to set/get, either `functions`, 
`evaluation`, `aggregation`, `descriptions`, or `initiation` (will parse 
partial matches)}
}
\value{
Depends on the method.
}
\description{
Methods for \code{\link{PipelineDefinition}} class

get names of PipelineDefinition steps

set names of PipelineDefinition steps
}
\examples{
pd <- mockPipeline()
length(pd)
names(pd)
pd$step1
pd[2:1]
}
\seealso{
\code{\link{PipelineDefinition}}, \code{\link{addPipelineStep}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/PipelineDefinition.R
\name{mockPipeline}
\alias{mockPipeline}
\title{mockPipeline}
\usage{
mockPipeline()
}
\value{
a `PipelineDefinition`
}
\description{
A mock `PipelineDefinition` for use in examples.
}
\examples{
mockPipeline()
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/scrna_evaluationFunctions.R
\name{evaluateClustering}
\alias{evaluateClustering}
\title{evaluateClustering}
\usage{
evaluateClustering(x, tl = NULL)
}
\arguments{
\item{x}{The clustering labels}

\item{tl}{The true labels}
}
\value{
A numeric vector of metrics (see the `pipeComp_scRNA` vignette for 
details)
}
\description{
Evaluates a clustering using 'true' labels. Entries with missing true labels
(i.e. NA) are excluded from calculations. If using `evaluteClustering` in a
custom pipeline, you might want to use the corresponding 
`pipeComp:::.aggregateClusterEvaluation` aggregation function.
}
\examples{
# random data
dat <- data.frame( 
 cluster=rep(LETTERS[1:3], each=10),
 x=c(rnorm(20, 0), rnorm(10, 1)),
 y=c(rnorm(10, 1), rnorm(20, 0))
)
# clustering
dat$predicted <- kmeans(dist(dat[,-1]),3)$cluster
# evaluation
evaluateClustering(dat$predicted, dat$cluster)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/aggregation.R
\name{readPipelineResults}
\alias{readPipelineResults}
\title{readPipelineResults}
\usage{
readPipelineResults(path = NULL, resfiles = NULL)
}
\arguments{
\item{path}{The path (e.g. folder or prefix) to the results. Either `path` 
or `resfiles` should be given.}

\item{resfiles}{A vector of paths to `*.evaluation.rds` files. Either `path` 
or `resfiles` should be given.}
}
\value{
A list of results.
}
\description{
readPipelineResults
}
\examples{
# we produce mock pipeline results:
pip <- mockPipeline()
datasets <- list( ds1=1:3, ds2=c(5,10,15) )
tmpdir1 <- paste0(tempdir(),'/')
res <- runPipeline(datasets, pipelineDef=pip, output.prefix=tmpdir1,
                   alternatives=list() )
# we read the evaluation files:
res <- readPipelineResults(tmpdir1)
}
